  
   'Problema PI-5A
 
   'Valuacin de la serie infinita (x)=1/(k(k+x)), k= 1, 2, ...
        
             'Versin 1.0 (creado por J. Antonio Ruiz G., 1993)
  
   DECLARE SUB enrolla ()
   DECLARE SUB fin ()
   DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
  
   'Se invoca la subrutina que despliega una cortina de presentacin
     CALL enrolla
  
   'Se designa el color del monitor
     COLOR 7, 9, 9
     CLS
  
   'Letrero
     COLOR 15
       LOCATE 3, 16: PRINT "VALUACION  DE  LA  SERIE  INFINITA  (x)=1/(k(k+x))"
     COLOR 7, 9
  
   'Se invoca a la subrutina que genera un marco
     CALL marco(2, 4, 2, 79, 10, 7)
     CALL marco(8, 21, 16, 66, 12, 7)
   
   'Clculos
     COLOR 31
       LOCATE 7, 32: PRINT "EFECTUANDO CALCULOS"
       COLOR 15
         LOCATE 9, 23: PRINT "X      (X)   ITERACIONES  TIEMPO [SEG]"
     COLOR 7
  
   'Nmero mximo propuesto de iteraciones (ITE)
     ITE = 10000
 
   'Tolerancia de 0.5E-08
     TOL = 5E-09
  
   'Variable para contabilizar tiempo
     TIMETOT = 0
 
   'Se inicia el proceso (el cual finaliza cuando se cumple la tolerancia
   'para cada valor de X), de X=0 a 1.0, con incrementos de 0.1
    
     FOR X = 0 TO 1.1 STEP .1#
     
         'Se inicializan variables
          k = 0
          B = 0
          C = 0
   
         'Contador de tiempo
          H = TIMER
     
         'Inicia ciclo iterativo
          DO
            k = k + 1
            A = 1 / (k * (k + X))
            B = A + B
        
            'Verificacin de tolerancia
              IF ABS(B - C) <= TOL THEN
                 H2 = TIMER
                 TIMEAUX = H2 - H
                 TIMETOT = TIMETOT + TIMEAUX
                 'Despliegue de resultados
                   cont = cont + 1
                   LOCATE 9 + cont, 22
                   PRINT USING "#.#   #.######     ####        ##.##"; X; B; k; TIMEAUX
                 'Salida del ciclo
                 EXIT DO
              END IF
          
            C = B
        
            'Verificacin del nm. de iteraciones
              IF k > ITE THEN
                 BEEP
                 LOCATE 10, 23: PRINT "NUMERO DE ITERACIONES INSUFICIENTE"
                 LOCATE 11, 23: PRINT "VALOR ANTERIOR = "; ITE
                 LOCATE 12, 23: INPUT "NUEVO VALOR "; ITE
                 FOR II = 1 TO 4
                   LOCATE 9 + II, 22: PRINT "                                   "
                 NEXT
                 'Se reinicializan variables
                  k = 0
                  B = 0
                  C = 0
              END IF
          LOOP
 
     NEXT X
     LOCATE 7, 29:  PRINT USING "& ##.## &"; "TIEMPO TOTAL:"; TIMETOT; "SEG"
   
    'Se invoca a la subrutina para finalizar la sesin
      CALL fin

   

SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
  
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
  
   'Letreros
     COLOR 0, 3
       LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
       LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
       LOCATE 14, 34: PRINT "EJEMPLO PI-5A"
       LOCATE 18, 25: PRINT "EJEMPLO RESUELTO DEL CAPITULO I"
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
   
   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

SUB fin
 
  'Subrutina que controla el fin de sesin
 
   'Letrero para salir o continuar
     COLOR 0, 7
       LOCATE 24, 27: PRINT " TECLEE < ESC > PARA TERMINAR "
     COLOR 7, 9
  
   'Ciclo iterativo para mostrar los resultados o salir de sesin
     DO
       'Captura
         DO
           k$ = INKEY$
         LOOP WHILE k$ = ""
    
       'Traslado a cdigo ASCII del primer dgito
         qy = ASC(RIGHT$(k$, 1))
      
       'Se seleccion ESCAPE?
         IF qy = 27 THEN
            EXIT DO
         ELSE
            SOUND 500, 2
         END IF
     LOOP
  
   CLS
   END

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
     COLOR ci%
       LOCATE reni%, coli%: PRINT esi$
       LOCATE reni%, colf%: PRINT esd$
       LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
       FOR I% = reni% + 1 TO renf%
          LOCATE I%, coli%: PRINT lv$
          LOCATE I%, colf%: PRINT lv$
       NEXT I%
       LOCATE renf%, coli%: PRINT eii$
       LOCATE renf%, colf%: PRINT eid$
       LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
     COLOR cf%

END SUB

