
  'Solucin de sistemas de ecuaciones lineales mediante las subrutinas
  'DECOMP y SOLVE
     
      'Versin 1.0 (programa fuente creado por J. Antonio Ruiz G., 1992)
   
    DEFINT I-J, M-N
    DECLARE SUB asciival (X)
    DECLARE SUB borrado (coorx, coory, dato)
    DECLARE SUB decomp (NDIM, N, A(), COND, IPVT(), WORK())
    DECLARE SUB enrolla ()
    DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
    DECLARE SUB matriz (xpos, dato, I, J, aux, coorx1)
    DECLARE SUB solve (NDIM, N, A(), B(), IPVT())
   
   'Cursor invisible
   LOCATE , , 0
  
   'Se invoca a la subrutina que genera una pantalla de presentacin
    CALL enrolla

   'Inicia el proceso
    DO
      'Se designa el rea visual de trabajo y se le asigna color
        CLEAR
        VIEW PRINT
        COLOR 7, 9, 9
        CLS
     
      'Se invoca a la subrutina que genera un marco
        CALL marco(1, 3, 1, 80, 10, 15)
        COLOR 0, 7
          LOCATE 24, 25: PRINT " TECLEE < ESC > PARA TERMINAR "
        COLOR 7, 9
     
      'Captura del orden M del sistema
        DO
          LOCATE 5, 19: PRINT "Orden (m) de la matriz (ecuaciones) ? ";
          'Coordenadas del cursor
            coorx = CSRLIN
            coory = POS(0)
          'Subrutina para captura
            CALL asciival(AUXM)
          'Cambio de variable, (AUXM es real y M es entera)
            M = AUXM
          IF M <= 0 THEN
             SOUND 200, 7
             'Subrutina para borrado de cadenas capturadas
               CALL borrado(coorx, coory, AUXM)
          END IF
        LOOP WHILE M <= 0
     
      'Captura del orden N del sistema
        DO
          LOCATE 6, 19: PRINT "Orden (n) de la matriz (incgnitas) ? ";
          'Coordenadas del cursor
            coorx = CSRLIN
            coory = POS(0)
          'Subrutina para captura
            CALL asciival(AUXN)
          'Cambio de variable, (AUXN es real y N es entera)
            N = AUXN
          IF N <= 0 THEN
             SOUND 200, 7
             'Subrutina para borrado de cadenas capturadas
               CALL borrado(coorx, coory, AUXN)
          END IF
        LOOP WHILE N <= 0
     
      'Se borran letreros de orden
        LOCATE 5, 19: PRINT "                                           "
        LOCATE 6, 19: PRINT "                                           "
     
      'Dimensionamiento de la matriz de coeficientes A y del vector de
      'trminos independientes B, as como de los vectores IPVT y WORK
        IF N > M THEN NDIM = N ELSE NDIM = M
        DIM A(NDIM, NDIM), IPVT(NDIM), WORK(NDIM), B(NDIM)
     
      'Captura de datos
        FOR I = 1 TO M
            BEEP
            FOR J = 1 TO N
                LOCATE 5, 27: PRINT "Elemento   A("; I; ","; J; ") = ";
                'Coordenadas del cursor
                  coorx = CSRLIN
                  coory = POS(0)
                'Subrutina para captura
                  CALL asciival(dato)
                A(I, J) = dato
                'Subrutina para despliegue en forma de arreglo matricial
                  CALL matriz(7, dato, I, J, 0, coorx1)
                'Subrutina para borrado de cadenas capturadas
                  CALL borrado(coorx, coory, dato)
            NEXT J
            LOCATE 5, 27: PRINT "Trmino indep. B("; I; ") = ";
            'Coordenadas del cursor
              coorx = CSRLIN
              coory = POS(0)
            'Subrutina para captura
              CALL asciival(dato)
            B(I) = dato
            CALL matriz(7, dato, I, J, 1, coorx1)
            'Subrutina para borrado de cadenas capturadas
              CALL borrado(coorx, coory, dato)
        NEXT I
       
        LOCATE 5, 27: PRINT "                             "

      'Invocando a la subrutina DECOMP
        CALL decomp(NDIM, N, A(), COND, IPVT(), WORK())
   
      'S la matriz es singular se aborta el proceso
        IF COND = 1E+32 THEN
          BEEP
          COLOR 31
            LOCATE 5, 25: PRINT "MATRIZ SINGULAR SIN SOLUCION !!"
          COLOR 7
          GOTO 10
        END IF
   
      'Invocando a la subrutina SOLVE
        CALL solve(NDIM, N, A(), B(), IPVT())
   
      'Despliegue de resultados (vector B)
        SOUND 200, 6
        LOCATE coorx1 + 1, 27: PRINT ; "Solucin del sistema:"
        FOR I = 1 TO N
            LOCATE (coorx1 + 1) + I, 30: PRINT "X("; I; ") = "; : PRINT USING "######.#####"; B(I)
        NEXT
       
        'Coordenadas del cursor
        LOCATE CSRLIN, 27: PRINT "Nm. de condicin ="; : PRINT USING "######.##"; COND

      'Eleccin de proseguir o finalizar
10      LOCATE 24, 25: PRINT "  DESEA OTRO CALCULO (S/N) ?  ";
      'Coordenadas del cursor
        coorx = CSRLIN: coory = POS(0)
      
      'Captura
11      DO
          k$ = INKEY$
        LOOP WHILE k$ = ""
       
      'El cracter tecleado se transforma maysculas
        k$ = UCASE$(k$)
     
      'Se seleccion S o N?
        IF k$ = "N" THEN
           'Fin de sesin
             CLS : END
        ELSE
           IF k$ <> "S" THEN
              SOUND 500, 2
              'Borrado de un caracter sobre la lnea actual
                 LOCATE coorx, coory - 1: PRINT "   "
              GOTO 11
           END IF
        END IF
   
    LOOP

DEFSNG I-J, M-N
SUB asciival (X)

 'Subrutina para captura y discriminacin de caracteres numricos

1  'Captura del primer dgito
     DO
       k$ = INKEY$
     LOOP WHILE k$ = ""
 
   'Traslado a cdigo ASCII del primer dgito
     qy = ASC(RIGHT$(k$, 1))
 
   'Accin a seguir en funcin de la tecla oprimida
     SELECT CASE qy
            CASE 13  'Enter
               'Se asigna el valor de cero
                 entrada$ = CHR$(48)
                 X = VAL(entrada$)
          
            CASE 27  'escape
               'Salida
                 CLS
                 END
             
            CASE 45 TO 57  'Nmeros y signos
               'Traslado a cadena del primer dgito
                 entrada$ = CHR$(qy)
                 PRINT entrada$;
               'Captura de los dgitos subsecuentes
2                DO
                   ky$ = INKEY$
                 LOOP WHILE ky$ = ""
               'Traslado a cdigo ASCII
                 kz = ASC(RIGHT$(ky$, 1))
               'Accin a seguir en funcin de las teclas subsecuentes
                 SELECT CASE kz
                        CASE 8 'Correccin de caracteres
                           'Posicin del cursor rengln y columna
                             AA = CSRLIN
                             BB = POS(0)
                           'Cuando se llega a la posicin inicial se aborta
                             IF BB = 1 THEN
                                SOUND 3700, 4
                                GOTO 2
                             END IF
                           'El ltimo caracter se reemplaza por un espacio
                           'en blanco (posicin n)
                             LOCATE AA, BB - 1: PRINT " ";
                           'Reubicacin en la posicin n-1
                             LOCATE AA, BB - 1
                           'Longitud de la cadena con espacio en blanco
                             lng = LEN(entrada$)
                           'Nueva longitud de la cadena (n-1)
                             entrada$ = LEFT$(entrada$, lng - 1)
                           GOTO 2
                      
                        CASE 13  'Enter (cantidad deseada)
                           'Asignacin de valor a la variable X
                             X = VAL(entrada$)
                      
                        CASE 27  'escape
                           'Salida
                             CLS
                             END
                      
                        CASE 45 TO 57  'Se aceptan nmeros y signos, para
                                       'conformar una cifra
                           'Se constituye una cadena
                             entrada$ = entrada$ + CHR$(kz)
                             PRINT CHR$(kz);
                             GOTO 2
                      
                        CASE ELSE  'se rechazan otros cracteres
                           SOUND 420, 5
                           GOTO 2
                 END SELECT
          
            CASE ELSE  'Caracteres no vlidos
                SOUND 420, 5
                GOTO 1
     END SELECT

END SUB

SUB borrado (coorx, coory, dato)

'Subrutina para borrar caracteres tecleados       
  
   'Conversin de valor numrico a cadena
   dato$ = STR$(dato)
   'Posicionamiento en la ltima coordenada del cursor
   LOCATE coorx, coory
   'Borrado de la longitud de la cadena (caracter por caracter)
   FOR s = 1 TO LEN(dato$)
           PRINT " ";
   NEXT

END SUB

DEFINT I-K, M-N
SUB decomp (NDIM, N, A(), COND, IPVT(), WORK())
  
    'Descomposicin de una matriz real por Eliminacin Gaussiana, adems, se
    'estima su nmero de condicin.
    'Con la subrutina SOLVE se obtiene la solucin del sistema lineal.
 
    'Datos de entrada:
       'NDIM = Dimensionamiento del arreglo de la matriz A.
          'N = Orden de la matriz.
          'A = Matriz que ser triangularizada.
 
    'Datos de salida:
          'A = Contiene una matriz tringular superior  (U)  y  una  versin
              'permutada de una tringular inferior (I-L), por lo tanto:
                           '(matriz permutada)*A = L*U.
       'COND = Valor estimado del nmero de condicin de A. Para un  sistema
              'lineal A*X = B, cambios en los valores de  A  y/o  B,  pueden
              'causar modificaciones a COND y a veces en X. Si COND+1 = COND,
              'A es una matriz singular  an  al  trabajarla  con  precisin,
              'entonces COND = 1.0D+32 si la singularidad exacta es detectada.
       'IPVT = Vector pivote.
              'IPVT(K) = El ndice del k-simo rengln pivote.
              'IPVT(N) = (-1)^(nmero de intercambios).
 
    'Espacio de trabajo:
              'El vector WORK debe declararse e incluirse en  la  llamada  a
              'esta subrutina. Su contenido de entrada se ignora (cero) y el
              'de salida no es relevante.
 
    'El determinante de A puede obtenerse mediante la expresin:
                 'Det(A) = IPVT(N) * A(1,1) * A(2,2) * ... * A(N,N)

    IPVT(N) = 1
    IF N = 1 THEN GOTO d80
    NM1 = N - 1

    'Clculo de (1-NORMA) de A
      ANORM = 0#
      FOR J = 1 TO N
          T = 0#
          FOR I = 1 TO N
              T = T + ABS(A(I, J))
          NEXT I
          IF T > ANORM THEN ANORM = T
      NEXT J

    'Eliminacin Gaussiana con pivoteo parcial
      FOR k = 1 TO NM1
          KP1 = k + 1
 
          'Se ubica el pivote
          M = k
          FOR I = KP1 TO N
              IF ABS(A(I, k)) > ABS(A(M, k)) THEN M = I
          NEXT I
          IPVT(k) = M
          IF M <> k THEN IPVT(N) = -IPVT(N)
          T = A(M, k)
          A(M, k) = A(k, k)
          A(k, k) = T
  
          'Si el pivote es cero se efecta un salto
          IF T = 0# THEN GOTO 35
 
          'Clculo de multiplicaciones
          FOR I = KP1 TO N
              A(I, k) = -A(I, k) / T
          NEXT I
 
          'Intercambio y eliminacin por columnas
          FOR J = KP1 TO N
              T = A(M, J)
              A(M, J) = A(k, J)
              A(k, J) = T
              IF T = 0# THEN GOTO 30
              FOR I = KP1 TO N
                  A(I, J) = A(I, J) + A(I, k) * T
              NEXT I
30        NEXT J
35    NEXT k
 
    'COND = (1-NORMA de A)*(estimacin de 1-NORMA de la inversa de A)
      'La estimacin se obtiene en un paso iterativo inverso para el vector
      'singular reducido. Esto involucra la solucin de 2 sistemas de ecua-
      'ciones, (TRANSPUESTA de A)*Y = E y A*Z = Y, donde E es un vector  de
      'eleccin (+1  -1) para adicionarse en Y.
                  'Estimacin = (1-NORMA de Z)/(1-NORMA de Y)
   
      'Resolviendo (TRANSPUESTA de A)*Y = E
      FOR k = 1 TO N
          T = 0#
          IF k = 1 THEN GOTO d45
          KM1 = k - 1
          FOR I = 1 TO KM1
              T = T + A(I, k) * WORK(I)
          NEXT I
d45:      EK = 1#
          IF T < 0# THEN EK = -1#
          IF A(k, k) = 0# THEN GOTO d90
          WORK(k) = -(EK + T) / A(k, k)
      NEXT k
      FOR KB = 1 TO NM1
          k = N - KB
          T = 0#
          KP1 = k + 1
          FOR I = KP1 TO N
              T = T + A(I, k) * WORK(k)
          NEXT I
          WORK(k) = T
          M = IPVT(k)
          IF M = k THEN GOTO d60
          T = WORK(M)
          WORK(M) = WORK(k)
          WORK(k) = T
d60:  NEXT KB
      YNORM = 0
      FOR I = 1 TO N
        YNORM = YNORM + ABS(WORK(I))
      NEXT I
 
    'Resolviendo A*Z = Y
      CALL solve(NDIM, N, A(), WORK(), IPVT())
      ZNORM = 0#
      FOR I = 1 TO N
          ZNORM = ZNORM + ABS(WORK(I))
      NEXT I
 
    'Estimando la condicin
      COND = ANORM * ZNORM / YNORM
      IF COND < 1# THEN COND = 1#
      EXIT SUB
 
    'Sistema de 1 por 1
d80:  COND = 1#
      IF A(1, 1) <> 0# THEN EXIT SUB
 
    'Singularidad exacta
d90:  COND = 1D+32
  
END SUB

DEFSNG I-K, M-N
SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
 
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
 
   'Letreros
     COLOR 0, 3
       LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
       LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
       LOCATE 13, 27: PRINT "Subrutinas  DECOMP y SOLVE"
       LOCATE 17, 23: PRINT "(solucin de sistemas de ecuaciones"
       LOCATE 18, 24: PRINT "empleando eliminacin  Gaussiana)"
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
  
   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%
  
   'Letrero
     LOCATE 2, 4
     PRINT "SOLUCION DE SISTEMAS DE ECUACIONES EMPLEANDO LAS SUBRUTINAS DECOMP Y SOLVE"

END SUB

DEFINT I-J, M-N
SUB matriz (xpos, dato, I, J, aux, coorx1)

'Subrutina para formar un arreglo matricial
  'Encabezados
  IF I = 1 THEN
     LOCATE xpos, 10 * J
     IF aux = 1 THEN PRINT "T.I." ELSE PRINT "X("; J; ")"
  END IF
  'Elementos
  LOCATE xpos + I, 9 * J - 1: PRINT USING "#####.##"; dato
  'Posicin vertical del cursor
  coorx1 = CSRLIN

END SUB

DEFINT K
DEFSNG J
SUB solve (NDIM, N, A(), B(), IPVT())
   
    'Solucin del sistema lineal, A*X = B.
    'S la subrutina DECOMP detect singularidad se omite la ejecucin de
    'este procedimiento.
   
    'Datos de entrada :
        'NDIM = Dimensionamiento del arreglo de la matriz A.
           'N = Orden de la matriz.
           'A = Matriz tringularizada, obtenida por DECOMP.
           'B = Vector de trminos independientes.
        'IPVT = Vector pivote, obtenido por DECOMP.
   
    'Datos de salida :
           'B = Vector solucin, X.

    'Eliminacin hacia adelante
      IF N = 1 THEN GOTO s50
      NM1 = N - 1
      FOR k = 1 TO NM1
          KP1 = k + 1
          M = IPVT(k)
          T = B(M)
          B(M) = B(k)
          B(k) = T
          FOR I = KP1 TO N
              B(I) = B(I) + A(I, k) * T
          NEXT I
      NEXT k
   
    'Sustitucin hacia atrs
      FOR KB = 1 TO NM1
          KM1 = N - KB
          k = KM1 + 1
          B(k) = B(k) / A(k, k)
          T = -B(k)
          FOR I = 1 TO KM1
              B(I) = B(I) + A(I, k) * T
          NEXT I
      NEXT KB

s50:  B(1) = B(1) / A(1, 1)

END SUB

