 
  'Clculo del determinante y de la inversa de un matriz (n x n), empleando
  'las subrutinas DECOMP y SOLVE
    
     'Versin 1.0 (programa fuente creado por J. Antonio Ruiz G., 1992)
   
    DEFINT I-K, N
    DECLARE SUB asciival (X!)
    DECLARE SUB borrado (coorx!, coory!, dato!)
    DECLARE SUB decomp (NDIM, N, A(), COND, IPVT(), WORK())
    DECLARE SUB enrolla ()
    DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
    DECLARE SUB matriz (xpos!, dato!, I%, J%, aux!, coorx1!)
    DECLARE SUB solve (NDIM, N, A(), B(), IPVT())
   
    'Cursor no visible
    LOCATE , , 0
   
    'Se invoca a la subrutina que genera una pantalla de presentacin
    CALL enrolla
   
    'Inicia el proceso
    DO
      'Se designa el rea visual de trabajo y se le asigna color
      CLEAR
      VIEW PRINT
      COLOR 7, 9, 9
      CLS : BEEP
     
      'Se invoca a la subrutina que genera un marco
      CALL marco(1, 4, 1, 80, 13, 7)
      COLOR 0, 7
        LOCATE 24, 25: PRINT " TECLEE < ESC > PARA TERMINAR "
      COLOR 7, 9
     
      'El nm. de columnas debe ser igual que el de ecs. (n x n)
      DO
         LOCATE 6, 20: PRINT "Orden (n) de la matriz cuadrada (A) ? ";
         'Coordenadas del cursor
           coorx = CSRLIN
           coory = POS(0)
         'Subrutina para captura
           CALL asciival(AUXN)
         'Cambio de variable, (AUXN es real y N es entera)
           N = AUXN
         IF N <= 0 THEN
            SOUND 200, 7:
            'Subrutina para borrado de cadenas capturadas
             CALL borrado(coorx, coory, AUXN)
         END IF
      LOOP WHILE N <= 0
     
      'Se borran letreros de orden
        LOCATE 6, 19: PRINT "                                               "
     
      'Dimensionamiento de la matriz de coeficientes A, as como de los
      'vectores B, IPVT y WORK
      DIM A(N, N), IPVT(N), WORK(N), B(N)
  
      'Captura de datos
      PRINT
      FOR I = 1 TO N
          FOR J = 1 TO N
              LOCATE 6, 27: PRINT "Elemento   A("; I; ","; J; ") = ";
              'Coordenadas del cursor
                coorx = CSRLIN
                coory = POS(0)
              'Subrutina para captura
                CALL asciival(dato)
              A(I, J) = dato
              'Subrutina para despliegue en forma de arreglo matricial
                CALL matriz(7, dato, I, J, 0, coorx1)
              'Subrutina para borrado de cadenas capturadas
                CALL borrado(coorx, coory, dato)
          NEXT J
      SOUND 200, 2
      NEXT I
     
      LOCATE 6, 10: PRINT "La matriz original es:                            "

      'Invocando a la subrutina DECOMP
      CALL decomp(N, N, A(), COND, IPVT(), WORK())
     
      'Se elimina de la RAM el arreglo WORK
      ERASE WORK
  
      'Si la matriz es singular, se aborta el proceso
      IF COND = 1E+32 THEN
         SOUND 200, 8
         COLOR 31
           LOCATE 6, 25: PRINT "MATRIZ SINGULAR SIN SOLUCION !!"
         COLOR 7
         GOTO 10
      END IF
  
      'Clculo del det A
      SOUND 320, 4
      DIAG = 1
      FOR I = 1 TO N
          DIAG = A(I, I) * DIAG
      NEXT I
      DET = IPVT(N) * DIAG
      LOCATE coorx1 + 1, 20: PRINT "El determinante es:    det (A) = "; DET
     
      LOCATE CSRLIN + 1, 10: PRINT "La matriz (A)^-1 es:"
      coorx = CSRLIN
      
      'Clculo de (A)^-1
      FOR K = 1 TO N
          'Se genera la k-sima columna de la matriz identidad
            B(K) = 1
         
          'Se invoca a SOLVE "n" ocasiones
            CALL solve(N, N, A(), B(), IPVT())
          
          'Despliegue de resultados (vector B)
            FOR I = 1 TO N
              'Subrutina para despliegue en forma de arreglo matricial
                dato = B(I)
                CALL matriz(coorx, dato, K, I, 1, coorx1)
                B(I) = 0#
      NEXT I, K
     
      LOCATE CSRLIN + 1, 20: PRINT "Nm. de condicin ="; : PRINT USING "######.##"; COND
     
      'Eleccin de proseguir o finalizar
10      LOCATE 24, 25: PRINT "  DESEA OTRO CALCULO (S/N) ?  ";
      'Coordenadas del cursor
        coorx = CSRLIN: coory = POS(0)
     
      'Captura
11      DO
          K$ = INKEY$
        LOOP WHILE K$ = ""
      
      'El cracter tecleado se transforma maysculas
        K$ = UCASE$(K$)
    
      'Se seleccion S o N?
        IF K$ = "N" THEN
           'Fin de sesin
             CLS : END
        ELSE
           IF K$ <> "S" THEN
              SOUND 500, 2
              'Borrado de un caracter sobre la lnea actual
                 LOCATE coorx, coory - 1: PRINT "   "
              GOTO 11
           END IF
        END IF

    LOOP

DEFSNG I-K, N
SUB asciival (X)

 'Subrutina para captura y discriminacin de caracteres numricos

1  'Captura del primer dgito
     DO
       K$ = INKEY$
     LOOP WHILE K$ = ""

   'Traslado a cdigo ASCII del primer dgito
     qy = ASC(RIGHT$(K$, 1))

   'Accin a seguir en funcin de la tecla oprimida
     SELECT CASE qy
            CASE 13  'Enter
               'Se asigna el valor de cero
                 entrada$ = CHR$(48)
                 X = VAL(entrada$)
         
            CASE 27  'escape
               'Salida
                 CLS
                 END
            
            CASE 45 TO 57  'Nmeros y signos
               'Traslado a cadena del primer dgito
                 entrada$ = CHR$(qy)
                 PRINT entrada$;
               'Captura de los dgitos subsecuentes
2                DO
                   ky$ = INKEY$
                 LOOP WHILE ky$ = ""
               'Traslado a cdigo ASCII
                 kz = ASC(RIGHT$(ky$, 1))
               'Accin a seguir en funcin de las teclas subsecuentes
                 SELECT CASE kz
                        CASE 8 'Correccin de caracteres
                           'Posicin del cursor rengln y columna
                             AA = CSRLIN
                             BB = POS(0)
                           'Cuando se llega a la posicin inicial se aborta
                             IF BB = 1 THEN
                                SOUND 3700, 4
                                GOTO 2
                             END IF
                           'El ltimo caracter se reemplaza por un espacio
                           'en blanco (posicin n)
                             LOCATE AA, BB - 1: PRINT " ";
                           'Reubicacin en la posicin n-1
                             LOCATE AA, BB - 1
                           'Longitud de la cadena con espacio en blanco
                             lng = LEN(entrada$)
                           'Nueva longitud de la cadena (n-1)
                             entrada$ = LEFT$(entrada$, lng - 1)
                           GOTO 2
                     
                        CASE 13  'Enter (cantidad deseada)
                           'Asignacin de valor a la variable X
                             X = VAL(entrada$)
                     
                        CASE 27  'escape
                           'Salida
                             CLS
                             END
                     
                        CASE 45 TO 57  'Se aceptan nmeros y signos, para
                                       'conformar una cifra
                           'Se constituye una cadena
                             entrada$ = entrada$ + CHR$(kz)
                             PRINT CHR$(kz);
                             GOTO 2
                     
                        CASE ELSE  'se rechazan otros cracteres
                           SOUND 420, 5
                           GOTO 2
                 END SELECT
         
            CASE ELSE  'Caracteres no vlidos
                SOUND 420, 5
                GOTO 1
     END SELECT

END SUB

SUB borrado (coorx, coory, dato)

'Subrutina para borrar caracteres tecleados

   'Conversin de valor numrico a cadena
   dato$ = STR$(dato)
   'Posicionamiento en la ltima coordenada del cursor
   LOCATE coorx, coory
   'Borrado de la longitud de la cadena (caracter por caracter)
   FOR s = 1 TO LEN(dato$)
           PRINT " ";
   NEXT

END SUB

DEFINT I-K, M-N
SUB decomp (NDIM, N, A(), COND, IPVT(), WORK())
   
    'Descomposicin de una matriz real por Eliminacin Gaussiana, adems, se
    'estima su nmero de condicin.
    'Con la subrutina SOLVE se obtiene la solucin del sistema lineal.

    'Datos de entrada:
       'NDIM = Dimensionamiento del arreglo de la matriz A.
          'N = Orden de la matriz.
          'A = Matriz que ser triangularizada.

    'Datos de salida:
          'A = Contiene una matriz tringular superior  (U)  y  una  versin
              'permutada de una tringular inferior (I-L), por lo tanto:
                             '(matriz permutada)*A = L*U.
       'COND = Valor estimado del nmero de condicin de A. Para un  sistema
              'lineal A*X = B, cambios en los valores de  A  y/o  B,  pueden
              'causar modificaciones a COND y a veces en X. Si COND+1 = COND,
              'A es una matriz singular  an  al  trabajarla  con  precisin,
              'entonces COND = 1.0D+32 si la singularidad exacta es detectada.
       'IPVT = Vector pivote.
              'IPVT(K) = El ndice del k-simo rengln pivote.
              'IPVT(N) = (-1)^(nmero de intercambios).

    'Espacio de trabajo:
              'El vector WORK debe declararse e incluirse en  la  llamada  a
              'esta subrutina. Su contenido de entrada se ignora (cero) y el
              'de salida no es relevante.

    'El determinante de A puede obtenerse mediante la expresin:
              'Det(A) = IPVT(N) * A(1,1) * A(2,2) * ... * A(N,N)

    IPVT(N) = 1
    IF N = 1 THEN GOTO d80
    NM1 = N - 1

    'Clculo de (1-NORMA) de A
      ANORM = 0#
      FOR J = 1 TO N
          T = 0#
          FOR I = 1 TO N
              T = T + ABS(A(I, J))
          NEXT I
          IF T > ANORM THEN ANORM = T
      NEXT J

    'Eliminacin Gaussiana con pivoteo parcial
      FOR K = 1 TO NM1
          KP1 = K + 1

          'Se ubica el pivote
          M = K
          FOR I = KP1 TO N
              IF ABS(A(I, K)) > ABS(A(M, K)) THEN M = I
          NEXT I
          IPVT(K) = M
          IF M <> K THEN IPVT(N) = -IPVT(N)
          T = A(M, K)
          A(M, K) = A(K, K)
          A(K, K) = T
 
          'Si el pivote es cero se efecta un salto
          IF T = 0# THEN GOTO d35

          'Clculo de multiplicaciones
          FOR I = KP1 TO N
              A(I, K) = -A(I, K) / T
          NEXT I

          'Intercambio y eliminacin por columnas
          FOR J = KP1 TO N
              T = A(M, J)
              A(M, J) = A(K, J)
              A(K, J) = T
              IF T = 0# THEN GOTO d30
              FOR I = KP1 TO N
                  A(I, J) = A(I, J) + A(I, K) * T
              NEXT I
d30:      NEXT J
d35:  NEXT K

    'COND = (1-NORMA de A)*(estimacin de 1-NORMA de la inversa de A)
      'La estimacin se obtiene en un paso iterativo inverso para el vector
      'singular reducido. Esto involucra la solucin de 2 sistemas de ecua-
      'ciones, (TRANSPUESTA de A)*Y = E y A*Z = Y, donde E es un vector  de
      'eleccin (+1  -1) para adicionarse en Y.
                   'Estimacin = (1-NORMA de Z)/(1-NORMA de Y)
  
      'Resolviendo (TRANSPUESTA de A)*Y = E
      FOR K = 1 TO N
          T = 0#
          IF K = 1 THEN GOTO d45
          KM1 = K - 1
          FOR I = 1 TO KM1
              T = T + A(I, K) * WORK(I)
          NEXT I
d45:      EK = 1#
          IF T < 0# THEN EK = -1#
          IF A(K, K) = 0# THEN GOTO d90
          WORK(K) = -(EK + T) / A(K, K)
      NEXT K
      FOR KB = 1 TO NM1
          K = N - KB
          T = 0#
          KP1 = K + 1
          FOR I = KP1 TO N
              T = T + A(I, K) * WORK(K)
          NEXT I
          WORK(K) = T
          M = IPVT(K)
          IF M = K THEN GOTO d60
          T = WORK(M)
          WORK(M) = WORK(K)
          WORK(K) = T
d60:  NEXT KB
      YNORM = 0
      FOR I = 1 TO N
        YNORM = YNORM + ABS(WORK(I))
      NEXT I

    'Resolviendo A*Z = Y
      CALL solve(NDIM, N, A(), WORK(), IPVT())
      ZNORM = 0#
      FOR I = 1 TO N
          ZNORM = ZNORM + ABS(WORK(I))
      NEXT I

    'Estimando la condicin
      COND = ANORM * ZNORM / YNORM
      IF COND < 1# THEN COND = 1#
      EXIT SUB

    'Sistema de 1 por 1
d80:  COND = 1#
      IF A(1, 1) <> 0# THEN EXIT SUB

    'Singularidad exacta
d90:  COND = 1D+32

END SUB

DEFSNG I-K, M-N
SUB enrolla

  'Subrutina que despliega una cortina para presentacin de ttulos

   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR

   'Letreros
     COLOR 0, 3
       LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
       LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
       LOCATE 13, 16: PRINT "Obtencin del DETERMINANTE y la MATRIZ INVERSA"
       LOCATE 14, 25: PRINT "de una matriz cuadrada (nxn)"
       LOCATE 17, 19: PRINT "(empleando las subrutinas DECOMP y SOLVE)"
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."

   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco
   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%

   'Letreros
     LOCATE 2, 8
     PRINT "OBTENCION DEL DETERMINANTE Y DE LA INVERSA DE UNA MATRIZ CUADRADA"
     LOCATE 3, 21
     PRINT "USANDO LAS SUBRUTINAS DECOMP Y SOLVE"

END SUB

DEFINT I-J, N
SUB matriz (xpos, dato, I, J, aux, coorx1)

'Subrutina para formar un arreglo matricial
  'Elementos
  IF aux = 0 THEN
     'Arreglo matricial por rengln
     LOCATE xpos + I, 10 * J - 1: PRINT USING "#####.####"; dato
  ELSE
     'Arreglo matricial por columna
     LOCATE xpos + J, 10 * I: PRINT USING "#####.####"; dato
  END IF
  'Posicin vertical del cursor
  coorx1 = CSRLIN

END SUB

DEFINT K, M
DEFSNG J
SUB solve (NDIM, N, A(), B(), IPVT())
   
    'Solucin del sistema lineal, A*X = B.
    'S la subrutina DECOMP detect singularidad se omite la ejecucin de
    'este procedimiento.
  
    'Datos de entrada :
        'NDIM = Dimensionamiento del arreglo de la matriz A.
           'N = Orden de la matriz.
           'A = Matriz tringularizada, obtenida por DECOMP.
           'B = Vector de trminos independientes.
        'IPVT = Vector pivote, obtenido por DECOMP.
  
    'Datos de salida :
           'B = Vector solucin, X.

    'Eliminacin hacia adelante
      IF N = 1 THEN GOTO s50
      NM1 = N - 1
      FOR K = 1 TO NM1
          KP1 = K + 1
          M = IPVT(K)
          T = B(M)
          B(M) = B(K)
          B(K) = T
          FOR I = KP1 TO N
              B(I) = B(I) + A(I, K) * T
          NEXT I
      NEXT K
  
    'Sustitucin hacia atrs
      FOR KB = 1 TO NM1
          KM1 = N - KB
          K = KM1 + 1
          B(K) = B(K) / A(K, K)
          T = -B(K)
          FOR I = 1 TO KM1
              B(I) = B(I) + A(I, K) * T
          NEXT I
      NEXT KB

s50:  B(1) = B(1) / A(1, 1)

END SUB

