 
  'Programa fuente de la Tcnica de Descomposicin L-U para matrices
  'cuadradas pentadiagonales, como la que se genera en la simulacin de flujo
  'bidireccional en medios porosos (posee diagonales nulas intercaladas justo
  'antes de las diagonales extremas)
            
             'Versin 1.0 (creado por J. Antonio Ruiz G., 1992)
 
   DECLARE SUB asciival (X!)
   DECLARE SUB borrado (coorx!, coory!, dato!)
   DECLARE SUB enrolla ()
   DECLARE SUB LUpenta (N!, A!(), F!(), X!())
   DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
   DECLARE SUB matriz (xpos!, dato!, I, J, aux!, coorx1!)
  
   'Cursor invisible
   LOCATE , , 0

   'Se invoca a la subrutina que genera una pantalla de presentacin
    CALL enrolla
  
   'Inicia el proceso
   DO
     'Se designa el rea visual de trabajo y se le asigna color
     CLEAR
     VIEW PRINT
     COLOR 7, 9, 9
     CLS :  BEEP
 
     'Proteccin contra errores de underflow u overflow
     ON ERROR GOTO 30
 
     'Se invoca a la subrutina que genera un marco
     CALL marco(1, 3, 1, 80, 10, 7)
     COLOR 0, 7
       LOCATE 24, 25: PRINT " TECLEE < ESC > PARA TERMINAR "
     COLOR 7, 9
    
     'Captura del orden N del sistema
       DO
          LOCATE 5, 19: PRINT "Orden (n) de la matriz (incgnitas) ? ";
          'Coordenadas del cursor
            coorx = CSRLIN: coory = POS(0)
          'Subrutina para captura
            CALL asciival(AUXN)
          'Cambio de variable, (AUXN es real y N es entera)
            N = AUXN
          IF N <= 0 THEN
             SOUND 200, 7
             'Subrutina para borrado de cadenas capturadas
               CALL borrado(coorx, coory, AUXN)
          END IF
       LOOP WHILE N <= 0
      
       LOCATE 5, 19: PRINT "                                           "
    
     'Dimensionando la matriz de coeficientes A(n x n), el vector de trminos
     'independientes F, y el de soluciones X
     DIM A(N, N), F(N), X(N)

     'Captura de datos
       FOR I = 1 TO N
            BEEP
           FOR J = 1 TO N
                LOCATE 5, 27: PRINT "Elemento   A("; I; ","; J; ") = ";
                'Coordenadas del cursor
                  coorx = CSRLIN: coory = POS(0)
                'Subrutina para captura
                  CALL asciival(dato)
                A(I, J) = dato
                'Subrutina para despliegue en forma de arreglo matricial
                  CALL matriz(7, dato, I, J, 0, coorx1)
                'Subrutina para borrado de cadenas capturadas
                  CALL borrado(coorx, coory, dato)
           NEXT J
           LOCATE 5, 27: PRINT "Trmino indep. F("; I; ") = ";
           'Coordenadas del cursor
             coorx = CSRLIN: coory = POS(0)
           'Subrutina para captura
             CALL asciival(dato)
           F(I) = dato
           CALL matriz(7, dato, I, J, 1, coorx1)
           'Subrutina para borrado de cadenas capturadas
             CALL borrado(coorx, coory, dato)
        NEXT I
     
        LOCATE 5, 27: PRINT "                             "
    
     'Invocando a la subrutina de la Tcnica de Descomposicin L-U
     CALL LUpenta(N, A(), F(), X())
 
     'Despliegue de resultados (vector x)
     SOUND 220, 6
     LOCATE coorx1 + 1, 27: PRINT "Solucin del sistema:"
     FOR I = 1 TO N
         LOCATE (coorx1 + 1) + I, 30: PRINT "X("; I; ") = "; : PRINT USING "######.##"; X(I)
     NEXT
 
     'Eleccin de proseguir o finalizar
10      LOCATE 24, 25: PRINT "  DESEA OTRO CALCULO (S/N) ?  ";
      'Coordenadas del cursor
        coorx = CSRLIN: coory = POS(0)
    
      'Captura
20      DO
          k$ = INKEY$
        LOOP WHILE k$ = ""
     
      'El cracter tecleado se transforma maysculas
        k$ = UCASE$(k$)
   
      'Se seleccion S o N?
        IF k$ = "N" THEN
           'Fin de sesin
             CLS : END
        ELSE
           IF k$ <> "S" THEN
              SOUND 500, 2
              'Borrado de un caracter sobre la lnea actual
                 LOCATE coorx, coory - 1: PRINT "   "
              GOTO 20
           END IF
        END IF
  
   LOOP
  
   'Sentencias para manejo de errores de underflow u overflow
30   SOUND 200, 4: CLS
     LOCATE 14, 14
     PRINT "Error detectado: Sistema Incompatible (matriz singular)"
     RESUME 40
40   END

SUB asciival (X)

 'Subrutina para captura y discriminacin de caracteres numricos

1  'Captura del primer dgito
     DO
       k$ = INKEY$
     LOOP WHILE k$ = ""
 
   'Traslado a cdigo ASCII del primer dgito
     qy = ASC(RIGHT$(k$, 1))
 
   'Accin a seguir en funcin de la tecla oprimida
     SELECT CASE qy
            CASE 13  'Enter
               'Se asigna el valor de cero
                 entrada$ = CHR$(48)
                 X = VAL(entrada$)
          
            CASE 27  'escape
               'Salida
                 CLS
                 END
             
            CASE 45 TO 57  'Nmeros y signos
               'Traslado a cadena del primer dgito
                 entrada$ = CHR$(qy)
                 PRINT entrada$;
               'Captura de los dgitos subsecuentes
2                DO
                   ky$ = INKEY$
                 LOOP WHILE ky$ = ""
               'Traslado a cdigo ASCII
                 kz = ASC(RIGHT$(ky$, 1))
               'Accin a seguir en funcin de las teclas subsecuentes
                 SELECT CASE kz
                        CASE 8 'Correccin de caracteres
                           'Posicin del cursor rengln y columna
                             aa = CSRLIN
                             BB = POS(0)
                           'Cuando se llega a la posicin inicial se aborta
                             IF BB = 1 THEN
                                SOUND 3700, 4
                                GOTO 2
                             END IF
                           'El ltimo caracter se reemplaza por un espacio
                           'en blanco (posicin n)
                             LOCATE aa, BB - 1: PRINT " ";
                           'Reubicacin en la posicin n-1
                             LOCATE aa, BB - 1
                           'Longitud de la cadena con espacio en blanco
                             lng = LEN(entrada$)
                           'Nueva longitud de la cadena (n-1)
                             entrada$ = LEFT$(entrada$, lng - 1)
                           GOTO 2
                      
                        CASE 13  'Enter (cantidad deseada)
                           'Asignacin de valor a la variable X
                             X = VAL(entrada$)
                      
                        CASE 27  'escape
                           'Salida
                             CLS
                             END
                      
                        CASE 45 TO 57  'Se aceptan nmeros y signos, para
                                       'conformar una cifra
                           'Se constituye una cadena
                             entrada$ = entrada$ + CHR$(kz)
                             PRINT CHR$(kz);
                             GOTO 2
                      
                        CASE ELSE  'se rechazan otros cracteres
                           SOUND 420, 5
                           GOTO 2
                 END SELECT
          
            CASE ELSE  'Caracteres no vlidos
                SOUND 420, 5
                GOTO 1
     END SELECT

END SUB

SUB borrado (coorx, coory, dato)

'Subrutina para borrar caracteres tecleados  
  
   'Conversin de valor numrico a cadena
   dato$ = STR$(dato)
   'Posicionamiento en la ltima coordenada del cursor
   LOCATE coorx, coory
   'Borrado de la longitud de la cadena (caracter por caracter)
   FOR s = 1 TO LEN(dato$)
           PRINT " ";
   NEXT

END SUB

SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
 
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
 
   'Letreros
     COLOR 0, 3
       LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
       LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
       LOCATE 13, 30: PRINT "C A P I T U L O   II"
       LOCATE 16, 18: PRINT "Tcnica de Descomposicin L-U para matrices"
       LOCATE 17, 27: PRINT "cuadradas pentadiagonales"
       
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
  
   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

SUB LUpenta (N, A(), F(), X())
 
  'Algoritmo de Thomas para una matriz pentadiagonal cuadrada, como la que se
  'genera en la simulacin de flujo bidireccional en medios porosos (posee
  'diagonales nulas intercaladas justo antes de las diagonales extremas)

  'Asignando los valores A(i,j) de las diagonales diferentes de cero a los
  'vectores involucrados en el algoritmo [aa(i), b(i), c(i), d(i), e(i)] y
  'dimensionndolos
   DIM aa(N), b(N), c(N), d(N), e(N)
  
   FOR I = 4 TO N
     aa(I) = A(I, I - 3)
   NEXT
  
   FOR I = 2 TO N
     b(I) = A(I, I - 1)
   NEXT
  
   FOR I = 1 TO N
     c(I) = A(I, I)
   NEXT
  
   FOR I = 1 TO N - 1
     d(I) = A(I, I + 1)
   NEXT
  
   FOR I = 1 TO N - 3
     e(I) = A(I, I + 3)
   NEXT
   
  'Eliminando de la RAM a la matriz A
   ERASE A

  'Clculo de las matrices L y U, y dimensionando los arreglos pertinentes
   DIM alfa(N), beta(N), gama(N), delta(N), u(N), v(N), w(N)
  
   alfa(1) = c(1)
   u(1) = d(1) / alfa(1)
   v(1) = 0
   w(1) = e(1) / alfa(1)
   gama(3) = 0

   FOR I = 2 TO N
     IF I <= 3 THEN
        beta(I) = b(I)
        alfa(I) = c(I) - beta(I) * u(I - 1)
        u(I) = (d(I) - beta(I) * v(I - 1)) / alfa(I)
     END IF
     IF I >= 4 THEN
        delta(I) = aa(I)
        gama(I) = -delta(I) * u(I - 3)
        beta(I) = b(I) - gama(I) * u(I - 2) - delta(I) * v(I - 3)
        alfa(I) = c(I) - beta(I) * u(I - 1) - gama(I) * v(I - 2) - delta(I) * w(I - 3)
        IF I <= N - 1 THEN u(I) = (d(I) - beta(I) * v(I - 1) - gama(I) * w(I - 2)) / alfa(I)
     END IF
      IF I <= N - 2 THEN v(I) = (-beta(I) * w(I - 1)) / alfa(I)
      IF I <= N - 3 THEN w(I) = e(I) / alfa(I)
   NEXT I
   
  'Eliminando de la RAM a los vectores aa, b, c, d y e
   ERASE aa, b, c, d, e
                                                       
  'Sustitucin hacia adelante para obtener al vector y, sabiendo que Ly=f
   DIM Y(N)
  
   Y(1) = F(1) / alfa(1)
   Y(2) = (F(2) - beta(2) * Y(1)) / alfa(2)
   Y(3) = (F(3) - beta(3) * Y(2) - gama(3) * Y(1)) / alfa(3)
  
   FOR I = 4 TO N
     Y(I) = (F(I) - beta(I) * Y(I - 1) - gama(I) * Y(I - 2) - delta(I) * Y(I - 3)) / alfa(I)
   NEXT

  'Sustitucin hacia atrs para obtener al vector solucin x (Ux=y)
   X(N) = Y(N)
   X(N - 1) = Y(N - 1) - u(N - 1) * X(N)
   X(N - 2) = Y(N - 2) - u(N - 2) * X(N - 1) - v(N - 2) * X(N)
  
   FOR I = N - 3 TO 1 STEP -1
     X(I) = Y(I) - u(I) * X(I + 1) - v(I) * X(I + 2) - w(I) * X(I + 3)
   NEXT

  'Eliminando de la RAM a los vectores F, Y, alfa, beta, gama, delta,
  'u, v y w
   ERASE F, Y, alfa, beta, gama, delta, u, v, w

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%
  
   'Letrero
     LOCATE 2, 5
     PRINT "DESCOMPOSICION L-U PARA SISTEMAS CUADRADOS DE ECUACIONES PENTA-DIAGONALES"

END SUB

SUB matriz (xpos, dato, I, J, aux, coorx1)

'Subrutina para formar un arreglo matricial
  'Encabezados
  IF I = 1 THEN
     LOCATE xpos, 10 * J
     IF aux = 1 THEN PRINT "T.I." ELSE PRINT "X("; J; ")"
  END IF
  'Elementos
  LOCATE xpos + I, 9 * J - 1: PRINT USING "#####.##"; dato
  'Posicin vertical del cursor
  coorx1 = CSRLIN

END SUB

