 
  'Programa del Mtodo de Estimacin Kriging en Dos Dimensiones
  '(Creado por el Ing. Gustavo Hernndez y modificado por J. Antonio Ruiz)
  'Versin 1.0 (1993)
 
  DECLARE SUB apuntador (FIRST%, LAST%, DX%, Y%, FLAG1%)
  DECLARE FUNCTION Big! (A(), N!)
  DECLARE FUNCTION CoVar! (X!, Y!, XC!, YC!, DX!, DY!, CO!, Range!, Sill!, TipoModelo$)
  DECLARE SUB DistNormal (Mu, Sigma, MuDatos, SigmaDatos, MuBloque, SigmaBloque, A$)
  DECLARE SUB Division (TK1, SK1, Result)
  DECLARE SUB enrolla ()
  DECLARE FUNCTION Fll! (Ele!, A!)
  DECLARE FUNCTION GamaBarra! (X1!, X2!, Y1!, Y2!, Nugget!, Range!, Sill!, TipoModelo$)
  DECLARE FUNCTION GamEsf! (C!, A!, H!)
  DECLARE FUNCTION GamExp! (C!, A!, H!)
  DECLARE FUNCTION GamGau! (C!, A!, H!)
  DECLARE FUNCTION GamLin! (Slope!, H!)
  DECLARE FUNCTION GamLog! (H!)
  DECLARE SUB Hist (Vr(), Ndat!, IV!, IND1!, NCl!, DCL!, Cinf!, Ifr(), U!, V!, N!, EC!, ICU!, Nam$)
  DECLARE SUB letreros (X%)
  DECLARE SUB Mapa (XC, YC, XCen, YCen, NX, NY, PasX, PasY, X(), Y(), Ndat, Radio, Ind(), NMuestras, XCenAnt, YCenAnt, RadioAnt, Indix)
  DECLARE SUB marco (reni%, renf%, coli%, colf%, tipo%, ci%, cf%)
  DECLARE FUNCTION Max0! (I!, J!)
  DECLARE FUNCTION Min0! (I!, J!)
  DECLARE SUB MuSigma (Nd, IV, T(), MuDatos, SigmaDatos)
  DECLARE SUB opciones (archivo$)
  DECLARE FUNCTION Small! (A(), N!, Test!)
  DECLARE SUB SolveSystem (XX(), A(), B(), M, N, KTilt)
  DECLARE SUB SumaPesos (XX(), N)
  DECLARE SUB Texto (XCen!, YCen!, I!, Radio!, Indix!)
    
 
  '***** A T E N C I O N :  Seleccione tipo de monitor ************
   COMMON SHARED tipo$
   'tipo$ = "CGA"
   tipo$ = "VGA"
   
 
  'Proteccin contra errores durante la ejecucin del programa
   ON ERROR GOTO PROCERROR
 
  DIM NBL(400), Nam$(4), CO(3), Range(3), Sill(3), X(137), Y(137), T(137, 3), T1(100, 3)
  DIM ValorKri(400, 3), VarKri(400, 3), DesvStdKri(400, 3), ErrorGlobal(3)
  DIM NumMues(400), RadioBusq(400), Gamm(51), VolBloque(400)
  DIM XF(15), YF(15), Ind(400), SP(400), S2P2(400), MuDatos(3), SigmaDatos(3)
  DIM XX(400), A(400), B(51), Modelo$(3)
 
  CLS
  VIEW PRINT
 
  'Subrutina de pantalla inicial
   CALL enrolla
   CALL opciones(archivo$)
	
   'Lectura del archivo 1 (abierto previamente en la subrutina opciones)
    INPUT #1, Titre$
    INPUT #1, Nam$(1), ECO
    INPUT #1, NX, NY, XC, YC, PasX, PasY
    INPUT #1, Ndat, NVar, NDatF, NPozo
    FOR I = 1 TO NDatF
	   INPUT #1, YF(I), XF(I)
    NEXT
    area = PasX * PasY
    NumBloques = NX * NY
    Test = 0!

  'Se abren archivos para escritura
   OPEN "RESGLOBA.RES" FOR OUTPUT AS #2   'Resultados globales
   OPEN "RESSINTE.RES" FOR OUTPUT AS #3   'Resultados sintetizados
   
	 'Almacenado de datos en archivo de salida de datos globales
	 '(descripcin de variables)
	 PRINT #2, Titre$
	 PRINT #2, "R E S U L T A D O S    G L O B A L E S"
	 PRINT #2, "NUMERO DE CELDAS EN LA DIRECCION X     = ", NX
	 PRINT #2, "NUMERO DE CELDAS EN LA DIRECCION Y     = ", NY
	 PRINT #2, "COORDS. DE LA ESQUINA INFERIOR     XC  = "; XC
	 PRINT #2, "IZQUIERDA DE LA MALLA              YC  = "; YC
	 PRINT #2, "LONG. DE LAS CELDAS EN LA DIRECCION X  = ", PasX; " KM"
	 PRINT #2, "LONG. DE LAS CELDAS EN LA DIRECCION Y  = ", PasY; " KM"
	 PRINT #2, "AREA DE CADA CELDA (KM)               = ", area
	 PRINT #2, "NUM. DE VARIABLES QUE SERAN KRIGEADAS  = ", NVar
	 PRINT #2, " "
	 PRINT #2, "            CARACTERISTICAS ESTRUCTURALES"
	 PRINT #2, "            ============================="
	 PRINT #2, "VARIABLE  EFECTO PEPITA   MESETA       RANGO      TIPO"
	 PRINT #2, "========  =============   ======       =====      ===="
	
	 'Los tipo de modelos de variogramas considerados en este programa son
	 '- Modelos con meseta : ESFERICO, EXPONENCIAL Y GAUSSIANO
	 '- Modelos sin meseta : LINEAL Y LOGARITMICO

	  FOR I = 1 TO NVar
		 INPUT #1, Modelo$(I), CO(I), Sill(I), Range(I)
		 Modelo$(I) = UCASE$(Modelo$(I))
		 PRINT #2, USING "\       \   #.######     #.######   ##.######   &"; Nam$(I); CO(I); Sill(I); Range(I); Modelo$(I)
	  NEXT

	 PRINT #2, " "
	 PRINT #2, " Datos de las variables utilizadas"
	 PRINT #2, "-----------------------------------"
	 PRINT #2, "MUESTRA    X        Y     POROSIDAD"

	 FOR I = 1 TO Ndat
		INPUT #1, X(I), Y(I), T(I, 1)
		PRINT #2, USING "####    ###.##   ###.##     #.###"; I; X(I); Y(I); T(I, 1)
	 NEXT
	
	 'Almacenado de datos en archivo de salida de datos sintetizados
	 PRINT #3, Titre$
	 PRINT #3, "R E S U L T A D O S    S I N T E T I Z A D O S"
	 PRINT #3, "-------------------------------------------------------"
	 PRINT #3, "    X          Y         POROSIDAD    DESV.EST.KRIG."
	
	 'Subrutinas de clculos estadsticos
	 CALL MuSigma(Ndat, 1, T(), MuDatos(1), SigmaDatos(1))

	 NumCeldas = 0
	 Inb = 0
	 FOR LP1 = 1 TO NX
	  XD = XC + (LP1 - 1) * PasX + .5 * PasX
	  FOR LP2 = 1 TO NY
		 YD = YC + (LP2 - 1) * PasY + .5 * PasY
		 Inb = Inb + 1
		 KTest = 0
		 FOR IJ = 1 TO NDatF
		   IF YF(IJ) < YD GOTO 125
		   U = XF(IJ)
		   IF IJ = 1 THEN
			 V = XF(NDatF)
		   ELSE
			 V = XF(IJ - 1)
		   END IF
		   IF XD >= U AND XD <= V THEN
			 KTest = KTest + 1
		   END IF
		   IF XD >= V AND XD <= U THEN
			 KTest = KTest + 1
		   END IF
125 :      NEXT IJ
		 'El Valor correcto de NBL debe ser 0
		 NBL(Inb) = 1
		 IF KTest / 2 < KTest / 2! THEN
		    NBL(Inb) = 1
		 END IF
		 IF NBL(Inb) = 1 THEN
		    NumCeldas = NumCeldas + 1
		 END IF
	  NEXT LP2
	 NEXT LP1
	
	 AREAY = area * NumCeldas

	 FOR IV = 1 TO NVar
	  NBL1 = 0
	  ErrorKri = 0!
	  Sig2z = Sill(IV) * (1! - Fll(PasX, Range(IV)))
	
	  Inb = 0
	  FOR LP1 = 1 TO NX
		 XCen = XC + (LP1 - 1) * PasX + .5 * PasX
		 FOR LP2 = 1 TO NY
		  YCen = YC + (LP2 - 1) * PasY + .5 * PasY
		  Inb = Inb + 1
		  Radio = Range(IV)
		  I = 0
		  IF NBL(Inb) = 0 GOTO 210
		  Indix = (LP1 - 1) * NY + LP2
		  IF Indix = 1 THEN
			XCenAnt = XCen
			YCenAnt = YCen
			RadioAnt = Radio
		  END IF
180 :
		  I = 0
		  FOR LP3 = 1 TO Ndat
			 D2 = (X(LP3) - XCen) ^ 2 + (Y(LP3) - YCen) ^ 2
			 D = SQR(D2)
			 IF D > Radio GOTO 200
			 IF T(LP3, IV) <= 0 GOTO 200
			 I = I + 1
			 IF I > NPozo GOTO 220
			 Ind(I) = LP3
			 T1(I, IV) = T(LP3, IV)
200 :       NEXT LP3
		  IF I >= 2 THEN
			GOTO 240
		  END IF
210 :
		  ValorKri(Indix, IV) = 0!
		  VarKri(Indix, IV) = 0!
		  DesvStdKri(Indix, IV) = 0!
		  NumMues(Indix) = I
		  RadioBusq(Indix) = Radio

		  'Subrutina para creacin de malla de puntos
		  CALL Mapa(XC, YC, XCen, YCen, NX, NY, PasX, PasY, X(), Y(), Ndat, Radio, Ind(), I, XCenAnt, YCenAnt, RadioAnt, Indix)
		  CALL Texto(XCen, YCen, I, Radio, Indix)
		 
		  'Subrutinas de clculos estadsticos
		  CALL DistNormal(ValorKri(Indix, IV), DesvStdKri(Indix, IV), MuDatos(IV), SigmaDatos(IV), MuBloque, SigmaBloque, Nam$(IV))
		
		  'Almacenado de datos en archivo de salida de datos sintetizados
		  IF IV = 1 THEN
			PRINT #3, USING "####.###  ####.###  #####.########  ####.########"; XCen; YCen; ValorKri(Indix, IV); DesvStdKri(Indix, IV)
		  END IF
		  GOTO 360
220 :
		  Radio = Radio * .9
		  GOTO 180
240 :
		  K = 0
		  FOR LP3 = 1 TO I
			 FOR LP4 = 1 TO LP3
			  K = K + 1
			  IF LP3 <> LP4 THEN
				I1 = Ind(LP3)
				I2 = Ind(LP4)
				AA = GamaBarra(X(I1), X(I2), Y(I1), Y(I2), CO(IV), Range(IV), Sill(IV), Modelo$(IV))
				A(K) = Sill(IV) - AA
				IF A(K) = 0 THEN
				A(K) = Sill(IV)
				END IF
			  ELSE
				A(K) = Sill(IV)
			  END IF
			 NEXT LP4
		  NEXT LP3
		  FOR LP4 = 1 TO I
			 K = K + 1
			 A(K) = 1!
		  NEXT LP4
		  K = K + 1
		  A(K) = 0!
		 
		  FOR LP5 = 1 TO I
			 I1 = Ind(LP5)
			 B(LP5) = Sill(IV) - CoVar(X(I1), Y(I1), XCen, YCen, PasX, PasY, CO(IV), Range(IV), Sill(IV), Modelo$(IV))
			 Gamm(LP5) = B(LP5)
		  NEXT LP5
		  B(I + 1) = 1!
		  N = I + 1
		
		  'Subrutina para creacin de malla de puntos
		  CALL Mapa(XC, YC, XCen, YCen, NX, NY, PasX, PasY, X(), Y(), Ndat, Radio, Ind(), I, XCenAnt, YCenAnt, RadioAnt, Indix)
		  CALL Texto(XCen, YCen, I, Radio, Indix)
		  
		  LOCATE 9, 41: PRINT "                                        "
		  LOCATE 10, 41: PRINT "                                       "
		  LOCATE 11, 41: PRINT "                                       "
 
		  'Subrutina para solucin del sistema de ecuaciones
		  CALL SolveSystem(XX(), A(), B(), N, 1, KTilt)
		  CALL SumaPesos(XX(), N)
				   
		  SumX = 0!
		  SumL = 0!
		  FOR LP6 = 1 TO I
			 I1 = Ind(LP6)
			 SumL = SumL + Gamm(LP6) * XX(LP6)
			 SumX = SumX + T(I1, IV) * XX(LP6)
		  NEXT LP6
	
		  NBL1 = NBL1 + 1
		  Indix = (LP1 - 1) * NY + LP2
		  ValorKri(Indix, IV) = SumX
		  VarKri(Indix, IV) = Sig2z - XX(N) - SumL
		  SKK = VarKri(Indix, IV)
		 
		  IF SKK >= 0! THEN
			DesvStdKri(Indix, IV) = SQR(SKK)
		  ELSE
			DesvStdKri(Indix, IV) = SQR(ABS(VarKri(Indix, IV)))
		  END IF

		  'Subrutinas de clculos estadsticos
		  CALL MuSigma(I, IV, T1(), MuBloque, SigmaBloque)
		  CALL DistNormal(ValorKri(Indix, IV), DesvStdKri(Indix, IV), MuDatos(IV), SigmaDatos(IV), MuBloque, SigmaBloque, Nam$(IV))

		  ErrorKri = ErrorKri + VarKri(Indix, IV)

		  NumMues(Indix) = I
		  RadioBusq(Indix) = Radio
		 
		  'Almacenado de datos en archivo de salida de datos sintetizados
		  IF IV = 1 THEN
			PRINT #3, USING "####.###  ####.###  #####.########  ####.########"; XCen; YCen; ValorKri(Indix, IV); DesvStdKri(Indix, IV)
		  END IF
360 :
		 NEXT LP2
	  NEXT LP1
	  ErrorGlobal(IV) = SQR(ErrorKri) / NBL1
	
	  PRINT #2, " "
	  PRINT #2, " "
	  PRINT #2, "RESULTADOS DE LA VARIABLE "; Nam$(IV)
	  PRINT #2, USING "& #.#####"; "VARIANCIA DE LAS MUESTRAS EN LAS CELDAS (z) = "; Sig2z
	  PRINT #2, " "

	  'Si ECO>0 se alamacena el anlisis de la variable
	  IF ECO > 0 THEN
		FOR LP1 = 1 TO NY
		 IND1 = NY - (LP1 - 1)
		 IFIN = NX * NY - (LP1 - 1)
		 FOR IPOS = IND1 TO IFIN STEP NY
			PRINT #2, USING "#.###### "; ValorKri(IPOS, IV);
		 NEXT IPOS
		 PRINT #2, " Zk"
		 FOR IPOS = IND1 TO IFIN STEP NY
			PRINT #2, USING "#.###### "; VarKri(IPOS, IV);
		 NEXT IPOS
		 PRINT #2, " k"
		 FOR IPOS = IND1 TO IFIN STEP NY
			PRINT #2, USING "#.###### "; DesvStdKri(IPOS, IV);
		 NEXT IPOS
		 PRINT #2, " k"
		 FOR IPOS = IND1 TO IFIN STEP NY
			PRINT #2, USING "#.###### "; RadioBusq(IPOS);
		 NEXT IPOS
		 PRINT #2, " Radio"
		 FOR IPOS = IND1 TO IFIN STEP NY
			PRINT #2, USING "######## "; NumMues(IPOS);
		 NEXT IPOS
		 PRINT #2, " Datos Utilizados"
		 PRINT #2, " "
		NEXT LP1
	  END IF

	  PRINT #2, USING "& \       \ & ##.######"; "EL ERROR GLOBAL DE LA VARIABLE "; Nam$(IV); " ES DE "; ErrorGlobal(IV)
	  PRINT #2, "SE EMPLEARON "; NBL1; " CELDAS"
	  
	  
	  IF IV > 1 THEN
		Nam$(1) = Nam$(IV)
	  END IF
	
	 NEXT IV
	
	 'Pausa
	  SLEEP 2
	
	 'Se cierran los archivos abiertos
	  CLOSE
	
	 'Regreso a modo texto
	 SCREEN 0
	 CLS
	 VIEW PRINT
	 CALL opciones(archivo$)

 'Subrutina para deteccin de errores
PROCERROR: SELECT CASE ERR
		    CASE 53: LOCATE 23, 30:  COLOR 31, 0: PRINT "NO EXISTE EL ARCHIVO"; : BEEP: LOCATE 23, 11, 0: COLOR 15, 4: PRINT STRING$(80, 32):
UU:                    LOCATE 24, 8
				   INPUT "TECLEE NOMBRE DE ARCHIVO-DATOS (SIN PUNTO NI EXTENSION)"; archivo$:
				   IF archivo$ = "" THEN BEEP: CONTAD = CONTAD + 1: IF CONTAD = 3 THEN GOTO UU
				   'Archivos de 8 caracteres
				   IF LEN(archivo$) > 8 THEN BEEP: GOTO UU
				   archivo$ = archivo$ + ".REG"
				   COLOR 15, 0
				   RESUME
		 END SELECT
		 'Se cierran los archivos abiertos
		 CLOSE
		 'Regreso a modo texto
		 SCREEN 0: CLS : VIEW PRINT
		 CALL opciones(archivo$)

SUB apuntador (FIRST%, LAST%, DX%, Y%, FLAG1%)

 'Subprograma para control de seleccin de opciones en pantalla

   'ENTRADA:
	 'FIRST% = Valor mnimo o inicial de la coord. X del cursor (rengln),
			'el valor asciende de la parte sup. a la inferior del  moni-
			'tor.
	 ' LAST% = Valor mximo o final de la coord. X del  cursor  (rengln),
			'el valor se incrementa de la parte izq. a  la  derecha  del
			'monitor.
		 'NOTA: [LAST% - FIRST%] + 1 = nm. de alternativas de trabajo.
	 '   DX% = Valor que modifica la posicin inicial del cursor.
	 '    X% = Coord. X donde aparecera el cursor { FIRST% + DX% }
	 '    Y% = Coord. Y (ordenada o columna) donde aparecera el cursor.

   'SALIDA:
	 'FLAG1% = Valor nulo en la entrada y de la alternativa en la salida.

  '
 
	'Coordenada X del cursor
	  X% = FIRST% + DX%

	'Despliegue de barra de ayuda
	  LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);
	  LOCATE 24, 24: PRINT "USE LAS TECLAS < ,  > PARA MOVERSE": COLOR 15, 0
    
	'Se define visibilidad, tamao y posicin del cursor
	  LOCATE X%, Y%, 1, 0, 7
    
	'Se asigna el valor de una tecla a una variable alfanumrica
a10:   ANS$ = INKEY$
	  IF ANS$ = "" THEN GOTO a10
	 
	  'Se teclea la flecha de desplazamiento hacia bajo
	  IF ANS$ = CHR$(0) + CHR$(80) THEN
		'Nueva coordenada X (rengln)
		IF X% < LAST% THEN
		   'Incremento
		   X% = X% + 1
		ELSE
		   'Posicin inicial
		   X% = FIRST%
		END IF
	  END IF
  
	  'Se teclea la flecha de desplazamiento hacia arriba
	  IF ANS$ = CHR$(0) + CHR$(72) THEN
		'Nueva coordenada X (rengln)
		IF X% > FIRST% THEN
		   'Decremento
		   X% = X% - 1
		ELSE
		   'Posicin final
		   X% = LAST%
		END IF
	  END IF
    
	'Se invoca la subrutina de lectura de letreros para la barra de ayuda
	  CALL letreros(X%)
    
	'Se despliega el cursor en las coordenadas actuales
	  LOCATE X%, Y%
    
	'Si no se oprime < ENTER > se contina el proceso
	  IF ANS$ <> CHR$(13) THEN GOTO a10

	'Se asigna a la variable FLAG% el valor de la alternativa elegida en
	'funcin de su posicin
	  FLAG1% = CSRLIN
	  FLAG1% = FLAG1% - (FIRST% - 1)

	'Se redefine la visibilidad y el tamao del cursor
	  LOCATE , , 0, 5, 6

END SUB

FUNCTION Big (D(), N) STATIC
  
 'Funcin que selecciona al mayor elemento
   DIM D(400)
   Big = D(1)
   FOR K = 2 TO N
	  IF D(K) > D(1) THEN
		Big = D(K)
	  END IF
   NEXT

END FUNCTION

FUNCTION CoVar (X, Y, XC, YC, DX, DY, CO, Range, Sill, TipoModelo$) STATIC
   
'Funcin para calcular covariancia
   
    DIM XF(16), YF(16)
    K = 0
    SumG = 0!
    FOR I = 1 TO 4
	   FOR J = 1 TO 4
		  K = K + 1
		  XF(K) = XC + (I - 3) * DX / 4! + DX / 8!
		  YF(K) = YC + (J - 3) * DY / 4! + DY / 8!
		  SumG = SumG + GamaBarra(X, XF(K), Y, YF(K), CO, Range, Sill, TipoModelo$)
	    NEXT J
    NEXT I
    CoVar = SumG / 16!
   
END FUNCTION

SUB DistNormal (Mu, Sigma, MuDatos, SigmaDatos, MuBloque, SigmaBloque, A$) STATIC

'Subrutinas de clculos estadsticos
   
    DIM xMu(40), yMu(40), xMu2(40), yMu2(40), xMu3(40), yMu3(40)
   
    IF tipo$ = "VGA" THEN
	  COLOR 3, 0
	  LOCATE 8, 41: PRINT USING "& \       \    &      &     &"; "Variable:"; A$; ""; ""; "/"
    ELSE
	  LOCATE 8, 41: PRINT USING "& \       \   &  & &"; "Variable:"; A$; "Mu"; "D.Est."; "D.E./Mu"
    END IF
    LOCATE 9, 41: PRINT USING "&  #.###  #.###  #.###"; "Total de datos    "; MuDatos; SigmaDatos; SigmaDatos / MuDatos
   
    'Proteccin contra errores de overflow en bloques sin dato
    IF MuBloque = 0 THEN
	  SigmaBloqueMuBloque = 0
    ELSE
	  SigmaBloqueMuBloque = SigmaBloque / MuBloque
    END IF
    IF tipo$ = "VGA" THEN COLOR 2, 0
    LOCATE 10, 41: PRINT USING "&  #.###  #.###  #.###"; "Datos del bloque  "; MuBloque; SigmaBloque; SigmaBloqueMuBloque
   
    'Proteccin contra errores de overflow en bloques sin dato
    IF Mu = 0 THEN
	  SigmaMu = 0
    ELSE
	  SigmaMu = Sigma / Mu
    END IF
   
    IF tipo$ = "VGA" THEN COLOR 14, 0
    LOCATE 11, 41: PRINT USING "&  #.###  #.###  #.###"; "Estim. con Kriging"; Mu; Sigma; SigmaMu
    IF tipo$ = "VGA" THEN COLOR 15, 0
   
    'Proteccin contra errores de overflow en bloques sin dato
    IF MuBloque = 0 OR Mu = 0 THEN EXIT SUB
   
    'Ventana para curvas de distribucin
    IF tipo$ = "VGA" THEN SCREEN 9: VIEW (340, 180)-(590, 300), , 15
    CLS

    Pi = 3.1592654#
    NumPuntos = 30
    Veces = 4!
   
    LimIA = Mu - Veces * Sigma
    LimSA = Mu + Veces * Sigma
    DeltaXA = (LimSA - LimIA) / NumPuntos

    LimIB = MuDatos - Veces * SigmaDatos
    LimSB = MuDatos + Veces * SigmaDatos
    DeltaXB = (LimSB - LimIB) / NumPuntos

    LimIC = MuBloque - Veces * SigmaBloque
    LimSC = MuBloque + Veces * SigmaBloque
    DeltaXC = (LimSC - LimIC) / NumPuntos

    YA = 1! / SQR(2! * Pi * Sigma)
    YB = 1! / SQR(2! * Pi * SigmaDatos)
    YC = 1! / SQR(2! * Pi * SigmaBloque)
    MaxSigma = YA
    IF MaxSigma < YB THEN
	  MaxSigma = YB
    END IF
    IF MaxSigma < YC THEN
	  MaxSigma = YC
    END IF

    J = 0
    FOR I = LimIA TO LimSA STEP DeltaXA
	   J = J + 1
	   yMu(J) = YA * EXP(-((I - Mu) ^ 2) / (2! * Sigma ^ 2))
	   xMu(J) = I
    NEXT
    J = 0
    FOR I = LimIB TO LimSB STEP DeltaXB
	   J = J + 1
	   yMu2(J) = YB * EXP(-((I - MuDatos) ^ 2) / (2! * SigmaDatos ^ 2))
	   xMu2(J) = I
    NEXT
    J = 0
    FOR I = LimIC TO LimSC STEP DeltaXC
	   J = J + 1
	   yMu3(J) = YC * EXP(-((I - MuBloque) ^ 2) / (2! * SigmaBloque ^ 2))
	   xMu3(J) = I
    NEXT

    xMin = LimIA
    IF LimIB < xMin THEN
	  xMin = LimIB
    END IF
    IF LimIC < xMin THEN
	  xMin = LimIC
    END IF
   
    xMax = LimSA
    IF LimSB > xMax THEN
	  xMax = LimSB
    END IF
    IF LimSC > xMax THEN
	  xMax = LimSC
    END IF

    yMax = yMu(1)
    yMin = yMu(1)
    FOR I = 2 TO NumPuntos
	   IF yMu(I) > yMax THEN yMax = yMu(I)
	   IF yMu(I) < yMin THEN yMin = yMu(I)
    NEXT
   
    WINDOW (.95 * xMin, 0)-(1.05 * xMax, MaxSigma)
   
    LINE (.95 * xMu(1), 0)-(xMu(1), 0), 14
    FOR I = 1 TO NumPuntos
	   LINE -(xMu(I), yMu(I)), 14
    NEXT
    LINE (Mu, yMin)-(Mu, yMax), 14
    LINE (Mu, .6 * yMax)-(Mu + Sigma, .6 * yMax), 14

    LINE (.95 * xMu2(1), 0)-(xMu2(1), 0), 3
    FOR I = 1 TO NumPuntos
	   LINE -(xMu2(I), yMu2(I)), 3
    NEXT
   
    LINE (.95 * xMu3(1), 0)-(xMu3(1), 0), 2
    FOR I = 1 TO NumPuntos
	   LINE -(xMu3(I), yMu3(I)), 2
    NEXT
    
   IF tipo$ = "VGA" THEN
	 COLOR 14, 0: LOCATE 23, 58: PRINT "": COLOR 15, 0
   ELSE
	 LOCATE 17, 19: PRINT "Mu"
   END IF

END SUB

SUB enrolla

  'Subrutina que despliega una cortina para presentacin de ttulos

   'Creacin de la cortina
	CLS
	VIEW PRINT
	COLOR 3, 1
	  FOR AR = 8 TO 70
		 FOR RA = 4 TO 21
			COLOR 7
			  LOCATE RA + 1, AR + 1: PRINT ""
			COLOR 3
			  LOCATE RA, AR: PRINT ""
	  NEXT RA, AR

   'Letreros
	COLOR 0, 3
	  LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
	  LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
	  LOCATE 13, 28: PRINT "C A P I T U L O   I I I"
	  LOCATE 17, 24: PRINT "PROGRAMA DEL METODO DE ESTIMACION"
	  LOCATE 18, 36: PRINT "DE KRIGING"
	COLOR 31, 0
	  LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
 
   'Pausa de 2.5 segundos
	SLEEP 2.5

END SUB

FUNCTION Fll (Ele, A) STATIC
	
	 Res = 1! / SQR(2!)
	 Coc = Ele / A
	 IF Coc <= Res THEN
	    Fll = .7821 * Coc - .08917 * Coc ^ 3
	 ELSE
	    Fll = 0!
	 END IF
END FUNCTION

FUNCTION GamaBarra (X1, X2, Y1, Y2, Nugget, Range, Sill, TipoModelo$) STATIC
    
'Funcin para eleccin del tipo de modelo
	
	 C0 = Nugget
	 C1 = Sill
	 A1 = Range
	 D = SQR((X1 - X2) ^ 2 + (Y1 - Y2) ^ 2)
	 IF TipoModelo$ = "ESFERICO" THEN
	    GamaBarra = C0 + GamEsf(C1, A1, D)
	 ELSEIF TipoModelo$ = "EXPONENCIAL" THEN
		GamaBarra = C0 + GamExp(C1, A1, D)
	 ELSEIF TipoModelo$ = "GAUSSIANO" THEN
		GamaBarra = C0 + GamGau(C1, A1, D)
	 ELSEIF TupeModel$ = "LINEAL" THEN
		GamaBarra = C0 + GamLin(C1, D)
	 ELSEIF TipoModelo$ = "LOGARITMICO" THEN
		GamaBarra = C0 + GamLog(D)
	 END IF
	
END FUNCTION

FUNCTION GamEsf (C, A, H) STATIC

'Funcin para modelo esfrico
	
	 IF H <= A THEN
	    GamEsf = C * (1.5 * H / A - .5 * (H / A) ^ 3)
	 ELSE
	    GamEsf = C
	 END IF

END FUNCTION

FUNCTION GamExp (C, A, H) STATIC

'Funcin para modelo exponencial
	
	 IF H <= A THEN
	    GamExp = C * (1! - EXP(-H / A))
	 ELSE
	    GamExp = C
	 END IF

END FUNCTION

FUNCTION GamGau (C, A, H) STATIC

'Funcin para modelo Gaussiano
	
	 IF H <= A THEN
	    GamGau = C * (1! - EXP(-H ^ 2 / A ^ 2))
	 ELSE
	    GamGau = C
	 END IF
	
END FUNCTION

FUNCTION GamLin (Slope, H) STATIC

'Funcin para modelo lineal
	  
	   GamLin = Slope * H

END FUNCTION

FUNCTION GamLog (H) STATIC

'Funcin para modelo logartmico
	
	 GamLog = LOG(H)

END FUNCTION

SUB letreros (X%)
  
 'Se invoca la subrutina de lectura de letreros para la barra de ayuda

 'Barra
 LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);
 
 SELECT CASE X%
	 CASE 11: LOCATE 24, 8: PRINT "LEE UN ARCHIVO (PREVIAMENTE CREADO) EN EL PATRON DE BUSQUEDA ACTUAL"
	 CASE 12: LOCATE 24, 15: PRINT "EJECUCION DEL METODO CON LOS DATOS DEL ARCHIVO ELEGIDO"
	 CASE 13: LOCATE 24, 29: PRINT "F I N    D E    S E S I O N"
 END SELECT

 COLOR 15, 0

END SUB

SUB Mapa (XC, YC, XCen, YCen, NX, NY, PasX, PasY, X(), Y(), Ndat, Radio, Ind(), NMuestras, XCenAnt, YCenAnt, RadioAnt, Indix) STATIC

'Subrutina para creacin de malla de puntos

 IF tipo$ = "VGA" THEN
    SCREEN 9
    VIEW (1, 1)-(310, 170), , 1
 ELSE
    SCREEN 2
    VIEW (1, 1)-(310, 120), , 1
 END IF
 WINDOW (XC, YC)-(XC + NX * PasX, YC + NY * PasY)
 CLS

 FOR I = XC TO XC + NX * PasX STEP PasX
	LINE (I, 0)-(I, YC + NY * PasY)
 NEXT
 FOR I = YC TO YC + NY * PasY STEP PasY
	LINE (0, I)-(XC + NX * PasX, I)
 NEXT

 CIRCLE (XCen, YCen), .02, 2
 LINE (XCen - PasX / 2, YCen - PasY / 2)-(XCen + PasX / 2, YCen + PasY / 2), 3, BF
 CIRCLE (XCen, YCen), Radio, 2

 XCenAnt = XCen
 YCenAnt = YCen
 RadioAnt = Radio

 FOR K = 1 TO Ndat
	I = X(K): J = Y(K)
	CIRCLE (I, J), .02
 NEXT

 FOR K = 1 TO NMuestras
	I = X(Ind(K))
	J = Y(Ind(K))
	CIRCLE (I, J), .06, 14
  NEXT

 END SUB

SUB marco (reni%, renf%, coli%, colf%, tipo%, ci%, cf%)

 'Subprograma que genera un marco

   'reni%, renf%-- Rengln inicial y final del recuadro
   'coli%, colf%-- Columna inicial y final del recuadro
   'tipo%       -- 1 para lnea sencilla, 2 para doble y 3 para semi-gruesa
   'ci%, cf%    -- Color inicial (recuadro) y final

   'Caractersticas del marco (tipo de lnea)
   SELECT CASE tipo%
		CASE 1
			'lnea sencilla
			esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
			lhi$ = "": eid$ = ""
		CASE 2
			'lnea doble
			esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
			lhi$ = "": eid$ = ""
		CASE 3
			'lnea semi-gruesa
			esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
			lhi$ = "": eid$ = ""
   END SELECT

   'Se despliega el recuadro
   COLOR ci%
	LOCATE reni%, coli%: PRINT esi$
	LOCATE reni%, colf%: PRINT esd$
	LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
	FOR I% = reni% + 1 TO renf%
	    LOCATE I%, coli%: PRINT lv$
	    LOCATE I%, colf%: PRINT lv$
	NEXT I%
	LOCATE renf%, coli%: PRINT eii$
	LOCATE renf%, colf%: PRINT eid$
	LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%

END SUB

FUNCTION Max0 (I, J) STATIC
	
	 IF I < J THEN
	    Max0 = J
	 ELSE
	   Max0 = I
	 END IF

END FUNCTION

FUNCTION Min0 (I, J) STATIC
	
	 IF I < J THEN
	    Min0 = I
	 ELSE
	    Min0 = J
	 END IF

END FUNCTION

SUB MuSigma (Nd, IV, T(), Mu, Sigma) STATIC
  
 'Subrutinas de clculos estadsticos
	
	 Test = 0!
	 U = 0
	 V = 0
	 N = 0

	 VMin = T(1, IV)
	 VMax = T(1, IV)
	 FOR I = 1 TO Nd
		VR1 = T(I, IV)
		IF VR1 <= Test GOTO 14
		U = U + VR1
		N = N + 1
		V = V + VR1 * VR1
		IF (VMax - VR1) * (VR1 - VMin) >= 0! GOTO 14
		IF VR1 > VMax THEN
		   VMax = VR1
		ELSE
		   VMin = VR1
		END IF
14 :
	 NEXT I
	
	 V = (V - U * U / Max0(1, N)) / Max0(1, N)
	 U = U / Max0(1, N)
	 Mu = U
	 Sigma = SQR(V)

END SUB

SUB opciones (archivo$)

 'Subrutina que facilita una seleccin de alternativas con el cursor como
 'apuntador

  '-------------- Despliegue grfico de opciones maestras -------------------

p10: CLS
    'Se invoca a la subrutina que genera un marco
	 CALL marco(9, 15, 21, 58, 3, 6, 15)
  
    COLOR 15, 6
	 LOCATE 9, 32:  PRINT " MENU PRINCIPAL "
    COLOR 15, 0
    LOCATE 11, 26: PRINT "_ Leer archivo de datos."
    LOCATE 12, 26: PRINT "_ Ejecutar Mtodo de Kriging."
    LOCATE 13, 26: PRINT "_ Trmino de la sesin."
  
    'Control de seleccin de opciones en pantalla
	 CALL apuntador(11, 13, 0, 26, FLAG1%)
	 SOUND 450, 4
  
    'Designacin de alternativa
	 ON FLAG1% GOSUB p20, p30, p40

p20: 'Opcin 1 (lectura de archivos)
	 CLS
	 CONTAD = 0
	 SHELL ("A:\")
	 SHELL ("CD \CAP3")
	 SHELL ("DIR/W *.REG")
	 VIEW PRINT
U:    'Despliegue de barra de texto
	  LOCATE 23, 24: COLOR 15, 2: PRINT STRING$(80, 32);
	  LOCATE 24, 2: INPUT "Elija archivo de datos (sin punto ni extensin) "; archivo$
	  COLOR 15, 0
	  IF archivo$ = "" THEN BEEP: CONTAD = CONTAD + 1: IF CONTAD = 3 THEN GOTO p10 ELSE GOTO U
	  'Archivos de 8 caracteres
	  IF LEN(archivo$) > 8 THEN BEEP: GOTO U
	  archivo$ = UCASE$(archivo$) + ".REG"
	  'Se abre archivo para lectura
	  OPEN archivo$ FOR INPUT AS #1
	 
	  GOTO p10

p30: 'Opcin 2 (efectuar mtodo de Kriging)
	 CLS
	  'Previamente debe elegirse un archivo
	  IF archivo$ = "" THEN BEEP:  GOTO p10
	  EXIT SUB
	  GOTO p10

p40: 'Opcin 3
	 CLS
	 'Se invoca a la subrutina que genera un marco
	  CALL marco(22, 24, 52, 70, 3, 22, 0)
	 
	  COLOR 31, 0
	    LOCATE 23, 54
	    PRINT " FIN DE SESION "
	  COLOR 15, 0
    
	  'Se redefinen las caractersticas del cursor
	   LOCATE , , 0
    
	  END

END SUB

FUNCTION Small (AB(), N, Test) STATIC
	
	 DIM AB(400)
	 J = 0
	 FOR I = 1 TO N
		IF A(I) <= Test THEN
		   J = J + 1
		   AB(J) = A(I)
		 END IF
	 NEXT
	 AMin = AB(1)
	 FOR K = 2 TO J
		IF AB(K) < AMin THEN
		   AMin = AB(K)
		END IF
	 NEXT
	 Small = AMin

END FUNCTION

SUB SolveSystem (XX(), A(), B(), M, N, KTilt) STATIC
    
'Solucin del sistema de ecuaciones generado en el mtodo
	
	 IF M <= 0 THEN
	    KTilt = -1
	    EXIT SUB
	 END IF
	 IF M > 1 GOTO 21
	 IF A(1) = 0! THEN
	    KTilt = 1
	    EXIT SUB
	 END IF
	 FOR I = 1 TO N
		XX(I) = B(I) / A(1)
	 NEXT I
	 KTilt = 0
	 EXIT SUB

' ------------------------  INICIALIZA

21 : TOL = .01
	KTilt = 0
	NN = M * (M + 1) / 2
	NM = N * M
	M1 = M - 1
	KK = 0
	NV = 1

' ------------------------  INICIA LA TRIANGULACION

	 FOR K = 1 TO M1
		KK = KK + K
		AK = A(KK)
		IF AK = TOL THEN
		   KTilt = K
		   EXIT SUB
		END IF
		KM1 = K - 1
		FOR IV = 1 TO NV
		    NM1 = NM * (IV - 1)
		    II = KK + NN * (IV - 1)
		    'El siguiente loop se incluy despus
		    IF A(II) = 0 THEN GOTO loopiv
		    PIV = 1! / A(II)
		    LP = 0
		    FOR I = K TO M1
			   LL = II
			   II = II + I
			   R = A(II) * PIV
			   LP = LP + 1
			   IJ = II - KM1
			  FOR J = I TO M1
				 IJ = IJ + J
				 LL = LL + J
				 A(IJ) = A(IJ) - R * A(LL)
			  NEXT J
			  FOR LLB = K TO NM STEP M
				 IN = LLB + LP + NM1
				 LL1 = LLB + NM1
				 B(IN) = B(IN) - R * B(LL1)
			  NEXT LLB
		    NEXT I
loopiv:
		NEXT IV
	 NEXT K
	 IJM = IJ - NN * (NV - 1)
	 IF A(IJM) = TOL THEN
	    KTilt = M
	    EXIT SUB
	 END IF
	 FOR IV = 1 TO NV
		NM1 = NM * (IV - 1)
		IJ = IJM + NN * (IV - 1)
		PIV = 1! / A(IJ)
		FOR LLB = M TO NM STEP M
		    LL1 = LLB + NM1
		    XX(LL1) = B(LL1) * PIV
		NEXT LLB
		I = M
		KK = IJ
		FOR II = 1 TO M1
		    KK = KK - I
		'El siguiente if se incluy despus
		 IF A(KK) = 0 THEN GOTO loopII
		 PIV = 1! / A(KK)
		 I = I - 1
		 FOR LLB = I TO NM STEP M
			LL1 = LLB + NM1
			IN = LL1
			R = B(IN)
			IJ = KK
			FOR J = I TO M1
			    IJ = IJ + J
			    IN = IN + 1
			    R = R - A(IJ) * XX(IN)
			NEXT J
			XX(LL1) = R * PIV
		 NEXT LLB
loopII:
	 NEXT II
	 NEXT IV
	 EXIT SUB

END SUB

SUB SumaPesos (XX(), N) STATIC
   
    SumaX = 0!
    FOR I = 1 TO N
	  SumaX = SumaX + XX(I)
    NEXT I

END SUB

SUB Texto (XCen, YCen, I, Radio, Indix)

  'Textos
   
    LOCATE 1, 41: PRINT "Las coord. del centro de la celda  son"
    LOCATE 2, 51: PRINT "X="; XCen; " Y="; YCen
    LOCATE 3, 41: PRINT "Para estimar el valor promedio  de  la"
    LOCATE 4, 41: PRINT USING "& ##"; "variable en la celda se utilizaron "; I;
    LOCATE 5, 41: PRINT USING "& ##.### &"; "datos dentro de un radio de "; Radio; " Kms"
    LOCATE 6, 41: PRINT USING "& ###"; "Celda Nm. "; Indix

END SUB

