
  'Programa fuente para aproximacin polinomial mediante la subrutina SVD
        'modelo:  Y = C(1) + C(2) X + C(3) X^2 + ... + C(M) X^Gp"
     
      'Versin 1.0 (programa fuente creado por J. Antonio Ruiz G., 1992)

    DEFINT G, I-N
    DEFDBL A, R-W
    DECLARE SUB asciival (X!)
    DECLARE SUB borrado (coorx!, coory!, dato!)
    DECLARE SUB centra (posx!, Title$)
    DECLARE SUB enrolla ()
    DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
    DECLARE SUB svd (NM, M, N, A(), W(), MATU, U(), MATV, V(), IERR, RV1())
                   
    'Cursor invisible
     LOCATE , , 0

    'Se invoca a la subrutina que genera una pantalla de presentacin
     CALL enrolla
   
    'Cursor visible
    LOCATE , , 1
   
    'Inicia el proceso
    DO
      'Se designa el rea visual de trabajo y se la asigna color
f1:     CLEAR
        VIEW PRINT
        COLOR 7, 9, 9
        CLS
        BEEP
        
      'Invocando a la subrutina que genera un marco
        CALL marco(1, 4, 3, 78, 10, 15)
        COLOR 0, 7
          LOCATE 24, 25: PRINT " TECLEE < ESC > PARA TERMINAR "
        COLOR 7, 9
     
      'Captura del nmero de datos
        DO
          LOCATE 6, 10: PRINT "Nmero (M) de datos (M > 1) ? ";
          'Coordenadas del cursor
            coorx = CSRLIN: coory = POS(0)
          'Subrutina para captura
            CALL asciival(dato)
          'Cambio de variable, (dato es real y M es entera)
            M = dato
          IF M <= 1 THEN
             SOUND 200, 7
             'Subrutina para borrado de cadenas capturadas
               CALL borrado(coorx, coory, dato)
          END IF
        LOOP WHILE M <= 1
     
      'Captura del grado de la funcin
f2:     DO
          LOCATE 7, 10: PRINT "Grado (Gp) del polinomio de aprox. (mximo grado = M-1) ? ";
          'Coordenadas del cursor
            coorx = CSRLIN: coory = POS(0)
          'Subrutina para captura
            CALL asciival(dato)
          'Cambio de variable, (dato es real y Gp es entera)
            Gp = dato
          'El nm. de coef. de la funcin de aprox. = Gp + 1
            N = Gp + 1
          IF N > M OR N <= 0 OR Gp <= 0 THEN
             SOUND 200, 7
             'Subrutina para borrado de cadenas capturadas
               CALL borrado(coorx, coory, dato)
          END IF
        LOOP WHILE N > M OR N <= 0 OR Gp <= 0
         
      'Si op=2 : clculo con nuevo grado del polinomio
        IF op$ = "2" THEN GOTO f3
     
      'Mximo valor entre N y M
        IF N > M THEN NM = N ELSE NM = M
     
      'Se dimensionan los vectores y matrices involucrados
        DIM A(NM, N), SIGMA(N), U(NM, M), V(NM, N), WORK(M), T(M), Y(M)
     
      'Se genera la matriz de diseo
        LOCATE 9, 15: PRINT "Datos :"
        FOR I = 1 TO M
           'Abscisas de los puntos dato
            LOCATE 9 + I, 21: PRINT "X ("; I; ") = ";
              'Subrutina para captura
              CALL asciival(dato)
              'Cambio de variable, (dato es real y T(I) de doble precisin
              T(I) = dato
            'Ordenadas de los puntos dato
            LOCATE 9 + I, 46: PRINT "Y ("; I; ") = ";
              'Subrutina para captura
              CALL asciival(Y(I))
           'Clculo de la j-sima funcin base evaluada en T(I), en este
           'programa se considera una aprox. polinomial
            A(I, 1) = 1!
            FOR J = 2 TO N
                A(I, J) = T(I) * A(I, J - 1)
        NEXT J, I
     
f3:   COLOR 31
        LOCATE 24, 25, 0: PRINT "  EFECTUANDO   CALCULOS   ...  ";
      COLOR 7
     
      'Se invoca a SVD
        CALL svd(NM, M, N, A(), SIGMA(), 1, U(), 1, V(), IERR, WORK())
     
      'Deteccin de error en SVD
        IF IERR <> 0! THEN
           SOUND 700, 6: SOUND 500, 3
           COLOR 31
             LOCATE 20, 27, 0: PRINT "ERROR ENCONTRADO POR SVD ..."
           COLOR 7
           GOTO f20
        END IF
     
      CLS
      'Invocando a la subrutina que genera un marco
        CALL marco(1, 4, 3, 78, 10, 15)
        COLOR 0, 7
          LOCATE 24, 25: PRINT " TECLEE < ESC > PARA TERMINAR "
        COLOR 7, 9
        BEEP
     
      'Bsqueda del mximo y mnimo valor singular y deteccin de los
      'valores despreciables, adems,  se  inicializa  el  vector  de
      'coeficientes
        SIGMAMAX = 0!
        SIGMAMIN = SIGMA(1)
        FOR J = 1 TO N
            IF SIGMA(J) > SIGMAMAX THEN SIGMAMAX = SIGMA(J)
            IF SIGMA(J) < SIGMAMIN THEN SIGMAMIN = SIGMA(J)
            C(J) = 0!
        NEXT
     
      'Nmero de condicin = mx/mn
        cond = SIGMAMAX / SIGMAMIN
        LOCATE 6, 10: PRINT "Nmero de condicin de la matriz de datos = "; cond
     
      'Se proporciona un error de tol. y se calcula el error absoluto (TAU)
        RELERR = .001
        TAU = RELERR * SIGMAMAX
     
      'Se calcula el vector de coeficientes C(J), de acuerdo a:  V c = U y
        FOR J = 1 TO N
            IF SIGMA(J) <= TAU THEN GOTO f10
            S = 0!
            FOR I = 1 TO M
                'Se evala y'= U^t y
                S = S + U(I, J) * Y(I)
            NEXT I
            'Se evala c'= ^-1 y'
            S = S / SIGMA(J)
            FOR I = 1 TO N
                'Se evala c = V c'
                C(I) = C(I) + S * V(I, J)
            NEXT I
f10:    NEXT J
     
      'Coeficientes del modelo
        LOCATE 8, 1: PRINT "El modelo es:"
        LOCATE 9, 1: PRINT "Y = ";
        FOR I = 1 TO N
            PRINT USING "+####.####"; C(I);
            IF I = 1 THEN PRINT " ";
            IF I = 2 THEN PRINT " X";
            IF I > 2 THEN PRINT " X^"; I - 1;
        NEXT
     
      'Se obtiene la raz cuadrada de la suma del cuadrado de los errores
      'residuales
        RSQ = 0!
        FOR I = 1 TO M
            RI = 0!
            FOR J = 1 TO N
                RI = RI + C(J) * A(I, J)
            NEXT J
            RSQ = RSQ + (RI - Y(I)) ^ 2
        NEXT I
        R = SQR(RSQ)
        'Posicin del cursor
         posx = CSRLIN
         LOCATE posx + 2, 15: PRINT "Error residual incurrido = "; : PRINT USING "####.####"; R
       
      'Se evala el modelo en el punto TT (aprox. polinomial) mediante la
      'tcnica de Horner
        DO
          LOCATE posx + 4, 15, 1: PRINT "Cuntos valores desea aproximar ? ";
          'Coordenadas del cursor
            coorx = CSRLIN: coory = POS(0)
          'Subrutina para captura
            CALL asciival(dato)
          'Cambio de variable, (dato es real y K es entera)
            K = dato
          IF K < 1 THEN
             SOUND 200, 7
             'Subrutina para borrado de cadenas capturadas
               CALL borrado(coorx, coory, dato)
          END IF
        LOOP WHILE K < 1
     
      'Tcnica de Horner
        FOR KK = 1 TO K
            YY = 0!
            LOCATE posx + 6, 15: PRINT "Valor X a sustituir en el modelo ? ";
            'Coordenadas del cursor
              coorx = CSRLIN: coory = POS(0)
            'Subrutina para captura
              CALL asciival(dato)
            'Cambio de variable
              TT = dato
            'Subrutina para borrado de cadenas capturadas
              CALL borrado(coorx, coory, dato)
            FOR Jb = 1 TO N
                J = N + 1 - Jb
                YY = TT * YY + C(J)
            NEXT
            LOCATE posx + 7, 30: PRINT "Y ="; : PRINT USING "#####.####"; YY
        NEXT
      
       'Eleccin de proseguir o finalizar
         COLOR 31, 9
f20:       LOCATE 24, 25, 0: PRINT "  DESEA OTRO CALCULO (S/N) ?  ";
       'Coordenadas del cursor
         coorx = CSRLIN: coory = POS(0)

       'Captura
f30:     DO
           K$ = INKEY$
         LOOP WHILE K$ = ""
 
       'El cracter tecleado se transforma maysculas
         K$ = UCASE$(K$)

       'Se seleccion S o N?
         IF K$ = "N" THEN
            'Fin de sesin
             CLS : END
         ELSE
            IF K$ <> "S" THEN
              SOUND 500, 2
              'Borrado de un caracter sobre la lnea actual
                 LOCATE coorx, coory - 1: PRINT "   "
              GOTO f30
           END IF
         END IF
        
         LOCATE 24, 10: PRINT "Nuevos datos (1) o cambio de grado en la funcin (2) ? ";
         'Coordenadas del cursor
           coorx = CSRLIN: coory = POS(0)
f40:     DO
           op$ = INKEY$
         LOOP WHILE op$ = ""
         
         'Se seleccion un nmero?
          IF op$ <> "1" AND op$ <> "2" THEN
             SOUND 500, 2
             'Borrado de un caracter sobre la lnea actual
                LOCATE coorx, coory - 1: PRINT "   "
             GOTO f40
           END IF
        
         'Nuevos datos o nuevo grado del polinomio
         LOCATE , , 1
         IF op$ = "1" THEN
            GOTO f1
         ELSE
            CLS
            'Invocando a la subrutina que genera un marco
            CALL marco(2, 4, 3, 78, 10, 15)
            GOTO f2
         END IF
     
    LOOP
   

DEFSNG G
SUB asciival (X)

 'Subrutina para captura y discriminacin de caracteres numricos

1  'Captura del primer dgito
     DO
       K$ = INKEY$
     LOOP WHILE K$ = ""
 
   'Traslado a cdigo ASCII del primer dgito
     qy = ASC(RIGHT$(K$, 1))
 
   'Accin a seguir en funcin de la tecla oprimida
     SELECT CASE qy
            CASE 13  'Enter
               'Se asigna el valor de cero
                 entrada$ = CHR$(48)
                 X = VAL(entrada$)
          
            CASE 27  'escape
               'Salida
                 CLS
                 END
             
            CASE 45 TO 57  'Nmeros y signos
               'Traslado a cadena del primer dgito
                 entrada$ = CHR$(qy)
                 PRINT entrada$;
               'Captura de los dgitos subsecuentes
2                DO
                   ky$ = INKEY$
                 LOOP WHILE ky$ = ""
               'Traslado a cdigo ASCII
                 kz = ASC(RIGHT$(ky$, 1))
               'Accin a seguir en funcin de las teclas subsecuentes
                 SELECT CASE kz
                        CASE 8 'Correccin de caracteres
                           'Posicin del cursor rengln y columna
                             aa = CSRLIN
                             BB = POS(0)
                           'Cuando se llega a la posicin inicial se aborta
                             IF BB = 1 THEN
                                SOUND 3700, 4
                                GOTO 2
                             END IF
                           'El ltimo caracter se reemplaza por un espacio
                           'en blanco (posicin n)
                             LOCATE aa, BB - 1: PRINT " ";
                           'Reubicacin en la posicin n-1
                             LOCATE aa, BB - 1
                           'Longitud de la cadena con espacio en blanco
                             lng = LEN(entrada$)
                           'Nueva longitud de la cadena (n-1)
                             entrada$ = LEFT$(entrada$, lng - 1)
                           GOTO 2
                      
                        CASE 13  'Enter (cantidad deseada)
                           'Asignacin de valor a la variable X
                             X = VAL(entrada$)
                      
                        CASE 27  'escape
                           'Salida
                             CLS
                             END
                      
                        CASE 45 TO 57  'Se aceptan nmeros y signos, para
                                       'conformar una cifra
                           'Se constituye una cadena
                             entrada$ = entrada$ + CHR$(kz)
                             PRINT CHR$(kz);
                             GOTO 2
                      
                        CASE ELSE  'se rechazan otros cracteres
                           SOUND 420, 5
                           GOTO 2
                 END SELECT
          
            CASE ELSE  'Caracteres no vlidos
                SOUND 420, 5
                GOTO 1
     END SELECT

END SUB

SUB borrado (coorx, coory, dato)

'Subrutina para borrar caracteres tecleados
  
   'Conversin de valor numrico a cadena
   dato$ = STR$(dato)
   'Posicionamiento en la ltima coordenada del cursor
   LOCATE coorx, coory
   'Borrado de la longitud de la cadena (caracter por caracter)
   FOR S = 1 TO LEN(dato$)
           PRINT " ";
   NEXT

END SUB

SUB centra (posx, Title$)
 
  'Subrutina para centrar textos con respecto a la pantalla
     'Coordenada "y" en base a la long. del texto y a la disponible en pantalla
     posy = INT((80 - LEN(Title$)) / 2)
     LOCATE posx, posy: PRINT Title$

END SUB

DEFSNG A, I-N, R-W
SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
 
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
 
   'Letreros
     COLOR 0, 3
       'Se invoca a la subrutina para centrado de textos
       CALL centra(7, "T E C N I C A S    A V A N Z A D A S ")
       CALL centra(9, "D E     P R O G R A M A C I O N")
       CALL centra(13, "C A P I T U L O   III")
       CALL centra(18, "Aproximacin polinomial mediante la subrutina SVD")
    
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
  
   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
 
 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%
 
   'Mensaje
     LOCATE 2, 17: PRINT "APROXIMACION POLINOMIAL USANDO LA SUBRUTINA SVD"
     LOCATE 3, 13: PRINT "MODELO:  Y = C(1) + C(2) X + C(3) X^2 + ... + C(M) X^Gp"

END SUB

DEFINT I-N
DEFDBL A, R-W
SUB svd (NM, M, N, A(), W(), MATU, U(), MATV, V(), IERR, RV1())
   
    'Esta subrutina es una transferancia del programa SVD en lenguaje ALGOL.
    'Nm. Math. 14, 403-420 (1970), Golub y Reinsch, Handbook for  Automatic
    'Comp., Vol II-Linear Algebra, 134-151 (1971).
   
    'Esta rutina determina la descomposicin de los  valores  singulares  T,
    'A=USV de una matriz rectangular de M por N, se emplea una  bidiagonali-
    'lizacin comn y una variante del algoritmo QR.
   
    'ENTRADA:
    '  NM .. Debe ser el nm. de renglones de los  arreglos  bidimensionales
    '        que se declaran en la sentencia  de  llamado  a  la  subrutina.
    '        Ntese que NM debe ser cuando menos igual al mximo  valor  en-
    '        tre M y N.
    '  M ... Es el nmero de renglones de A (y de U), esto es, el nmero  de
    '        pares de datos base.
    '  N ... Es el nmero de columnas de A (y de U) y el orden de V. Adems,
    '        representa el grado del polinomio ms 1  para  la  aproximacin
    '        funcional, es decir, el nmero de coeficientes de  tal  funcin
    '        de aproximacin.
    '  A ... Representa la matriz rectangular de entrada, que  ser  descom-
    '        puesta.
    '  MATU. Debe asignarse el valor de 1, si en la descomposicin se  desea
    '        obtener la matriz U, y el de 0 en caso contrario.
    '  MATV. Debe asignarse el valor de 1, si en la descomposicin se  desea
    '        obtener la matriz V, y el de 0 en caso contrario.
   
    'SALIDA:
    '  A ... Permanece inalterada (a no ser que se reemplace por U o V).
    '  W ... Contiene los N valores singulares (no-negativos) de A  (elemen-
    '        tos de las diagonales de S). Los cuales estn desordenados.  Si
    '        se detecta un error automticamente se realiza la salida, y los
    '        valores singulares se corregirn por los ndices IERR+1, IERR+2,
    '        ..., N.
    '  U ... Contiene la matriz U (vectores columna ortogonales) de la  des-
    '        composicin si MATU=1, en caso contrario,  se  emplea  como  un
    '        arreglo temporal. Puede coincidir con la matriz A. Si se detecta
    '        un error, automticamente se realiza la salida, y  las columnas
    '        de U multiplicadas por los ndices de  correccin  ofrecen  los
    '        valores singulares efectivos.
    '  V ... Contiene la matriz V (ortogonal) de la descomposicin s MATV=1,
    '        en caso contrario, no se calcula. Puede coincidir con la matriz
    '        A si U no se requiere. Si se detecta un error,  automticamente
    '        se realiza la salida, y las columnas de V multiplicadas por los
    '        ndices de correccin ofrecen los valores singulares efectivos.
    '  IERR. Tendr el valor:
    '                        0 .... en una ejecucin normal.
    '                        K .... s el k-simo valor singular no se ha
    '                               obtenido despus de 30 iteraciones.
    '  RV1 . Es un arreglo para almacenaje temporal.
   
      'Las interrogantes y comentarios, deben dirigirse a B. S. Garbow,
      'Applied Mathematics Division, Argonne National Laboratory.
   
    'Rutina modificada para prescindir del MACHINE EPSILON.
   
    '  ------------------------------------------------------------------
 
      IERR = 0
      FOR I = 1 TO M
          FOR J = 1 TO N
              U(I, J) = A(I, J)
          NEXT J
      NEXT I
   
    'Reduccin a la forma bidiagonal
      G = 0!
      SCALE = 0!
      ANORM = 0!
      FOR I = 1 TO N
          L = I + 1
         RV1(I) = SCALE * G
         G = 0!
         S = 0!
         SCALE = 0!
         IF I > M THEN GOTO Svd210
         FOR K = I TO M
             SCALE = SCALE + ABS(U(K, I))
         NEXT K
         IF SCALE = 0! GOTO Svd210
         FOR K = I TO M
             U(K, I) = U(K, I) / SCALE
             S = S + U(K, I) ^ 2
         NEXT K
         F = U(I, I)
         IF F >= 0! THEN G = -SQR(S) ELSE G = SQR(S)
         H = F * G - S
         U(I, I) = F - G
         IF I = N GOTO Svd190
         FOR J = L TO N
             S = 0!
             FOR K = I TO M
                 S = S + U(K, I) * U(K, J)
             NEXT K
             F = S / H
             FOR K = I TO M
                 U(K, J) = U(K, J) + F * U(K, I)
             NEXT K
         NEXT J
Svd190:  FOR K = I TO M
             U(K, I) = SCALE * U(K, I)
         NEXT K
Svd210:  W(I) = SCALE * G
         G = 0!
         S = 0!
         SCALE = 0!
         IF I > M OR I = N GOTO Svd290
         FOR K = L TO N
             SCALE = SCALE + ABS(U(I, K))
         NEXT K
         IF SCALE = 0! GOTO Svd290
         FOR K = L TO N
             U(I, K) = U(I, K) / SCALE
             S = S + U(I, K) ^ 2
         NEXT K
         F = U(I, L)
         IF F >= 0! THEN G = -SQR(S) ELSE G = SQR(S)
         H = F * G - S
         U(I, L) = F - G
         FOR K = L TO N
             RV1(K) = U(I, K) / H
         NEXT K
         IF I = M GOTO Svd270
         FOR J = L TO M
             S = 0!
             FOR K = L TO N
                 S = S + U(J, K) * U(I, K)
             NEXT K
             FOR K = L TO N
                 U(J, K) = U(J, K) + S * RV1(K)
             NEXT K
         NEXT J
Svd270:  FOR K = L TO N
             U(I, K) = SCALE * U(I, K)
         NEXT K
Svd290:  AUX = ABS(W(I)) + ABS(RV1(I))
         IF AUX > ANORM THEN ANORM = AUX
      NEXT I
   
    'Transformacin acumulativa hacia la derecha
      IF MATV = 0 GOTO Svd410
   
    'Desde I = N hasta 1 , con decrementos de - 1
      FOR II = 1 TO N
          I = N + 1 - II
          IF I = N GOTO Svd390
          IF G = 0! GOTO Svd360
          FOR J = L TO N
              'Una doble divisin protege contra un posible error de
              'underflow
                V(J, I) = (U(I, J) / U(I, L)) / G
          NEXT J
          FOR J = L TO N
              S = 0!
              FOR K = L TO N
                  S = S + U(I, K) * V(K, J)
              NEXT K
              FOR K = L TO N
                  V(K, J) = V(K, J) + S * V(K, I)
              NEXT K
          NEXT J
Svd360:   FOR J = L TO N
              V(I, J) = 0!
              V(J, I) = 0!
          NEXT J
Svd390:   V(I, I) = 1!
          G = RV1(I)
          L = I
      NEXT II
   
    'Transformacin acumulativa hacia la izquierda
Svd410: IF MATU = 0 THEN GOTO Svd510
   
    'Desde I = mn.(M,N) hasta 1 , con decrementos de - 1
      MN = N
      IF M < N THEN MN = M
      FOR II = 1 TO MN
          I = MN + 1 - II
          L = I + 1
          G = W(I)
          IF I = N GOTO Svd430
          FOR J = L TO N
              U(I, J) = 0!
          NEXT J
Svd430:   IF G = 0! GOTO Svd475
          IF I = MN GOTO Svd460
          FOR J = L TO N
              S = 0!
              FOR K = L TO M
                  S = S + U(K, I) * U(K, J)
              NEXT K
              'Una doble divisin protege contra un posible error de
              'underflow
                F = (S / U(I, I)) / G
              FOR K = I TO M
                  U(K, J) = U(K, J) + F * U(K, I)
              NEXT K
          NEXT J
Svd460:   FOR J = I TO M
              U(J, I) = U(J, I) / G
          NEXT J
          GOTO Svd490
Svd475:   FOR J = I TO M
              U(J, I) = 0!
          NEXT J
Svd490:   U(I, I) = U(I, I) + 1!
      NEXT II
   
    'Diagonalizacin de la forma bidiagonal desde K = N hasta 1 , con
    'decrementos de - 1
Svd510: FOR KK = 1 TO N
            K1 = N - KK
            K = K1 + 1
            ITS = 0!
           
            'Prueba para la particin desde L = K hasta 1 , con
            'decrementos de - 1
Svd520:         FOR LL = 1 TO K
                    L1 = K - LL
                    L = L1 + 1
                    IF ABS(RV1(L)) + ANORM = ANORM GOTO Svd565
                    'RV1(1) siempre es cero, por lo que no hay salida al
                    'final del ciclo
                      IF ABS(W(L1)) + ANORM = ANORM THEN GOTO Svd540
                NEXT LL
             
              'Cancelacin de RV1(L) s L > 1
Svd540:         C = 0!
                S = 1!
                FOR I = L TO K
                    F = S * RV1(I)
                    RV1(I) = C * RV1(I)
                    IF ABS(F) + ANORM = ANORM GOTO Svd565
                    G = W(I)
                    H = SQR(F ^ 2 + G ^ 2)
                    W(I) = H
                    C = G / H
                    S = -F / H
                    IF MATU = 0 THEN GOTO Svd560
                    FOR J = 1 TO M
                        Y = U(J, L1)
                        Z = U(J, I)
                        U(J, L1) = Y * C + Z * S
                        U(J, I) = -Y * S + Z * C
                    NEXT J
Svd560:         NEXT I
             
              'Prueba de la convergencia
Svd565:         Z = W(K)
                IF L = K GOTO Svd650
             
              'Transferencia de 2 en 2 desde la parte inferior
                IF ITS = 30 GOTO Svd1000
                ITS = ITS + 1
                X = W(L)
                Y = W(K1)
                G = RV1(K1)
                H = RV1(K)
                F = ((Y - Z) * (Y + Z) + (G - H) * (G + H)) / (2! * H * Y)
                G = SQR(F ^ 2 + 1!)
                IF F >= 0! THEN AUX = ABS(G) ELSE AUX = -ABS(G)
                F = ((X - Z) * (X + Z) + H * (Y / (F + AUX) - H)) / X
             
              'Siguiente transformacin QR
                C = 1!
                S = 1!
                FOR I1 = L TO K1
                    I = I1 + 1
                    G = RV1(I)
                    Y = W(I)
                    H = S * G
                    G = C * G
                    Z = SQR(F ^ 2 + H ^ 2)
                    RV1(I1) = Z
                    C = F / Z
                    S = H / Z
                    F = X * C + G * S
                    G = -X * S + G * C
                    H = Y * S
                    Y = Y * C
                    IF MATV = 0 THEN GOTO Svd575
                    FOR J = 1 TO N
                        X = V(J, I1)
                        Z = V(J, I)
                        V(J, I1) = X * C + Z * S
                        V(J, I) = -X * S + Z * C
                    NEXT J
Svd575:             Z = SQR(F ^ 2 + H ^ 2)
                    W(I1) = Z
                 
                  'La rotacin puede ser aleatoria si Z=0
                    IF Z = 0! THEN GOTO Svd580
                    C = F / Z
                    S = H / Z
Svd580:             F = C * G + S * Y
                    X = -S * G + C * Y
                    IF MATU = 0 THEN GOTO Svd600
                    FOR J = 1 TO M
                        Y = U(J, I1)
                        Z = U(J, I)
                        U(J, I1) = Y * C + Z * S
                        U(J, I) = -Y * S + Z * C
                    NEXT J
Svd600:         NEXT I1
                RV1(L) = 0!
                RV1(K) = F
                W(K) = X
                GOTO Svd520
             
              'Convergencia
Svd650:         IF Z >= 0! GOTO Svd700
             
              'W(K) se hace no-negativo
                W(K) = -Z
                IF MATV = 0 GOTO Svd700
                FOR J = 1 TO N
                    V(J, K) = -V(J, K)
                NEXT J
Svd700: NEXT KK
        GOTO Svd1001
     
      'Se presenta un error si no se converge hacia los valores
      'singulares en 30 iteraciones.
Svd1000: IERR = K
Svd1001: END SUB

