 
  'Programa fuente para la subrutina GAUSSQ
  
      'Versin 1.0 (programa fuente creado por J. Antonio Ruiz G., 1992)
  
   DECLARE SUB centra (posx!, Title$)
   DECLARE SUB class (KIND!, M!, ALPHA!, BETA!, B!(), A!(), MUZERO!)
   DECLARE SUB enrolla ()
   DECLARE FUNCTION FUN! (x!)
   DECLARE FUNCTION GAMMA! (valor!)
   DECLARE SUB gaussq (KIND!, N!, ALPHA!, BETA!, KPTS!, ENDPTS!(), B!(), T!(), W!())
   DECLARE SUB imtql2 (N!, D!(), E!(), Z!(), IERR!)
   DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
   DECLARE FUNCTION solve! (SHIFT!, N!, A!(), B!())
  
   'Se invoca a la subrutina que genera una pantalla de presentacin
     CALL enrolla
  
   'Inicia el proceso
   DO
  
      'Se designa el rea visual de trabajo y se la asigna color
      VIEW PRINT
      COLOR 7, 1, 1
      CLS : CLEAR
  
     'Proteccin contra errores de underflow u overflow
      ON ERROR GOTO 30
  
     'Invocando a la subrutina que genera un marco
      CALL marco(2, 4, 3, 78, 10, 7)
  
     'Dimensionando de manera dinmica y comn en funcin del nmero de puntos
      N = 4
      DIM SHARED A(N), B(N), T(N), W(N), ENDPTS(2)
  
      'Valores dato
      inc = 0
      FOR I = 1 TO N
          inc = inc + (1 / N)
          B(I) = FUN(inc)
          'PRINT "B("; I; ")="; B(I)
      NEXT
  
     'Puntos extremos
      ENDPTS(1) = FUN(0)
      ENDPTS(2) = FUN(1)

      LOCATE 6, 10: PRINT "Se evala la integral de la funcin cuya ecuacin es:"
      LOCATE 7, 30: PRINT "          b"
      LOCATE 8, 30: PRINT "f(x)=2/ a e^(-x)"
     
      'Seleccin de la cuadratura
      KIND = 4
      LOCATE 10, 30: PRINT "Cuadratura de ";
      SELECT CASE KIND
            CASE 1: PRINT "Legendre"
            CASE 2: PRINT "Chebyshev de 1er. tipo"
            CASE 3: PRINT "Chebyshev de 2do. tipo"
            CASE 4: PRINT "Hermite"
            CASE 5: PRINT "Jacobi"
            CASE 6: PRINT "Laguerre (generalizada)"
      END SELECT
    
     'Llamada a GAUSSQ
      CALL gaussq(KIND, N, 0, 0, 0, ENDPTS(), B(), T(), W())
  
     'Impresin de resultados
      LOCATE 12, 26: PRINT "NODOS T(I)      PONDERADORES W(I)"
      FOR I = 1 TO N
          LOCATE 12 + I, 25: PRINT USING "+####.####         +####.####"; T(I); W(I)
      NEXT
     
      sum1 = 0
      FOR I = 1 TO N
         sum2 = sum1 + W(I) * FUN(T(I))
         sum1 = sum2
      NEXT
      posx = CSRLIN
      LOCATE CSRLIN + 2, 32: PRINT "Resultado :"; sum2
      
       'Eleccin de proseguir o finalizar
10       LOCATE 24, 25, 0: PRINT "  DESEA OTRO CALCULO (S/N) ?  ";
       'Coordenadas del cursor
         coorx = CSRLIN: coory = POS(0)

       'Captura
20       DO
           k$ = INKEY$
         LOOP WHILE k$ = ""

       'El cracter tecleado se transforma maysculas
         k$ = UCASE$(k$)

       'Se seleccion S o N?
         IF k$ = "N" THEN
            'Fin de sesin
             CLS : END
         ELSE
            IF k$ <> "S" THEN
              SOUND 500, 2
              'Borrado de un caracter sobre la lnea actual
                 LOCATE coorx, coory - 1: PRINT "   "
              GOTO 20
           END IF
         END IF
   LOOP
  
   'Seccin de deteccin de errores (en caso de presentarse uno, el proceso
   'continuar)
30 : RESUME NEXT

DEFINT I-K, N
SUB centra (posx, Title$)
 
  'Subrutina para centrar textos con respecto a la pantalla
     'Coordenada "y" en base a la long. del texto y a la disponible en pantalla
     posy = INT((80 - LEN(Title$)) / 2)
     LOCATE posx, posy: PRINT Title$

END SUB

DEFSNG I-K, N
SUB class (KIND, M, ALPHA, BETA, B(), A(), MUZERO)
  
   'Este procedimiento proporciona los coeficientes A(J) y B(J) de la siguien
   'te ecuacin de recurrencia:
   '           B  P (X) = (X - A ) P   (X) - B    P   (X)
   '            J  J            J   J-1       J-1  J-2
   'y es vlida para la variedad clsica (normalizada) de polinomios  ortogo-
   'nales en el raz-simo momento:
   '                      MUZERO = integral W(X) DX
   'para la funcin peso, W(X), asociada al polinomio dado. Como los  polino-
   'mios son orto-normalizados, se garantiza que la matriz  tridiagonal  ser
   'simtrica. ALPHA, parmetro de entrada, se emplea nicamente por los  po-
   'linomios de Laguerre y de Jacobi; y BETA, slo por los de Jacobi. Los po-
   'linomios de Laguerre y de Jacobi requieren de la funcin GAMMA.
  
   '........................................................................
  
   PI = 3.141592653589793#
   NM1 = N - 1
   ON KIND GOTO C10, C20, C30, C40, C50, C60
  
   'KIND=1 : Polinomios de Laguerre, P(X), para (-1, 1) y W(X)=1.
C10: MUZERO = 2#
     FOR I = 1 TO NM1
         A(I) = 0#
         ABI = I
         ''B(I) = ABI / DSQRT(4 * ABI ^ 2 - 1#)
         B(I) = ABI / SQR(4 * ABI ^ 2 - 1#)
     NEXT
     A(N) = 0#
     EXIT SUB
  
   'KIND=2 : Polinomios de Chebyshev de primera clase, T(X), para (-1, 1) y
   'W(X)=1/SQRT(1-X^2).
C20: MUZERO = PI
     FOR I = 1 TO NM1
         A(I) = 0#
         B(I) = .5#
     NEXT
     ''B(1) = DSQRT(.5#)
     B(1) = SQR(.5#)
     A(N) = 0#
     EXIT SUB
  
   'KIND=3 : Polinomios de Chebyshev de segunda clase, U(X), para (-1, 1) y
   'W(X)=1/SQRT(1-X^2).
C30: MUZERO = PI / 2#
     FOR I = 1 TO NM1
         A(I) = 0#
         B(I) = .5#
     NEXT
     A(N) = 0#
     EXIT SUB
  
   'KIND=4 : Polinomios de Hermite, H(X), para (-, ) y W(X)=EXP(-X^2).
''C40: MUZERO = DSQRT(PI)
C40: MUZERO = SQR(PI)
     FOR I = 1 TO NM1
         A(I) = 0#
         ''B(I)=DSQRT(I/2.D0)
         B(I) = SQR(I / 2#)
     NEXT
     A(N) = 0#
     EXIT SUB
  
   'KIND=5 : Polinomios de Jacobi, P(ALPHA, BETA) (X), para (-1, 1), BETA y
   'ALFA mayores de -1, y W(X) = (1 - X) ^ ALPHA + (1 + X) ^ BETA.
C50: AB = ALPHA + BETA
     ABI = 2# + AB
     MUZERO = 2# ^ (AB + 1#) * GAMMA(ALPHA + 1#) * GAMMA(BETA + 1#) / GAMMA(ABI)
     A(1) = (BETA - ALPHA) / ABI
     ''B(1) = DSQRT(4.0D0*(1.0D0 + ALPHA) * (1.0D0 + BETA)/((ABI + 1#) - ABI ^ 2))
     B(1) = SQR(4# * (1# + ALPHA) * (1# + BETA) / ((ABI + 1#) - ABI ^ 2))
     A2B2 = BETA ^ 2 - ALPHA ^ 2
     FOR I = 2 TO NM1
         ABI = 2# * I + AB
         A(I) = A2B2 / ((ABI - 2#) * ABI)
         'B(I) = DSQRT(4.0D0*I*(I + ALPHA)*(I + BETA)*(I + AB)/((ABI^2 - 1)*ABI^2))
         B(I) = SQR(4# * I * (I + ALPHA) * (I + BETA) * (I + AB) / ((ABI ^ 2 - 1) * ABI ^ 2))
     NEXT
     ABI = 2# * N + AB
     A(N) = A2B2 / ((ABI - 2#) * ABI)
     EXIT SUB
  
   'KIND=6 : Polinomios de Laguerre, L(ALPHA) (X), para(0, ),
   'W(X) = EXP(-X) * X ^ ALPHA, y ALFA mayor de -1.
C60: MUZERO = GAMMA(ALPHA + 1#)
     FOR I = 1 TO NM1
          A(I) = 2# * I - 1# + ALPHA
          'B(I) = DSQRT(I*(I + ALPHA))
          B(I) = SQR(I * (I + ALPHA))
     NEXT
     A(N) = 2# * N - 1 + ALPHA

END SUB

DEFINT I-K, N
SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
 
   'Cursor invisible
   LOCATE , , 0
  
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
 
   'Letreros
     COLOR 0, 3
       'Se invoca a la subrutina para centrado de textos
       CALL centra(7, "T E C N I C A S    A V A N Z A D A S ")
       CALL centra(9, "D E     P R O G R A M A C I O N")
       CALL centra(13, "C A P I T U L O    IV")
       CALL centra(18, "Aproximacin de integrales mediante la Subrutina GAUSSQ")
       
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
  
   'Pausa de 2.5 segundos
     SLEEP 2.5
  
   'Cursor invisible
   LOCATE , , 1

END SUB

DEFSNG I-K, N
FUNCTION FUN! (x)

 'Subprograma que evala la integral de la funcin error en el punto X,
 'cuya ecuacin es: f(x)=2/ e^(-x) = (cte) e^(-x)

  IF x = 0! THEN FUN = 0!
  IF x <> 0! THEN FUN = (2! / SQR(3.141595654#)) * EXP(-x ^ 2!)

END FUNCTION

FUNCTION GAMMA (valor)

 'Subprograma que evala la funcin gamma
  
   IF valor >= 0 THEN
      GAMMA = (lambda / r) * (lambda * valor) ^ r - 1 * EXP(-lambda * x)
   ELSE
      GAMMA = 0
   END IF

END FUNCTION

SUB gaussq (KIND, N, ALPHA, BETA, KPTS, ENDPTS(), B(), T(), W())
  
   'Este conjunto de rutinas calcula los nodos T(J) y los pesos  W(J),  de
   'Cuadraturas Gaussianas con nodos  pre-asignados,  para  aproximar  una
   '                integral (de A a B)   F(X) W(X) DX
   '                         N
   ' mediante               sum  W   F(T  )
   '                        J=1   J     J
  
   'NOTA: W(X) y W(J) no tienen conexin entre s.
  
   'W(X) es una funcin peso, de entre seis posibles (listadas ms adelan-
   'te), y F(X) es la funcin por integrar. Las Cuadraturas Gaussianas son
   'particularmente tiles en intervalos infinitos (con  la  funcin  peso
   'apropiada), ya que otras tcnicas a menudo fallan. Un conjunto de poli
   'nomios ortogonales est asociado a cada funcin peso, W(X). Los  nodos
   'T(J) son las races del polinomio, de e-nsimo grado, apropiado.
  
   'PARAMETROS DE ENTRADA (nmeros reales de doble precisin):
  
   '  KIND ... Nmero entero entre 1 y 6, el cual fija el tipo de cuadratu
   '           ra a usar.
   '  KIND=1 : Cuadratura de Legendre, W(X)=1 sobre (-1, 1).
   '  KIND=2 : Cuadratura de Chebyshev de 1er. tipo, W(X)=1/SQRT(1-X^2)
   '           sobre (-1, 1).
   '  KIND=3 : Cuadratura de Chebyshev de 2do. tipo, W(X)=SQRT(1-X^2)
   '           sobre (-1, 1).
   '  KIND=4 : Cuadratura de Hermite, W(X)=EXP(-X^2) sobre (-, ).
   '  KIND=5 : Cuadratura de Jacobi, W(X)=(1-X)^ALPHA*(1+X)^BETA sobre
   '           (-1, 1), (ALPHA, BETA) > -1.
   '           Nota: KIND=2 y 3, son casos especiales de esta cuadratura.
   '  KIND=6 : Cuadratura generalizada de Laguerre, W(X)=EXP(-X)*X^ALPHA
   '           sobre (0, ), ALPHA > -1.
   '  N ...... Nmero de puntos a usar en la cuadratura.
   '  ALPHA .. Parmetro real, usado slo en las cuadraturas de Gauss-Jaco
   '           bi y Gauss-Laguerre (0 en otros casos).
   '  BETA ... Parmetro real, usado slo en la cuadratura de Gauss-Jacobi
   '           (0 en otros casos).
   '  KPTS ... Parmetro entero, normalmente 0, a menos que se desee que el
   '           lmite izquierdo o derecho (o ambos) del intervalo,  sea  un
   '           nodo (a esto se le denomina cuadratura de Gauss-Radau  o  de
   '           Gauss-Lobatto). Entonces KPTS es el nmero de puntos extremo
   '           fijos (1  2).
   '  ENDPTS . Arreglo real de tamao 2. Contendr los valores de los puntos
   '           extremo fijos cuando KPTS= 1  2.
   '  B ...... Arreglo real de tamao N.
  
   'PARAMETROS DE SALIDA (dos arreglos de doble precisin de tamao N):
  
   '  T ...... Contendr los nodos deseados.
   '  W ...... Contendr los pesos deseados, W(J).
  
   'SUBRUTINAS REQUERIDAS:
  
   'SOLVE, CLASS, e IMTQL2 estn includas. Un  error  de  UNDERFLOW  puede
   'Gauss-Lobatto). Entonces pero ser innocuo si la interrupcin por UNDER
   'FLOW se cancela. Para lo cual, debe anexarse la siguiente instruccin -
   'en el programa principal:
   '                       ON ERROR GO TO etiqueta
  
   'EXACTITUD:
  
   'Esta subrutina se prob con N=512 para la Cuadratura de Legendre, N=136
   'para la de Hermite, N=68 para la de Laguerre y N=10  20 en otros casos.
   'Todos los resultados, a excepcin de los de 2  cuadraturas,  comparados
   'con las tablas de la referencia 3, muestran 12 o ms dgitos significa-
   'tivos. Las dos excepciones, son los pesos de las cuadatruras de Hermite
   'y de Laguerre, debido al UNDERFLOW causado por valores peso que tienden
   'a cero. Esto es, por supuesto, inofensivo.
  
   'METODO:
  
   'Los coeficientes de la relacin de recurrencia, de 3 trminos, para  el
   'conjunto pertinente de polinomios ortogonales, son empleados para  for-
   'mar una matriz tri-diagonal simtrica, cuyos  Eigenvalores  (calculados
   'por el mtodo Ql implcito con pivotes), son los  nodos  deseados.  Los
   'primeros componentes de los Eigenvectores ortonormalizados, correctamen
   'te escalados, generan los pesos. Esta tcnica es ms rpida que  la  de
   'usar un detector para las races de los  polinomios  ortogonales.  Para
   'ms detalles, consulte la referencia 1. La referencia 2, contiene infor
   'macin sobre las tcnicas de Gauss-Radau y Gauss - Lobatto.
  
   'REFERENCIAS:
  
   '1.- Golub, G. H., y Welsch, J. H., "CALCULATION OF GAUSSIAN  QUADRATURE
   'RULES ", Mathematics of Computation 23 (abril, 1969), pgs. 221-230.
   '2.- Golub, G. H., "SOME MODIFIED MATRIX EIGENVALUE PROBLEMS", Siam  Re-
   'view 15 (abril, 1973), pgs. 318-334 (seccin 7).
   '3.- Stroud y Secrest, "GAUSSIAN  QUADRATURE  FORMULAS",  Prentice-Hall,
   'Englewood Cliffs, N. J., 1966.
  
   '......................................................................
 
  
   'Llamada a class
     CALL class(KIND, M, ALPHA, BETA, B(), T(), MUZERO)
  
   'Se supone que la matriz de coeficientes es simtrica. El  arreglo  T
   'contiene los elementos de la diagonal principal, y el arreglo B, los
   'de las diagonales superior e inferior. Se realizan los cambios apro-
   'piados en la esquina inferior derecha, de la submatriz de 2x2.
     IF KPTS = 0 GOTO g100
     IF KPTS = 2 GOTO g50
  
   'S KPTS=1, nicamente T(N) debe modificarse
    T(N) = solve(ENDPTS(1), N, T(), B()) * B(N - 1) ^ 2 + ENDPTS(1)
   GOTO g100
  
   'S KPTS=2, T(N) y B(N - 1) deben calcularse
g50: GAM = solve(ENDPTS(1), N, T(), B())
     T1 = ((ENDPTS(1) - ENDPTS(2)) / (solve(ENDPTS(2), N, T(), B()) - GAM))
     ''B(N - 1) = DSQRT(T1)
     B(N - 1) = SQR(T1)
     T(N) = ENDPTS(1) + GAM * T1
  
   'Ntese que los ndices de los elementos de B, varan de 1 a N-1, y
   'entonces el valor de B(N) es arbitrario. Ahora se  calcularn  los
   'Eigenvalores de la de la matriz simtrica tridiagonal, los  cuales
   'sern modificados, si es necesario. El mtodo a usar es el QL  con
   'pivoteo.
g100: W(1) = 1#
     FOR I = 2 TO N
         W(I) = 0#
     NEXT
  
   'Llamada a imtql2
     CALL imtql2(N, T(), B(), W(), IERR)
    
   FOR I = 1 TO N
       W(I) = MUZERO * (W(I) ^ 2)
   NEXT

END SUB

SUB imtql2 (N, D(), E(), Z(), IERR)
  
   'Esta subrutina es una traslacin del procedimiento, en  Algol,  IMTQL2,
   'NUM. MATH. 12, 377-383, de Martin y Wilminson, modificado por Dubrulle,
   'NUM. MATH. 15, 450 (1970). Tomado de AUTO. COMP., vol. II (LINEAR MATH.
   '241-248 (1971).
  
   'Esta es una versin modificada de la subrutina IMTQL2 de EISPACK.  Esta
   'subrutina encuentra los Eigenvalores y los primeros  elementos  de  los
   'Eigenvectores, de una matriz tridiagonal y simtrica, mediante el mto-
   'do QL implcito.
  
   'DATOS DE ENTRADA:
  
   '  N ...... Orden de la matriz.
   '  D ...... Contiene los elementos de la diagonal principal.
   '  E ...... Contiene los elementos de las sub-diagonales,  en  sus  pri-
   '           meras N-1 posiciones; E(N) es arbitrario.
   '  Z ...... Contiene el primer rengln de la matriz identidad.
  
   'DATOS DE SALIDA:

   '  D ...... Contiene los Eigenvalores en orden ascendente. Si se detecta
   '           un error, tales valores se corregirn, pero no sern reorde-
   '           nados, para los ndices 1, 2, 3, ..., IERR-1.
   '  E ...... Ser eliminado.
   '  Z ...... Contiene los primeros componentes de los Eigenvectores orto-
   '           gonales de la matriz tridiagonal simtrica. Si se detecta un
   '           error, contendr los Eigenvectores asociados a los Eigenvalo
   '           res almacenados.
   '  IERR ... Su valor ser:
   '            Cero .... En un regreso normal.
   '            J    .... Si el J-simo Eigenvalor no se ha determinado des
   '                      pus de 30 iteraciones.
  
   '........................................................................
  
   'MACHEP es un parmetro dependiente de la computadora en uso y represen-
   'ta a Precisin Aritmtica en Punto Flotante. MACHEP = 16.0D0^(-13),  en
   'doble precisin para una computadora IBM S360.
   
   'Clculo del Machine Epsilon
     MACHEP = 1!
     DO
       MACHEP = .5 * MACHEP
       MACHEP1 = MACHEP + 1!
     LOOP WHILE MACHEP1 > 1!
  
   IERR = 0
   IF N = 1 GOTO i1001
   E(N) = 0#
  
   FOR L = 1 TO N
       J = 0
       ':::::::::::  Bsqueda del menor elemento sub-diagonal  :::::::::::
i105:  FOR M = L TO N
           IF M = N GOTO i120
           ''IF (DABS(E(M)).LE.MACHEP * (DABS(D(M)) + DABS(D(M + 1)))) GOTO 120
           IF (ABS(E(M)) <= MACHEP * (ABS(D(M)) + ABS(D(M + 1)))) GOTO i120
       NEXT M
i120:  P = D(L)
       IF M = L GOTO i240
       IF J = 30 GOTO i1000
       J = J + 1
      
       '::::::::::::::::::::    Se efecta pivoteo    ::::::::::::::::::::
       G = (D(L + 1) - P) / (2# * E(L))
       ''R = DSQRT(G ^ 2 + 1#)
       r = SQR(G ^ 2 + 1#)
       ''G = D(M) - P + E(L) / (G + DSIGN(R, G))
       IF G >= 0! THEN AUX = ABS(r) ELSE AUX = -ABS(r)
       G = D(M) - P + E(L) / (G + AUX)
       S = 1#
       C = 1#
       P = 0#
       MML = M - L
      
       ':::::::::::::  Para I=M-1 a L con decrementos de -1  :::::::::::::
       FOR II = 1 TO MML
            I = M - II
            F = S * E(I)
            B = C * E(I)
            ''IF (DABS(F) .LT. DABS(G)) GO TO 150
            IF (ABS(F) <= ABS(G)) GOTO i150
            C = G / F
            ''R = DSQRT(C ^ 2 + 1#)
            r = SQR(C ^ 2 + 1#)
            E(I + 1) = F * r
            S = 1# / r
            C = C * S
            GOTO i160
i150:       S = F / G
            ''R = DSQRT(S^2 + 1.0D0)
            r = SQR(S ^ 2 + 1#)
            E(I + 1) = G * r
            C = 1# / r
            S = S * C
i160:       G = D(I + 1) - P
            r = (D(I) - G) * S + 2# * C * B
            P = S * r
            D(I + 1) = G + P
            G = C * r - B
           
            ':::::::  Se conforma el primer componente del vector  :::::::
            F = Z(I + 1)
            Z(I + 1) = S * Z(I) + C * F
i200:       Z(I) = C * Z(I) - S * F
       NEXT II
       D(L) = D(L) - P
       E(L) = G
       E(M) = 0#
       GOTO i105
i240: NEXT L
  
   ':::::::  Ordenamiento de los Eigenvalores y Eigenvectores  :::::::
    FOR II = 2 TO N
         I = II - 1
         k = I
         P = D(I)
         FOR J = II TO N
             IF D(J) >= P GOTO i260
             k = J
             P = D(J)
i260:    NEXT J
         IF k = I GOTO i300
         D(k) = D(I)
         D(I) = P
         P = Z(I)
         Z(I) = Z(k)
         Z(k) = P
i300: NEXT II
   GOTO i1001
  
   ':::: Existe error si no se converge al Eigenvalor despus de 30
   '                                                    iteraciones ::::
i1000: IERR = L
i1001: EXIT SUB
  
   '::::::::::::::::::     Fin   de   IMTQL2       ::::::::::::::::::

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%
  
   'Letrero
   LOCATE 3, 13
   PRINT "APROXIMACION DE INTEGRALES USANDO LA SUBRUTINA GAUSSQ"

END SUB

FUNCTION solve (SHIFT, N, A(), B())
  
   'Esta funcin desempea una eliminacin para el n-simo componente de
   'DELTA, que es la solucin a la ecuacin siguiente:
   '                (J(N)- SHIFT * IDENTIDAD) * DELTA = EN
   'Donde EN es el vector de todas las races, excepto, para la  que  se
   'encuentra en la n-sima posicin.
  
   'La matriz JN es simtrica y tridiagonal, con elementos  A(I)  en  la
   'diagonal principal y B(I), en las sub-diagonales. Esta ecuacin debe
   'resolverse para generar los cambios apropiados en la  sub-matriz  de
   'coeficientes, de 2x2, para los polinomios ortogonales.
  
  ALPHA = A(1) - SHIFT
  NM1 = N - 1
  FOR I = 2 TO NM1
      ALPHA = A(I) - SHIFT - B(I - 1) ^ 2 / ALPHA
  NEXT
  solve = 1# / ALPHA

END FUNCTION

