 
  'Programa fuente para la obtencin del potencial de gas real, m(p),
  'empleando varios mtodos (Spline, Cuadraturas del Rectngulo, del
  'Trapecio y de Simpson, y Quanc8).
 
       'NOTA: QUANC8 incluye el uso de SPLINE y SEVAL (en lugar de la
           'funcin FUN(X)).

        'Versin 1.0 (Programa diseado por J. Antonio Ruiz G., 1992)
 
  DECLARE SUB apuntador (FIRST%, LAST%, DX%, Y%, FLAG1%)
  DECLARE SUB captura (letrero$, var!, min!, max!, ren%, col%, colcap%)
  DECLARE FUNCTION FUN! (P!)
  DECLARE SUB marco (reni%, renf%, coli%, colf%, tipo%, ci%, cf%)
  DECLARE SUB opcion1 ()
  DECLARE SUB opcion2 ()
  DECLARE SUB opcion3 ()
  DECLARE SUB opciones ()
  DECLARE SUB pausa (ren%, col%, ci%, cf%)
  DECLARE SUB propsgas (PY!, TY!, DRGL!, Z!, MG!, tipogas%)
  DECLARE SUB quanc8 (A!, B!, ABSERR!, RELERR!, RESULT!, ERREST!, NOFUN%, FLAG!)
  DECLARE SUB rectangulo ()
  DECLARE FUNCTION seval (N, U, X(), Y(), B(), C(), D(), OP)
  DECLARE SUB simpson ()
  DECLARE SUB spline (N, X(), Y(), B(), C(), D())
  DECLARE SUB splineinteg ()
  DECLARE SUB torre ()
  DECLARE SUB trapecio ()
 
  'Declaracin de constantes
    CONST enter = 13
 
  'Declaracin de variables comunes
    COMMON SHARED N, PY, TY, DRGL, Z, MG, desp, RESULT
 
  'Declaracin de arreglos dinmicos comunes
    DIM SHARED Pdat(N), Mpdat(N), H(N), B(N), C(N), D(N)
 
  'Se define el rea visual de trabajo y se le asigna color
    VIEW PRINT 1 TO 25
    COLOR 0, 7, 7
    CLS
    BEEP: CLEAR
 
  'Proteccin contra errores durante la ejecucin del programa
    ON ERROR GOTO 10
 
  'Se invoca a la subrutina que controla las opciones de trabajo
    CALL opciones
 
  'Seccin de deteccin de errores
10  SOUND 720, 10
    CLS
    COLOR 4
      LOCATE 13, 12
      PRINT "Error detectado: Revise los datos, verifique la existencia"
      LOCATE 14, 12
      PRINT "de las bases de datos o corrija el patrn de bsqueda."
    COLOR 0
    RESUME 20

20 END

SUB apuntador (FIRST%, LAST%, DX%, Y%, FLAG1%)
 
 'Subprograma para control de seleccin de opciones en pantalla

   'ENTRADA:
      'FIRST% = Valor mnimo o inicial de la coord. X del cursor (rengln),
               'el valor asciende de la parte sup. a la inferior del  moni-
               'tor.
      ' LAST% = Valor mximo o final de la coord. X del  cursor  (rengln),
               'el valor se incrementa de la parte izq. a  la  derecha  del
               'monitor.
           'NOTA: [LAST% - FIRST%] + 1 = nm. de alternativas de trabajo.
      '   DX% = Valor que modifica la posicin inicial del cursor.
      '    X% = Coord. X donde aparecera el cursor { FIRST% + DX% }
      '    Y% = Coord. Y (ordenada o columna) donde aparecera el cursor.

   'SALIDA:
      'FLAG1% = Valor nulo en la entrada y de la alternativa en la salida.

  '
  
     'Coordenada X del cursor
       X% = FIRST% + DX%
 
     'Se define visibilidad, tamao y posicin del cursor
       LOCATE X%, Y%, 1, 0, 7

     'Se asigna el valor de una tecla a una variable alfanumrica
a10:   ANS$ = INKEY$
       IF ANS$ = "" THEN GOTO a10
   
       'Se teclea la flecha de desplazamiento hacia bajo
       IF ANS$ = CHR$(0) + CHR$(80) THEN
          'Nueva coordenada X (rengln)
          IF X% < LAST% THEN
             'Incremento
             X% = X% + 1
          ELSE
             'Posicin inicial
             X% = FIRST%
          END IF
       END IF
   
       'Se teclea la flecha de desplazamiento hacia arriba
       IF ANS$ = CHR$(0) + CHR$(72) THEN
          'Nueva coordenada X (rengln)
          IF X% > FIRST% THEN
             'Decremento
             X% = X% - 1
          ELSE
             'Posicin final
             X% = LAST%
          END IF
       END IF
   
     'Se despliega el cursor en las coordenadas actuales
       LOCATE X%, Y%
             
     'Si no se oprime < ENTER > se contina el proceso
       IF ANS$ <> CHR$(13) THEN GOTO a10
 
     'Se asigna a la variable FLAG% el valor de la alternativa elegida en
     'funcin de su posicin
       FLAG1% = CSRLIN
       FLAG1% = FLAG1% - (FIRST% - 1)
 
     'Se redefine la visibilidad y el tamao del cursor
       LOCATE , , 0, 5, 6

END SUB

SUB captura (letrero$, var, min, max, ren%, col%, colcap%)
 
  'Subprograma que controla la captura de informacin de la variable "var"

    'letrero$ -- Frase a desplegar.
    'var      -- Nombre de la variable de entrada.
    'min, max -- Valores mn. y mx..
    'ren,col  -- Rengln y columna de desplegado.
    'colcap   -- Columna de captura y de borrado en caso de error.

    DO
      LOCATE ren%, col%: PRINT letrero$; : INPUT var
      'Se verifica que el dato introducido est dentro de un rango lgico
      IF var < min! OR var > max! THEN
         SOUND 300, 3: LOCATE ren%, colcap%: PRINT "          "
      END IF
    LOOP WHILE var < min! OR var > max!

END SUB

FUNCTION FUN! (PY!)

 'Funcin que evala le expresin P/( Z)
 
   'Llamada a la subrutina de clculo de propiedades del gas
     CALL propsgas(PY, TY, DRGL, Z, MG, 1)
  
   'Se evala la expresin P/( Z)
     AUX = PY / (MG * Z)
  
   'Asignando valor a la funcin FUN mediante un cambio de variable
     FUN = AUX
  
   'S desp<>0 se despliegan los clculos de Z, , m(p) y p
     IF desp <> 0 THEN
        'Despliegue de resultados parciales (correspondientes a cada presin)
          LOCATE 17, 24: PRINT "p       [lb/pgabs] ="; PY
          LOCATE 18, 24: PRINT "Z       [adim.]     = ";
          PRINT USING "#.####"; Z
          LOCATE 19, 24: PRINT "g      [cp]        =";
          PRINT USING "##.####^^^^"; MG
          LOCATE 20, 24: PRINT "p/( Z) [psia/cp]  ="; : PRINT AUX
     END IF

END FUNCTION

SUB marco (reni%, renf%, coli%, colf%, tipo%, ci%, cf%)

 'Subprograma que genera un marco

   'reni%, renf%-- Rengln inicial y final del recuadro
   'coli%, colf%-- Columna inicial y final del recuadro
   'tipo%       -- 1 para lnea sencilla, 2 para doble y 3 para semi-gruesa
   'ci%, cf%    -- Color inicial (recuadro) y final

   'Caractersticas del marco (tipo de lnea)
   SELECT CASE tipo%
          CASE 1
               'Lnea sencilla
               esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
               lhi$ = "": eid$ = ""
          CASE 2
               'Lnea doble
               esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
               lhi$ = "": eid$ = ""
          CASE 3
               'Lnea semi-gruesa
               esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
               lhi$ = "": eid$ = ""
   END SELECT

   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%

END SUB

SUB opcion1
 
  'Subprograma que efecta la integracin por varios mtodos
   
   'Invocando a la subrutina que genera un marco
    CALL marco(2, 4, 2, 79, 3, 1, 0)
    CALL marco(2, 24, 2, 79, 3, 1, 0)
  
   'Letreros
   COLOR 15
     LOCATE 3, 16: PRINT "APROXIMACION DE INTEGRALES USANDO VARIOS METODOS"
  
   COLOR 0
     LOCATE 9, 14
     PRINT "TECNICA                                      ERROR RELATIVO"
     LOCATE 10, 14
     PRINT "EMPLEADA         m(p)=2p/( Z) dp [psia/cp]  A QUANC8 [%]"
  
   COLOR 8
     LOCATE 12, 9: PRINT "Subrutina Quanc8"
     LOCATE 13, 9: PRINT "Mt. del Rectngulo"
     LOCATE 14, 9: PRINT "Mt. de Simpson"
     LOCATE 15, 9: PRINT "Tcnica Spline"
     LOCATE 16, 9: PRINT "Mt. del Trapecio"
  
   'Invocando a la subrutina que genera un marco
    CALL marco(11, 17, 7, 29, 2, 2, 0)
    CALL marco(11, 17, 30, 58, 2, 2, 0)
    CALL marco(11, 17, 59, 74, 2, 2, 0)
  
   COLOR 20
     LOCATE 23, 31
     PRINT "EFECTUANDO CALCULOS ..."
   COLOR 8
  
   'Se abre el archivo #1 (Mp1.dat), para lectura de datos del yacimiento,
   'del gas y el nmero de puntos p v.s. m(p)
     OPEN "a:\cap4\Mp1.dat" FOR INPUT AS #1
     INPUT #1, N, TY, DRGL
  
   'Redimensionando, de manera dinmica y comn, en funcin del nmero de
   'pares de puntos, los arreglos involucrados
     REDIM Pdat(N), Mpdat(N), H(N), B(N), C(N), D(N)
  
   'Se abren los archivos #2 y #3 (Mp2.dat y Mp3.dat, respectivamente), para
   'lectura de datos; Mp2.dat contendr una tabla de valores de presin, y
   'Mp3.dat, una de valores de m(p)
     OPEN "a:\cap4\Mp2.dat" FOR INPUT AS #2
     OPEN "a:\cap4\Mp3.dat" FOR INPUT AS #3
     FOR I = 1 TO N
         'Lectura de datos de presin
           INPUT #2, Pdat(I)
         'Lectura de datos de m(p), y adems, se har un cambio de escala,
         'para facilidad de clculos, dividiendo, por ejemplo, entre 1000
           INPUT #3, Mpdat(I)
           Mpdat(I) = Mpdat(I) / 1000
     NEXT
  
   'Se cierran los archivos #1, #2 y #3
     CLOSE
  
   'Espaciamiento entre paneles (excepto para QUANC8)
     FOR I = 1 TO N - 1
         H(I) = (Pdat(I + 1) - Pdat(I))
     NEXT I
  
   'Tolerancias para la subrutina QUANC8, considerando que los valores de
   'presin y de m(p) son tan grandes que pueden despreciarse los valores
   'centecimales
     RELEER = .1
     ABSERR = .1
  
   'Llamado a las subrutinas que que evalan la integral
     CALL quanc8(Pdat(1), Pdat(N), ABSERR, RELERR, RESULT, ERREST, NOFUN%, FLAG)
    
     'Afectando el valor calculado de la integral (RESULT), por 2 y por el
     'factor de escala (en este caso 1000)
       LOCATE 12, 37
       PRINT 2 * 1000 * RESULT
      
       LOCATE 12, 62: PRINT "----------";
      
       IF FLAG <> 0! THEN PRINT "flag ="; FLAG
    
   'Se invocan las subrutinas de clculo
      CALL rectangulo
      CALL simpson
      CALL splineinteg
      CALL trapecio
  
   'Se invoca a la subrutina que sirve de pausa
     CALL pausa(23, 18, 31, 0)

END SUB

SUB opcion2
 
  'Subprograma para el control de la opcin 2 del men principal
   
    COLOR 15
      LOCATE 4, 5, 0
      PRINT "DATOS (tomados de `Fundamentals of Reservoir Engeenering', Dake, L. P.,"
      PRINT TAB(11); "Elsevier Publishing Co.) :"
   
    COLOR 8
    LOCATE 8, 6
    PRINT "   El presente estudio, se basa en un yacimiento hipottico de gas con"
    PRINT TAB(6); "los siguientes datos:"
    PRINT
    PRINT TAB(13); "La temperatura es de 200F, la presin de 4400 lb/pgabs"
    PRINT TAB(13); "y la gravedad especfica del gas de 0.85."
    PRINT
    PRINT TAB(6); "   El resultado obtenido por el autor de la referencia, es:"
    PRINT TAB(25); "": PRINT TAB(18); "m(p)=2  p/( Z) dp = 1107.285 x 10^6 [psia/cp]"
    PRINT
    PRINT TAB(6); "   Comparando el valor anterior con los arrojados por este `software',"
    PRINT TAB(6); "el mximo error relativo es para el Mtodo del Trapecio (4.46 %),  con"
    PRINT TAB(6); "m(p)=1060.002 x 10^6 [psia/cp]; y el mnimo para  el  del  Rectngulo"
    PRINT TAB(6); "(4.23 %), con m(p)=1060.474 x 10^6 [psi/cp]."
   
    'Subrutina que crea un marco
     CALL marco(2, 24, 2, 79, 3, 14, 0)
   
    'Subrutina que funge como pausa
     CALL pausa(24, 30, 30, 0)

END SUB

SUB opcion3
 
  'Subrutina que crea los valores de presin v.s. potencial de gas real,
  'para almacenarlos en forma tabular en una base de datos,  adems  se
  'archivan los datos de yacimiento y del gas, as como  el  nmero  de
  'datos de presin v.s. potencial de gas real

   CLS
   
   'Subrutina que crea un marco
    CALL marco(2, 24, 2, 79, 3, 5, 0)
  
   COLOR 15
     LOCATE 2, 20
     PRINT " Creando los archivos: Mp1, Mp2 y Mp3.dat "
  
   'Subrutina que crea un marco
    CALL marco(1, 3, 19, 62, 3, 5, 0)
    CALL marco(4, 23, 11, 70, 2, 14, 0)
  
   'Captura de los datos del yacimiento y del gas producido
     LOCATE 7, 26
     PRINT "DATOS DEL GAS Y DEL YACIMIENTO :"
     COLOR 8
       CALL captura("Temperatura del yacimiento [F]       ", TY, 0, 500, 9, 19, 57)
       CALL captura("Densidad relativa del gas  [fraccin] ", DRGL, .001, 5, 10, 19, 57)
    
     LOCATE 11, 19
     PRINT "Presin a la que se desea calcular"
     CALL captura("el potencial de gas real   [lb/pgabs]", PY, 50, 10000, 12, 19, 57)
  
   'Se crean los archivos #1 y #2 (Mp2.dat y Mp3.dat, respectivamente).
   'Mp2.dat contendr una tabla de valores de presin, y Mp3.dat, una
   'de valores de m(p)
     COLOR 0
       LOCATE 15, 29
       PRINT "PROPIEDADES DEL GAS :"
     COLOR 8
     OPEN "a:\cap4\Mp2.dat" FOR OUTPUT AS #1
     OPEN "a:\cap4\Mp3.dat" FOR OUTPUT AS #2
  
   'Se obtiene el intervalo de presin con incrementos en funcin de la
   'presin del yacimiento (para los lmites A=0 y B=PY), con  su  m(p)
   'asociado. El nmero de puntos de presin ser N.
     SELECT CASE PY
          'Incremento de 50 lb/pg
            CASE IS < 2500
                 Dp = 50
          'Incremento de 100 lb/pg
            CASE 2500 TO 5000
                 Dp = 150
          'Incremento de 250 lb/pg
            CASE IS > 5000
                 Dp = 250
     END SELECT
    
     'Se inicializan el contador y el valor acumulado de presin, tambin
     'se define el despliegue de los clculos de Z, , m(p) y p, asignando
     'el valor de 1 a desp
       N = 1
       Paux = 0!
       desp = 1
    
     DO
       'Contador para el nm. de pares de puntos
         N = N + 1
      
       'Se almacena cada valor de presin (a partir del lmite A=0)
         PRINT #1, Paux
      
       'Se calcula y almacena el correspondiente valor de m(p)
         Mpaux = FUN(Paux)
         PRINT #2, Mpaux
         Paux = Paux + Dp
        
         IF Paux >= PY THEN
            'Se almacena el valor de la ensima presin (lmite B)
               PRINT #1, PY
            'Se calcula y almacena el correspondiente valor de m(p-ensima)
               Mpaux = FUN(PY)
               PRINT #2, Mpaux
         END IF
     LOOP WHILE Paux < PY
  
   'Se crea el archivo #3 (Mp1.dat)
     OPEN "a:\cap4\Mp1.dat" FOR OUTPUT AS #3
  
   'Se almacena el resto de los datos y se cierran los archivos #1, #2 y #3
     PRINT #3, N, TY, DRGL
     CLOSE
  
   'Se define el no despliegue de los clculos de Z, , m(p) y p (desp=0)
     desp = 0

END SUB

SUB opciones
 
  'Subrutina que facilita una seleccin de alternativas con el cursor como
  'apuntador

    'Se invoca a la subrutina que genera un marco
      CALL marco(9, 15, 9, 72, 3, 2, 0)
      CALL marco(10, 14, 11, 70, 1, 9, 0)
   
    'Letreros
      LOCATE 11, 13
      PRINT "OBTENCION DEL POTENCIAL DE GAS REAL m(p), EMPLEANDO LAS"
      LOCATE 12, 13
      PRINT "TECNICAS DE INTEGRACION DEL RECTANGULO, DEL TRAPECIO  Y"
      LOCATE 13, 13
      PRINT "DE SIMPSON, ASI COMO LAS SUBRUTINAS  SPLINE  Y  QUANC8."
   
    'Se invoca a la subrutina que sirve de pausa
      CALL pausa(23, 18, 16, 0)
 
'-------------- Despliegue grfico de opciones maestras --------------------

p10: CLS
    'Se invoca a la subrutina que genera un marco
      CALL marco(8, 15, 11, 68, 3, 4, 0)
   
    'Letreros
      LOCATE 8, 31:  PRINT " MENU PRINCIPAL "
      LOCATE 10, 16: PRINT "_ Obtencin del potencial de gas real m(p)."
      LOCATE 11, 16: PRINT "_ Visualizar los datos bsicos del gas en estudio."
      LOCATE 12, 16: PRINT "_ Crear las bases de datos (instalacin)."
      LOCATE 13, 16: PRINT "_ Trmino de la sesin."
   
    COLOR 31
      LOCATE 21, 20: PRINT "    Seleccione la opcin de trabajo     "
      LOCATE 22, 20: PRINT "        y   presione  < ENTER >         "
    COLOR 0
   
    'Control de seleccin de opciones en pantalla
      CALL apuntador(10, 13, 0, 16, FLAG1%)
      SOUND 450, 4
   
    'Eleccin de la alternativa
      ON FLAG1% GOSUB p20, p30, p40, p50

p20: 'Opcin 1
     CLS
      'Llamada a la subrutina de integracin
       CALL opcion1
       GOTO p10

p30: 'Opcin 2
     CLS
     'Se invoca a la subrutina de desplegado de informacin
       CALL opcion2
       GOTO p10

p40: 'Opcin 3
     CLS
     'Se oculta el cursor
      LOCATE 10, , 0
    
     PRINT TAB(15); "ESTA OPCION SOLO DEBE USARSE AL EJECUTAR EL PROGRAMA"
     PRINT TAB(15); "POR VEZ PRIMERA, DE LO CONTRARIO, SE CORRE EL RIESGO"
     PRINT TAB(15); "DE ELIMINAR LAS BASES DE DATOS EXISTENTES."
    
    'Se invoca a la subrutina que genera un marco
     CALL marco(8, 17, 11, 70, 3, 6, 0)
   
    'Se ofrece la alternativa de abortar la instalacin
    COLOR 31
      LOCATE 15, 22: PRINT "< ENTER > continuar, < ESC > terminar"
    COLOR 0
   
    DO
      K$ = INKEY$
    LOOP WHILE K$ = ""
   
    'Transmutacin a cdigo ASCII
    qy = ASC(RIGHT$(K$, 1))
   
    IF qy <> enter THEN GOTO p10
    LOCATE 10, 21: PRINT "                                        "
   
    'Llamado a la subrutina que crea las bases de datos
      CALL opcion3
      GOTO p10

p50: 'Opcin 4
     CLS
     'Se invoca a la subrutina que genera un marco
       CALL marco(22, 24, 52, 70, 3, 28, 7)
    
     'Se invoca a la subrutina que genera una torre
       CALL torre
     
      COLOR 31, 7
        LOCATE 23, 54
        PRINT " FIN DE SESION "
      COLOR 7, 7, 7
     
      'Redefinicin del tamao del cursor
       LOCATE , , 0
     
      'Fin de sesin
       END

END SUB

SUB pausa (ren%, col%, ci%, cf%)
 
  'Subprograma que funge como pausa
   
    'ren%, col% -- Rengln y columna del desplegado
    'ci%, cf%   -- Color inicial y final del mensaje
   
    'Letrero
    COLOR ci%
      LOCATE ren%, col%
      PRINT " < Para continuar presione cualquier tecla > "
    COLOR cf%
   
    'Ciclo que finaliza cuando se presiona cualquier tecla
    DO
    LOOP WHILE INKEY$ = ""
    SOUND 200, 2

END SUB

SUB propsgas (PY, TY, DRGL, Z, MG, tipogas%)
 
  'Subprograma que obtiene el factor de compresibilidad (Correlacin de
  'Hall-Yarborough) y la viscosidad (Correlacin de Lee) del gas
  
    'Se transforma la temperatura a grados Rankine
      Trank = TY + 460
   
    'tipogas es una constante que define si el gas es superficial (aceite
    'negro) o es hmedo o condensado (aceite voltil)
      'Propiedades pseudoreducidas
       IF tipogas% = 1 THEN
          'Gas superficial
          TPRinv = (167 + 316.67 * DRGL) / Trank: PPR = PY / (702.5 - 50 * DRGL)
       ELSE
          'Gas hmedo
          TPRinv = (238 + 210 * DRGL) / Trank: PPR = PY / (740 - 100 * DRGL)
       END IF
   
    'Suponiendo una densidad reducida inicial
      Y = .00001#
   
    'Clculo del factor de desviacin del gas (Z) (solucin mediante el
    'mtodo de Newton-Raphson)
      F1 = -.06125 * PPR * TPRinv * EXP(-1.2 * (1 - TPRinv) ^ 2)
     
      DO
        F2 = (Y + Y ^ 2 + Y ^ 3 - Y ^ 4) / (1 - Y) ^ 3
        F3 = -(14.76 * TPRinv - 9.76 * TPRinv ^ 2 + 4.58 * TPRinv ^ 3) * Y ^ 2
        F4 = (90.7 * TPRinv - 242.2 * TPRinv ^ 2 + 42.4 * TPRinv ^ 3) * Y ^ (2.18 + 2.82 * TPRinv)
        F = F1 + F2 + F3 + F4
        IF ABS(F) <= .0001 THEN EXIT DO
        DFDY1 = (1 + 4 * Y + 4 * Y ^ 2 - 4 * Y ^ 3 + Y ^ 4) / (1 - Y) ^ 4
        DFDY2 = -(29.52 * TPRinv - 19.52 * TPRinv ^ 2 + 9.16 * TPRinv ^ 3) * Y
        DFDY3 = (2.18 + 2.82 * TPRinv) * (90.7 * TPRinv - 242.2 * TPRinv ^ 2 + 42.4 * TPRinv ^ 3) * Y ^ (1.18 + 2.82 * TPRinv)
        DFDY = DFDY1 + DFDY2 + DFDY3
        Y = Y - F / DFDY
      LOOP
     
      IF PY = 0 THEN
         Z = 1
      ELSE
         Z = (.06125 * PPR * TPRinv * EXP(-1.2 * (1 - TPRinv) ^ 2)) / Y
      END IF
   
    'Clculo de la viscosidad del gas (MG)
      DG = (2.7044 * PY * DRGL) / (Z * Trank)
      K = ((9.4 + .5794 * DRGL) * Trank ^ 1.5) / (209 + 550.4 * DRGL + Trank)
      X = 3.5 + 986 / Trank + .2897 * DRGL: Y1 = 2.4 - .2 * X
      MG = K * 10 ^ -4 * EXP(X * (DG / 62.428) ^ Y1)

END SUB

SUB quanc8 (A, B, ABSERR, RELERR, RESULT, ERREST, NOFUN%, FLAG)
 
  'Esta subrutina estima la integral de una funcin F(X), en el intervalo
  '[A, B] considerando la tolerancia proporcionada por el usuario.
 
  'Representa una subrutina auto-adaptable basada  en  la  regla  de  los
  '8-pneles de Newton-Cotes.
 
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  'NOTA: Se incluye el uso de SPLINE y SEVAL  (en  lugar  de  la  funcin
        'FUN(X)). Las sentencias marcadas con:  '',  son  las  originales
         'y fueron canceladas.
  '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  'Variables de tipo real: A, B, ABSERR, RELERR, RESULT, ERREST, FLAG
  'Variables de tipo entero: NOFUN
 
  'ENTRADA:
  'Variables requeridas por SPLINE y SEVAL (tipo "common shared"):
  '  Pdat(),
  '  Mpdat(). Arreglos dato (abscisa y ordenada) de la funcin F(X).
  '  N ...... Nmero de pares de datos.
  '  B(), C()
  '  y D() .. Arreglos calculados por SPLINE y empleados por SEVAL.
  '  A ...... El lmite inferior de la integracin.
  '  B ...... El lmite superior de la integracin (B puede ser menor que
  '           A).
  '  RELERR . Tolerancia para el error relativo (debe ser positivo).
  '  ABSERR . Tolerancia para el error absoluto (debe ser positivo).
 
  'SALIDA:
  '  RESULT . Aproximacin de la integral que virtualmente  satisface  el
  '           mnimo valor de entre las dos tolerancias de error.
  '  ERREST . Estimacin de la magnitud del error actual.
  '  NOFUN .. Nmero de valuaciones de la funcin (FUN), usadas en el cl-
  '           culo de RESULT.
  '  FLAG ... Factor de integridad. Si FLAG es cero, entonces RESULT proba
  '           blemente satisfaga la tolerancia de error. Si FLAG es XXX.YYY,
  '           entonces XXX = nmero de  intervalos  que  no  convergen,  y
  '           0.YYY = fraccin del ltimo  intervalo  izquierdo  realizado,
  '           antes de que el lmite de NOFUN se halla alcanzado.
 
  '  Variables de tipo real: W0, W1, W2,  W3,  W4,  AREA,  X0,  F0,  STONE,
  '                          STEPP, COR11, TEMP.
  '  Variables de tipo real: QPREV, QNOW, QDIFF, QLEFT, ESTERR, TOLERR.
  '  Variables de tipo real: QRIGHT(31),    F(16),   X(16),   FSAVE(8, 30),
  '                          XSAVE(8, 30).
  '  Variables de tipo entero: LEVMIN, LEVMAX, LEVOUT, NOMAX, NOFIN, LEV,
  '                            NIM, I, J.
  
 DIM QRIGHT(31), F(16), X(16), FSAVE(8, 30), XSAVE(8, 30)

  '*** Etapa 1 *** inicializacin general
  'Definicin de constantes
    LEVMIN% = 1
    LEVMAX% = 30
    LEVOUT% = 6
    NOMAX% = 5000
    NOFIN% = NOMAX% - 8 * (LEVMAX% - LEVOUT% + 2 ^ (LEVOUT% + 1))
 
  'Existe un problema cuando NOFUN alcanza el valor NOFIN
    W0 = 3956! / 14175!
    W1 = 23552! / 14175!
    W2 = -3712! / 14175!
    W3 = 41984! / 14175!
    W4 = -18160! / 14175!
 
  'Se inicializan las variables de las sumas acumulativas
    FLAG = 0!
    RESULT = 0!
    COR11 = 0!
    ERREST = 0!
    AREA = 0!
    NOFUN% = 0
    IF A = B THEN EXIT SUB
 
  '*** Etapa 2 *** inicializacin del primer intervalo
    LEV% = 0
    NIM% = 1
    X0 = A
    X(16) = B
    QPREV = 0!
    ''F0 = FUN(X0)
   
    'Llamada a Spline
      CALL spline(N, Pdat(), Mpdat(), B(), C(), D())
   
    'Funcin SEVAL, F0 = es el valor interpolado de la ordenada
      F0 = seval(N, X0, Pdat(), Mpdat(), B(), C(), D(), 1)
   
    STONE = (B - A) / 16!
    X(8) = (X0 + X(16)) / 2!
    X(4) = (X0 + X(8)) / 2!
    X(12) = (X(8) + X(16)) / 2!
    X(2) = (X0 + X(4)) / 2!
    X(6) = (X(4) + X(8)) / 2!
    X(10) = (X(8) + X(12)) / 2!
    X(14) = (X(12) + X(16)) / 2!
    FOR J% = 2 TO 16 STEP 2
        ''F(J%) = FUN(X(J%))
        F(J%) = seval(N, X(J%), Pdat(), Mpdat(), B(), C(), D(), 1)
    NEXT J%
    NOFUN% = 9
 
  '*** Etapa 3 *** clculos centrales
  'Se requiere de QPREV, X0, X2, X4, ..., X16, F0, F2, F4, ..., F16
  'Se clculan X1, X3, ..., X15, F1, F3, ..., F15, QLEFT, QRIGHT, QNOW,
  'QDIFF, AREA
30  X(1) = (X0 + X(2)) / 2!
    ''F(1) = FUN(X(1))
   
    'Funcin SEVAL, F(1) = es el valor interpolado de la ordenada
    F(1) = seval(N, X(1), Pdat(), Mpdat(), B(), C(), D(), 1)
    FOR J% = 3 TO 15 STEP 2
        X(J%) = (X(J% - 1) + X(J% + 1)) / 2!
        ''F(J%) = FUN(X(J%))
        F(J%) = seval(N, X(J%), Pdat(), Mpdat(), B(), C(), D(), 1)
    NEXT J%
   
    NOFUN% = NOFUN% + 8
    STEPP = (X(16) - X0) / 16!
    QLEFT = (W0 * (F0 + F(8)) + W1 * (F(1) + F(7)) + W2 * (F(2) + F(6)) + W3 * (F(3) + F(5)) + W4 * F(4)) * STEPP
    QRIGHT(LEV% + 1) = (W0 * (F(8) + F(16)) + W1 * (F(9) + F(15)) + W2 * (F(10) + F(14)) + W3 * (F(11) + F(13)) + W4 * F(12)) * STEPP
    QNOW = QLEFT + QRIGHT(LEV% + 1)
    QDIFF = QNOW - QPREV
    AREA = AREA + QDIFF
 
  '*** Etapa 4 *** prueba de convergencia del intervalo
    ESTERR = ABS(QDIFF) / 1023!
    IF ABSERR > RELERR * ABS(AREA) THEN
       TOLERR = ABSERR * (STEPP / STONE)
    ELSE
       TOLERR = RELERR * ABS(AREA) * (STEPP / STONE)
    END IF
    IF LEV% < LEVMIN% THEN GOTO 50
    IF LEV% >= LEVMAX% THEN GOTO 62
    IF NOFUN% > NOFIN% THEN GOTO 60
    IF ESTERR <= TOLERR THEN GOTO 70
 
  '*** Etapa 5 *** no convergencia del intervalo
  'Localizacin del siguiente intervalo
50  NIM% = 2 * NIM%
    LEV% = LEV% + 1
 
  'Almacenaje de los elementos del lado derecho para un uso futuro
    FOR I% = 1 TO 8
        FSAVE(I%, LEV%) = F(I% + 8)
        XSAVE(I%, LEV%) = X(I% + 8)
    NEXT I%
 
  'Reacomodo de los elementos del lado izquierdo para su uso inmediato
    QPREV = QLEFT
    FOR I% = 1 TO 8
        J% = -I%
        F(2 * J% + 18) = F(J% + 9)
        X(2 * J% + 18) = X(J% + 9)
    NEXT I%
    GOTO 30
 
  '*** Etapa 6 *** seccin de problemas
  'El nmero de valuaciones de la funcin (FUN) no debe exceder el lmite
60  NOFIN% = 2 * NOFIN%
    LEVMAX% = LEVOUT%
    FLAG = FLAG + (B - X0) / (B - A)
    GOTO 70
 
  'El valor actual de LEVEL es LEVMAX
62  FLAG = FLAG + 1!
 
  '*** Etapa 7 *** intevalo convergente
  'Se adiciona las variables a las sumas acumulativas
70  RESULT = RESULT + QNOW
    ERREST = ERREST + ESTERR
    COR11 = COR11 + QDIFF / 1023!
 
  'Localizacin del siguiente intervalo
72  IF NIM% = 2 * INT(NIM% / 2) THEN GOTO 75
    NIM% = NIM% / 2
    LEV% = LEV% - 1
    GOTO 72
75  NIM% = NIM% + 1
    IF LEV% <= 0 THEN GOTO 80
 
  'Reacomodo de los elementos requeridos en el siguiente intervalo
    QPREV = QRIGHT(LEV%)
    X0 = X(16)
    F0 = F(16)
    FOR I% = 1 TO 8
        F(2 * I%) = FSAVE(I%, LEV%)
        X(2 * I%) = XSAVE(I%, LEV%)
    NEXT I%
    GOTO 30
 
  '*** Etapa 8 *** finalizacin y salida de la subrutina
80  RESULT = RESULT + COR11
 
  'Se verifica que ERREST no sea menor que el error de redondeo
    IF (ERREST = 0!) THEN
       ERASE QRIGHT, F, X, FSAVE, XSAVE
       EXIT SUB
    END IF
82  TEMP = ABS(RESULT) + ERREST
    IF TEMP <> ABS(RESULT) THEN
       'Se eliminan de memoria algunos arreglos
       ERASE QRIGHT, F, X, FSAVE, XSAVE
       EXIT SUB
    END IF
    ERREST = 2! * ERREST
    GOTO 82

END SUB

SUB rectangulo
 
  'Subprograma para evaluar integrales mediante la Cuadratura del Rectngulo
 
    R = 0!
    FOR I = 1 TO N - 1
        Pmed = (Pdat(I) + Pdat(I + 1)) / 2!
       
        'Se emplea la funcin SEVAL, Mpmed = es el valor interpolado de la
        'ordenada (Mp en el punto medio)
          Mpmed = seval(N, Pmed, Pdat(), Mpdat(), B(), C(), D(), 1)
       
        IR = Mpmed * H(I)
        R = R + IR
    NEXT
   
    'Afectando el valor calculado de la integral (R), por 2 y por el factor
    'de escala (1000)
      LOCATE 13, 37
      PRINT 2 * 1000 * R
      LOCATE 13, 60
      PRINT 100 * ABS(RESULT - R) / RESULT

END SUB

FUNCTION seval (N, U, X(), Y(), B(), C(), D(), OP)
  
   'Esta subrutina evala la funcin cbica spline:
 
        'seval = Y(I) + B(I)*(U-X(I)) + C(I)*(U-X(I))^2 + D(I)*(U-X(I))^3
 
   'donde:  X(I) < U < X(I+1), usando la regla de Horner.
 
   'Si U < X(1) entoces se supone que I=1.
   'Si U > X(N) entoces se supone que I=N.
 
   'Datos de entrada:
          'N = Nmero de datos.
          'U = Abscisa en la que se valuar el spline.
       'X, Y = Vectores de abscisas y ordenadas dato.
    'B, C, D = Vectores de coeficientes clculados por SPLINE.
         'OP = Variable que rige el tipo de bsqueda, secuencial si OP=1
              'y binaria en cualquier otro caso.
 
   'Si U no se ubica en el intervalo de la llamada previa, entonces  una
   'bsqueda binaria o secuencial ser ejecutada, para determinar el in-
   'tervalo apropiado.
  
   I = 1
   IF I >= N THEN I = 1
 
   'Se designa el mtodo de bsqueda
     SELECT CASE OP
          
            CASE 1
                 IF U <= X(I + 1) THEN GOTO se10
                 'Bsqueda secuencial para U < X(I)
                   K = 0
                   DO
                     K = K + 1
                     IF U < X(K) THEN J = K
                     IF U >= X(K) THEN I = K
                   LOOP WHILE K < N
          
            CASE ELSE
                 IF U <= X(I + 1) THEN GOTO se10
                 'Bsqueda binaria para U < X(I)
                   I = 1
                   J = N + 1
                   DO
                     K = INT((I + J) / 2)
                     IF U < X(K) THEN J = K
                     IF U >= X(K) THEN I = K
                   LOOP WHILE J > I + 1
   
     END SELECT
 
   'Se evala el spline
se10: DX = U - X(I)
      seval = Y(I) + DX * (B(I) + DX * (C(I) + DX * D(I)))
  
END FUNCTION

SUB simpson
 
  'Subprograma para evaluar integrales mediante la Cuadratura de Simpson
  
    S = 0!
    FOR I = 1 TO N - 1
        Pmed = (Pdat(I) + Pdat(I + 1)) / 2!
       
        'Se emplea la funcin SEVAL, Mpmed = es el valor interpolado de la
        'ordenada (Mp en el punto medio)
          Mpmed = seval(N, Pmed, Pdat(), Mpdat(), B(), C(), D(), 1)
       
        SI = (H(I) / 6!) * (Mpdat(I) + 4! * Mpmed + Mpdat(I + 1))
        S = S + SI
    NEXT
   
    'Afectando el valor calculado de la integral (S), por 2 y por el factor
    'de escala (1000)
      LOCATE 14, 37
      PRINT 2 * 1000 * S
      LOCATE 14, 60
      PRINT 100 * ABS(RESULT - S) / RESULT

END SUB

SUB spline (N, X(), Y(), B(), C(), D())
  
   'Los coeficientes B(I), C(I) y D(I), I=1,2,...,N, son calculados para
   'formar el polinomio de Splines cbicos:
 
       'S(X) = Y(I) + B(I)*(X-X(I)) + C(I)*(X-X(I))^2 + D(I)*(X-X(I))^3
 
   'para: X(I) =< X =< X(I+1).
 
   'Datos de entrada:
     'N = Nmero de datos, puntos o coordenadas (N >= 2).
     'X = Abscisa de las coordenadas dato en estricto orden  ascendente.
     'Y = Ordenada de las coordenadas dato.
 
   'Datos de salida:
     'B, C, D = vectores con coeficientes de SPLINE, indicados anterior-
               'mente.
 
   'Usando la letra "P" para denotar diferenciales:
     'Y(I) = S(X(I))
     'B(I) = SP(X(I))
     'C(I) = SPP(X(I))/2
     'D(I) = SPPP(X(I))/6
 
   'Nota: La funcin SEVAL evala el spline.
 
     NM1 = N - 1
     IF N < 2 THEN
        SOUND 200, 4: CLS
        COLOR 31
          LOCATE 12, 22: PRINT "EL No. DE DATOS DEBE SER MAYOR DE 2 !!"
        COLOR 7
        END
     END IF
     IF N < 3 THEN
        B(1) = (Y(2) - Y(1)) / (X(2) - X(1))
        C(1) = 0!
        D(1) = 0!
        B(2) = B(1)
        C(2) = 0!
        D(2) = 0!
        EXIT SUB
     END IF
 
   'Se crea un sistema tri-diagonal
   'B=diagonal principal, D=diagonal inmediata-superior, C=vector de trmi-
     'nos independientes
     D(1) = X(2) - X(1)
     C(2) = (Y(2) - Y(1)) / D(1)
     FOR I = 2 TO NM1
         D(I) = X(I + 1) - X(I)
         B(I) = 2! * (D(I - 1) + D(I))
         C(I + 1) = (Y(I + 1) - Y(I)) / D(I)
         C(I) = C(I + 1) - C(I)
     NEXT I
 
   'Condiciones finales. La tercera derivada de X(1) y X(N)  resultan  del
   'cociente de las diferencias
     B(1) = -D(1)
     B(N) = -D(N - 1)
     C(1) = 0!
     C(N) = 0!
     IF N = 3 THEN GOTO sp10
     C(1) = C(3) / (X(4) - X(2)) - C(2) / (X(3) - X(1))
     C(N) = C(N - 1) / (X(N) - X(N - 2)) - C(N - 2) / (X(N - 1) - X(N - 3))
     C(1) = C(1) * D(1) ^ 2 / (X(4) - X(1))
     C(N) = -C(N) * D(N - 1) ^ 2 / (X(N) - X(N - 3))
 
   'Sustitucin hacia adelante
sp10: FOR I = 2 TO N
          T = D(I - 1) / B(I - 1)
          B(I) = B(I) - T * D(I - 1)
          C(I) = C(I) - T * C(I - 1)
      NEXT I
 
   'Sustitucin hacia atrs
     C(N) = C(N) / B(N)
     FOR IB = 1 TO NM1
         I = N - IB
         C(I) = (C(I) - D(I) * C(I + 1)) / B(I)
     NEXT IB
 
   'Clculo de los coeficientes del polinomio
     B(N) = (Y(N) - Y(NM1)) / D(NM1) + D(NM1) * (C(NM1) + 2! * C(N))
     FOR I = 1 TO NM1
         B(I) = (Y(I + 1) - Y(I)) / D(I) - D(I) * (C(I + 1) + 2! * C(I))
         D(I) = (C(I + 1) - C(I)) / D(I)
         C(I) = 3! * C(I)
     NEXT I
     C(N) = 3! * C(N)
     D(N) = D(N - 1)
  
END SUB

SUB splineinteg
 
  'Subprograma para integracin incorporando el empleo de la subrutina
  'SPLINE.
 
  'NOTA:
       'La llamada a SPLINE se omite puesto que ya se realiz en QUANC8
       'y por lo tanto los valores de B(), C(), y D(), se conservan  en
       'memoria.
   
    S = 0!
    FOR I = 1 TO N - 1
        Sint = (H(I) * (Mpdat(I) + Mpdat(I + 1)) / 2!) - (H(I) ^ 3 * (C(I) + C(I + 1)) / 12!)
        S = S + Sint
    NEXT
   
    'Afectando el valor calculado de la integral (S), por 2 y por el factor
    'de escala (1000)
      LOCATE 15, 37
      PRINT 2 * 1000 * S
      LOCATE 15, 60
      PRINT 100 * ABS(RESULT - S) / RESULT

END SUB

SUB torre
 
  'Subprograma que despliega en pantalla una torre de terminacin
  
    'Tubera
    COLOR 15, 7
      LOCATE 2, 40: PRINT ""
    COLOR 0, 7
   
    'Estructrura de la torre
    PRINT TAB(35); ""
    PRINT TAB(35); "     "
    PRINT TAB(35); "   "
    PRINT TAB(35); "  "
    PRINT TAB(35); "    "
    PRINT TAB(35); "     "
    PRINT TAB(35); "   "
    PRINT TAB(35); "      "
   PRINT TAB(34); "   "
   PRINT TAB(34); "     "
   PRINT TAB(34); "         "
 PRINT TAB(32); " "
 PRINT TAB(32); "  Ĵ"
 PRINT TAB(32); "  Ĵ"

    'Estratos
    COLOR 0, 15
      LOCATE 17, 1: PRINT STRING$(80, 176)
      LOCATE 19, 1: PRINT STRING$(80, 177)

    'Tubera
    COLOR 15, 7
      FOR I = 4 TO 13
          LOCATE I, 40: PRINT ""
      NEXT
 
    COLOR 15, 0
      FOR I = 15 TO 21
          LOCATE I, 40: PRINT ""
      NEXT
   
      'Tubera disparada
      LOCATE 22, 40: PRINT ""
      LOCATE 23, 40: PRINT ""
    COLOR 0, 3

    'Estructrura de la torre
    LOCATE 10, 40: PRINT ""
    LOCATE 14, 40: PRINT ""

END SUB

SUB trapecio
 
  'Subprograma para evaluar integrales mediante la Cuadratura del Trapecio
   
    T = 0!
    FOR I = 1 TO N - 1
        IT = H(I) * (Mpdat(I) + Mpdat(I + 1)) / 2!: T = T + IT
    NEXT
   
    'Afectando el valor calculado de la integral (T), por 2 y por el factor
    'de escala (1000)
      LOCATE 16, 37
      PRINT 2 * 1000 * T
      LOCATE 16, 60
      PRINT 100 * ABS(RESULT - T) / RESULT

END SUB

