
  'Programa fuente para el control de la subrutina QUANC8.
 
     'NOTA: se considera la integracin de la funcin error, definida
     '                          b
     'por la ecuacin f(x)=2/ a e^(-x), en el intervalo [A, B].
     
      'Versin 1.0 (programa fuente creado por J. Antonio Ruiz G., 1992).

   DECLARE SUB centra (posx!, Title$)
   DECLARE SUB enrolla ()
   DECLARE FUNCTION FUN! (X!)
   DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
   DECLARE SUB QUANC8 (A!, B!, ABSERR!, RELERR!, RESULT!, ERREST!, NOFUN%, FLAG!)
  
    'Declaracin de variables comnes
     COMMON SHARED cte
  
    'Cursor invisible
     LOCATE , , 0

    'Se invoca a la subrutina que genera una pantalla de presentacin
     CALL enrolla

    'Inicia el proceso
    DO
      'Se designa el rea visual de trabajo y se le asigna color
        CLEAR
        VIEW PRINT
        COLOR 7, 9, 9
        CLS : BEEP
  
    'Invocando a la subrutina que genera un marco
     CALL marco(2, 4, 3, 78, 3, 7)
 
   'Proteccin contra errores de underflow u overflow
     ON ERROR GOTO 40
  
   'Asignacin de lmites de integracin, tolerancias de error y de la
   'constante de la funcin error (cte=2/)
     A = 0
     B = 1
     RELEER = .0001
     ABSERR = .0001
     cte = 2! / SQR(3.141595654#)
    
     LOCATE 7, 10: PRINT "Integracin de la funcin error, definida por la ecuacin:"
     LOCATE 8, 30: PRINT "           b"
     LOCATE 9, 30: PRINT " f(x)=2/ a e^(-x)"
     LOCATE 10, 10: PRINT "en el intervalo [0, 1]."
  
   'Variable de tiempo
    time1 = TIMER
  
   'Invocando a QUANC8
     CALL QUANC8(A, B, ABSERR, RELERR, RESULT, ERREST, NOFUN%, FLAG)
  
   'Variable de tiempo
    time2 = TIMER
  
   'Resultados
     LOCATE 12, 5
     PRINT "Integral ="; RESULT, "error ="; ERREST, "nm. de paneles ="; NOFUN%
     IF FLAG <> 0! THEN PRINT "flag ="; FLAG
     LOCATE 14, 5: PRINT "Tiempo de ejecucin: "; time2 - time1; " segs."
   
    'Eleccin de proseguir o finalizar
10    LOCATE 24, 25: PRINT "  DESEA OTRO CALCULO (S/N) ?  ";
    'Coordenadas del cursor
      coorx = CSRLIN: coory = POS(0)

    'Captura
20    DO
         k$ = INKEY$
      LOOP WHILE k$ = ""

    'El cracter tecleado se transforma maysculas
      k$ = UCASE$(k$)

    'Se seleccion S o N?
      IF k$ = "N" THEN
         'Fin de sesin
         CLS : END
      ELSE
         IF k$ <> "S" THEN
            SOUND 500, 2
            'Borrado de un caracter sobre la lnea actual
            LOCATE coorx, coory - 1: PRINT "   "
            GOTO 20
         END IF
      END IF
 
  LOOP
 
  'Sentencias para manejo de errores de underflow u overflow
40 BEEP
   LOCATE 14, 8
   PRINT "Error detectado, cambie el valor de las tolerancias o verifique"
   LOCATE 15, 8
   PRINT "la ecuacin por integrar."
   RESUME 45
45 END

SUB centra (posx, Title$)

  'Subrutina para centrar textos con respecto a la pantalla
     'Coordenada "y" en base a la long. del texto y a la disponible en pantalla
     posy = INT((80 - LEN(Title$)) / 2)
     LOCATE posx, posy: PRINT Title$

END SUB

DEFINT I-K, N
SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
 
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
 
   'Letreros
     COLOR 0, 3
       'Se invoca a la subrutina para centrado de textos
       CALL centra(7, "T E C N I C A S    A V A N Z A D A S ")
       CALL centra(9, "D E     P R O G R A M A C I O N")
       CALL centra(13, "C A P I T U L O    IV")
       CALL centra(18, "Aproximacin de integrales usando la subrutina QUANC8")
       
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
  
   'Pausa de 2.5 segundos
     SLEEP 2.5

END SUB

DEFSNG I-K, N
FUNCTION FUN! (X)

 'Subprograma que evala la integral de la funcin error en el punto X,
 'cuya ecuacin es: f(x)=2/ e^(-x) = (cte) e^(-x)
 
  IF X = 0! THEN FUN = 0!
  IF X <> 0! THEN FUN = cte * EXP(-X ^ 2!)

END FUNCTION

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%
 
   'Mensaje
     LOCATE 3, 14: PRINT "APROXIMACION DE INTEGRALES USANDO LA SUBRUTINA QUANC8"

END SUB

SUB QUANC8 (A, B, ABSERR, RELERR, RESULT, ERREST, NOFUN%, FLAG)
  
   'Esta subrutina estima la integral de la funcin FUN(X), en el intervalo
   '[A, B] considerando la tolerancia proporcionada por el usuario, y repre
   'senta una subrutina auto-adaptable basada en la regla de los  8-paneles
   'de Newton-Cotes.
  
   'Variables de tipo real: FUN, A, B, ABSERR, RELERR, RESULT, ERREST, FLAG
   'Variables de tipo entero: NOFUN
  
   'ENTRADA:
   ' FUN ... Nombre de la funcin que vala la ecuacin a  integrar  en  el
   '         punto X { FUN(X) }.
   ' A ..... El lmite inferior de la integracin.
   ' B ..... El lmite superior de la integracin (B puede ser menor que A).
   ' RELERR. Tolerancia para el error relativo (debe ser positivo).
   ' ABSERR. Tolerancia para el error absoluto (debe ser positivo).
  
   'SALIDA:
   ' RESULT. Aproximacin de la integral que virtualmente satisface el mni-
   '         mo valor de entre las dos tolerancias de error.
   ' ERREST. Estimacin de la magnitud del error actual.
   ' NOFUN.. Nmero de valuaciones de la funcin (FUN), usadas en el clculo
   '         de RESULT.
   ' FLAG... Factor de integridad. Si FLAG es cero, entonces RESULT probable
   '         mente satisfaga la tolerancia de error. Si FLAG es XXX.YYY, en-
   '         tonces XXX ser el nmero de intervalos  que  no  convergen,  y
   '         0.YYY la fraccin del ltimo intervalo, a la izquierda, realiza
   '         do antes de que el valor lmite de NOFUN se halla alcanzado.
  
   'Variables de tipo real: W0, W1, W2, W3, W4, AREA, X0, F0, STONE, STEPP,
                          ' COR11, TEMP
   'Variables de tipo real: QPREV, QNOW, QDIFF, QLEFT, ESTERR, TOLERR
   'Variables de tipo real: QRIGHT(31), F(16), X(16), FSAVE(8, 30),
                          ' XSAVE(8, 30)
   'Variables de tipo entero: LEVMIN, LEVMAX, LEVOUT, NOMAX, NOFIN, LEV,
                            ' NIM, I, J
 
    DIM QRIGHT(31), F(16), X(16), FSAVE(8, 30), XSAVE(8, 30)

   '*** Etapa 1 *** inicializacin general -- Definicin de constantes
     LEVMIN% = 1
     LEVMAX% = 30
     LEVOUT% = 6
     NOMAX% = 5000
     NOFIN% = NOMAX% - 8 * (LEVMAX% - LEVOUT% + 2 ^ (LEVOUT% + 1))
    
     'Existe un problema cuando NOFUN alcanza el valor NOFIN
       W0 = 3956! / 14175!
       W1 = 23552! / 14175!
       W2 = -3712! / 14175!
       W3 = 41984! / 14175!
       W4 = -18160! / 14175!
    
     'Se inicializan las variables de las sumas acumulativas
       FLAG = 0!
       RESULT = 0!
       COR11 = 0!
       ERREST = 0!
       AREA = 0!
       NOFUN% = 0
       IF A = B THEN EXIT SUB
  
   '*** Etapa 2 *** inicializacin del primer intervalo
     LEV% = 0
     NIM% = 1
     X0 = A
     X(16) = B
     QPREV = 0!
     F0 = FUN(X0)
     STONE = (B - A) / 16!
     X(8) = (X0 + X(16)) / 2!
     X(4) = (X0 + X(8)) / 2!
     X(12) = (X(8) + X(16)) / 2!
     X(2) = (X0 + X(4)) / 2!
     X(6) = (X(4) + X(8)) / 2!
     X(10) = (X(8) + X(12)) / 2!
     X(14) = (X(12) + X(16)) / 2!
     FOR J% = 2 TO 16 STEP 2
         F(J%) = FUN(X(J%))
     NEXT J%
     NOFUN% = 9
  
   '*** Etapa 3 *** clculos centrales
   'Se requiere de QPREV, X0, X2, X4, ..., X16, F0, F2, F4, ..., F16
   'Se clculan X1, X3, ..., X15, F1, F3, ..., F15, QLEFT, QRIGHT, QNOW, QDIFF, AREA
30   X(1) = (X0 + X(2)) / 2!
     F(1) = FUN(X(1))
     FOR J% = 3 TO 15 STEP 2
         X(J%) = (X(J% - 1) + X(J% + 1)) / 2!
         F(J%) = FUN(X(J%))
     NEXT J%
     NOFUN% = NOFUN% + 8
     STEPP = (X(16) - X0) / 16!
     QLEFT = (W0 * (F0 + F(8)) + W1 * (F(1) + F(7)) + W2 * (F(2) + F(6)) + W3 * (F(3) + F(5)) + W4 * F(4)) * STEPP
     QRIGHT(LEV% + 1) = (W0 * (F(8) + F(16)) + W1 * (F(9) + F(15)) + W2 * (F(10) + F(14)) + W3 * (F(11) + F(13)) + W4 * F(12)) * STEPP
     QNOW = QLEFT + QRIGHT(LEV% + 1)
     QDIFF = QNOW - QPREV
     AREA = AREA + QDIFF
  
   '*** Etapa 4 *** prueba de convergencia del intervalo
     ESTERR = ABS(QDIFF) / 1023!
     IF ABSERR > RELERR * ABS(AREA) THEN
        TOLERR = ABSERR * (STEPP / STONE)
     ELSE
        TOLERR = RELERR * ABS(AREA) * (STEPP / STONE)
     END IF
     IF LEV% < LEVMIN% THEN GOTO 50
     IF LEV% >= LEVMAX% THEN GOTO 62
     IF NOFUN% > NOFIN% THEN GOTO 60
     IF ESTERR <= TOLERR THEN GOTO 70
  
   '*** Etapa 5 *** no convergencia del intervalo -- Localizacin del
   'siguiente intervalo
50   NIM% = 2 * NIM%
     LEV% = LEV% + 1
    
     'Almacenaje de los elementos del lado derecho para un uso futuro
       FOR I% = 1 TO 8
           FSAVE(I%, LEV%) = F(I% + 8)
           XSAVE(I%, LEV%) = X(I% + 8)
       NEXT I%
    
     'Reacomodo de los elementos del lado izquierdo para su uso inmediato
       QPREV = QLEFT
       FOR I% = 1 TO 8
           J% = -I%
           F(2 * J% + 18) = F(J% + 9)
           X(2 * J% + 18) = X(J% + 9)
       NEXT I%
     GOTO 30
  
   '*** Etapa 6 *** seccin de problemas
   'El nmero de valuaciones de la funcin (FUN) no debe exceder el lmite
60   NOFIN% = 2 * NOFIN%
     LEVMAX% = LEVOUT%
     FLAG = FLAG + (B - X0) / (B - A)
    GOTO 70
   
    'El valor actual de LEVEL es LEVMAX
62    FLAG = FLAG + 1!
  
   '*** Etapa 7 *** intevalo convergente -- Se adiciona las variables a las
   'sumas acumulativas
70   RESULT = RESULT + QNOW
     ERREST = ERREST + ESTERR
     COR11 = COR11 + QDIFF / 1023!
    
     'Localizacin del siguiente intervalo
72     IF NIM% = 2 * INT(NIM% / 2) THEN GOTO 75
       NIM% = NIM% / 2
       LEV% = LEV% - 1
     GOTO 72
75   NIM% = NIM% + 1
     IF LEV% <= 0 THEN GOTO 80
    
     'Reacomodo de los elementos requeridos en el siguiente intervalo
       QPREV = QRIGHT(LEV%)
       X0 = X(16)
       F0 = F(16)
       FOR I% = 1 TO 8
           F(2 * I%) = FSAVE(I%, LEV%)
           X(2 * I%) = XSAVE(I%, LEV%)
       NEXT I%
     GOTO 30
  
   '*** Etapa 8 *** finalizacin y salida de la subrutina
80   RESULT = RESULT + COR11
    
     'Se verifica que ERREST no sea menor que el error de redondeo
       IF (ERREST = 0!) THEN EXIT SUB
82   TEMP = ABS(RESULT) + ERREST
     IF TEMP <> ABS(RESULT) THEN EXIT SUB
     ERREST = 2! * ERREST
     GOTO 82

END SUB

