
  'Programa fuente para el uso de la subrutina RKF45 (solucin de ecuaciones
  'diferenciales).
 
     'Versin 1.0 (programa fuente creado por J. Antonio Ruiz G., 1992)
 
     'Como ejemplo se emplea la solucin de la E.D. que representa a la
     'funcin error:   y'(x) = 1/ e^(-x)
  
   DECLARE SUB centra (posx!, Title$)
   DECLARE SUB enrolla ()
   DECLARE SUB F (T!, Y!(), YP!())
   DECLARE SUB FEHL (NEQN%, Y!(), T!, H!, YP!(), F1!(), F2!(), F3!(), F4!(), F5!(), S!())
   DECLARE SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)
   DECLARE SUB RKF45 (NEQN%, Y(), T, TOUT, RELERR, ABSERR, IFLAG%, WORK(), IWORK%())
   DECLARE SUB RKFS (NEQN%, Y!(), T!, TOUT!, RELERR!, ABSERR!, IFLAG%, YP!(), H!, F1!(), F2!(), F3!(), F4!(), F5!(), SAVRE!, SAVAE!, NFE%, KOP%, INIT%, JFLAG%, KSFLAG%)
  
   'Declaracin de variables y arreglos estticos comnes
     COMMON SHARED cte
     DIM SHARED IWORK%(5)
  
   'Cursor invisible
    LOCATE , , 0
  
   'Se invoca a la subrutina que genera una pantalla de presentacin
    CALL enrolla

   'Cursor visible
    LOCATE , , 1
  
   'Inicia el proceso
   DO
     'Se designa el rea visual de trabajo y se la asigna color
       VIEW PRINT
       COLOR 1, 9, 9
  
     CLEAR
     CLS
  
     'Invocando a la subrutina que genera un marco
       CALL marco(2, 4, 3, 78, 10, 7)
     LOCATE 6, 10: PRINT "Evaluacin de la funcin error, definida por la ecuacin"
     LOCATE 7, 30: PRINT "f'(x)=2/ e^(-x)"
    
     'Se declaran e inicializan contadores, tolerancias, condiciones
     'iniciales y constantes (cte=1/)
       'Contadores
         T = 0
         TFINAL = 1
         TPRINT = .1
         TOUT = T
    
       'Tolerancias
         RELERR = .0001#
         ABSERR = .0001#
    
       'Nmero de E.D.
         NEQN% = 1
     
       'Dimensionando los arreglos dinmicos comunes, en funcin del nmero
       'de E.D.
         DIM SHARED Y(NEQN%), YP(NEQN%), WORK(3 + 6 * NEQN%)
         DIM SHARED F1(NEQN%), F2(NEQN%), F3(NEQN%), F4(NEQN%), F5(NEQN%), S(NEQN%)
      
       'Condiciones iniciales
         Y(1) = 0!
    
       'Constantes
         cte = 2! / SQR(3.141592653589#)
    
       'Variable para RKF45 (significa solucin paso a paso)
         IFLAG% = 1
      
       'Posicin inicial para despliegue de letreros
         LOCATE 10, 1
      
       'Variable para conteo de tiempo
         AA = TIMER
    
     'Se llama a RKF45 o RKFS, segn el procesador del equipo de cmputo lo
     'permita (checar comentarios de la subprograma RKF45)
''10  call RKF45 (NEQN%, Y(), T, TOUT, RELERR, ABSERR, IFLAG%, WORK(), IWORK%())
10   CALL RKFS(NEQN%, Y(), T, TOUT, RELERR, ABSERR, IFLAG%, YP(), H, F1(), F2(), F3(), F4(), F5(), SAVRE, SAVAE, NFE%, KOP%, INIT%, JFLAG%, KSFLAG%)
    
     'Impresin de la solucin clculo a clculo
       PRINT TAB(30); "ERF("; : PRINT USING "#.#"; T; : PRINT ")="; Y(1)
    
     'Anlisis del identificador de RKF45 (se realiza clculo a clculo)
     SELECT CASE IFLAG%
            CASE -2
               TOUT = T + TPRINT
               IF T < TFINAL GOTO 10
            CASE 2
               TOUT = T + TPRINT
               IF T < TFINAL GOTO 10
            CASE 3
               PRINT "LAS TOLERANCIAS DEBEN REEMPLAZARSE:"
               PRINT "relerr="; RELERR, "abserr="; ABSERR
               GOTO 10
            CASE 4
               GOTO 10
            CASE 5
               ABSERR = 1E-09
               PRINT "LAS TOLERANCIAS DEBEN REEMPLAZARSE POR:"
               PRINT "relerr="; RELERR, "abserr="; ABSERR
               GOTO 10
            CASE 6
               RELERR = 10! * RELERR
               PRINT "LAS TOLERANCIAS SE DEBEN REMPLAZARSE POR:"
               PRINT "relerr="; RELERR, "abserr="; ABSERR
               IFLAG% = 2
               GOTO 10
            CASE 7
               PRINT "INEFICIENCIAS EN LA SOL. DE ESTA EC."
               IFLAG% = 2
               GOTO 10
            CASE 8
               PRINT "LLAMADA INADECUADA"
     END SELECT
  
     'Variable para conteo de tiempo
       BB = TIMER
    
     PRINT
     PRINT TAB(20); "Tiempo de mquina invertido:"; BB - AA; "segs."
     
    'Eleccin de proseguir o finalizar
20    LOCATE 24, 25: PRINT "  DESEA OTRO CALCULO (S/N) ?  ";
    'Coordenadas del cursor
      coorx = CSRLIN: coory = POS(0)

    'Captura
30    DO
         k$ = INKEY$
      LOOP WHILE k$ = ""

    'El cracter tecleado se transforma maysculas
      k$ = UCASE$(k$)

    'Se seleccion S o N?
      IF k$ = "N" THEN
         'Fin de sesin
         CLS : END
      ELSE
         IF k$ <> "S" THEN
            SOUND 500, 2
            'Borrado de un caracter sobre la lnea actual
            LOCATE coorx, coory - 1: PRINT "   "
            GOTO 30
         END IF
      END IF

 LOOP
  
   

SUB centra (posx, Title$)

  'Subrutina para centrar textos con respecto a la pantalla
     'Coordenada "y" en base a la long. del texto y a la disponible en pantalla
     posy = INT((80 - LEN(Title$)) / 2)
     LOCATE posx, posy: PRINT Title$

END SUB

SUB enrolla
 
  'Subrutina que despliega una cortina para presentacin de ttulos
  
   'Creacin de la cortina
     CLS
     VIEW PRINT
     COLOR 3, 1
       FOR AR = 8 TO 70
           FOR RA = 4 TO 21
               COLOR 7
                 LOCATE RA + 1, AR + 1: PRINT ""
               COLOR 3
                 LOCATE RA, AR: PRINT ""
       NEXT RA, AR
 
   'Letreros
     COLOR 0, 3
       'Se invoca a la subrutina para centrado de textos
       CALL centra(7, "T E C N I C A S    A V A N Z A D A S ")
       CALL centra(9, "D E     P R O G R A M A C I O N")
       CALL centra(13, "C A P I T U L O   V")
       CALL centra(17, "Aproximacin de Ecuaciones Diferenciales")
       CALL centra(18, "usando la Subrutina RKF45")
     COLOR 31, 0
       LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
  
   'Pausa de 2.5 segundos
     SLEEP 2.5
  
END SUB

SUB F (T, Y(), YP())
 
  'Subprograma que evala la(s) ecuacin(es) diferencial(es).
  'Como ejemplo se emplea la que representa a la funcin error:
                 ' y'(x) = 1/ e^(-x) = cte e^(-x)
   
    YP(1) = cte * EXP(-T ^ 2!)

END SUB

SUB FEHL (NEQN%, Y(), T, H, YP(), F1(), F2(), F3(), F4(), F5(), S())
           
           'METODO DE RUNGE-KUTTA FEHLBERG DE CUARTO-QUINTO ORDEN
 
 'FEHL soluciona un sistema de NEQN% E.D.O. de primer orden, de la forma:
                'DY(I)/DT = F(T, Y(1), Y(2), ..., Y(NEQN%))
 'donde cada valor inicial Y(I) y cada derivada inicial YP(I), estn especi-
 'ficadas para el punto de inicio T. FEHL tiende a la  solucin  sobre  cada
 'paso fijo H, y regresa con la aproximacin de  la  solucin  de  5  orden
 '(6 orden de exactitud local) para el punto T+H, en el arreglo S(I).
 'F1, ..., F5 -- Son arreglos de dimensin NEQN%,  los  cuales  se  utilizan
 'para almacenaje interno. Las frmulas han sido agrupadas para controlar la
 'prdida de significatividad. FEHL debe invocarse con una H no menor de  13
 'unidades de redondeo en T, por lo  que  varios  argumentos  independientes
 'pueden distinguirse.

 'Variables enteras: NEQN%, K%
 'Variables reales: Y(NEQN%),T,H,YP(NEQN%),F1(NEQN%),F2(NEQN%),F3 (NEQN%),
 '                  F4(NEQN%), F5(NEQN%), S(NEQN%), CH

    CH = H / 4!
    FOR k% = 1 TO NEQN%
        F5(k%) = Y(k%) + CH * YP(k%)
    NEXT
    CALL F(T + CH, F5(), F1())

    CH = 3! * H / 32!
    FOR k% = 1 TO NEQN%
        F5(k%) = Y(k%) + CH * (YP(k%) + 3! * F1(k%))
    NEXT
    CALL F(T + 3! * H / 8!, F5(), F2())

    CH = H / 2197!
    FOR k% = 1 TO NEQN%
        F5(k%) = Y(k%) + CH * (1932! * YP(k%) + (7296! * F2(k%) - 7200! * F1(k%)))
    NEXT
    CALL F(T + 12! * H / 13!, F5(), F3())

    CH = H / 4104!
    FOR k% = 1 TO NEQN%
        F5(k%) = Y(k%) + CH * ((8341! * YP(k%) - 845! * F3(k%)) + (29440! * F2(k%) - 32832! * F1(k%)))
    NEXT
    CALL F(T + H, F5(), F4())
   
    CH = H / 20520!
    FOR k% = 1 TO NEQN%
        F1(k%) = Y(k%) + CH * ((-6080! * YP(k%) + (9295! * F3(k%) - 5643! * F4(k%))) + (41040! * F1(k%) - 28352! * F2(k%)))
    NEXT
    CALL F(T + H / 2!, F1(), F5())

  'Se calcula la aproximacin de la solucin para T+H
    CH = H / 7618050#
    FOR k% = 1 TO NEQN%
        S(k%) = Y(k%) + CH * ((902880! * YP(k%) + (3855735# * F3(k%) - 1371249# * F4(k%))) + (3953664# * F2(k%) + 277020! * F5(k%)))
    NEXT

END SUB

SUB marco (reni%, renf%, coli%, colf%, ci%, cf%)

 'Subrutina que genera un marco

   'reni%, renf%-- rengln inicial y final del recuadro
   'coli%, colf%-- columna inicial y final del recuadro
   'ci%, cf%    -- color inicial (recuadro) y final (mensaje)

   'Caractersticas del marco (lnea sencilla)
     esi$ = "": lhs$ = "": lv$ = "": esd$ = ""
     eii$ = "": lhi$ = "": eid$ = ""

   'Se despliega el recuadro
   COLOR ci%
     LOCATE reni%, coli%: PRINT esi$
     LOCATE reni%, colf%: PRINT esd$
     LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
     FOR I% = reni% + 1 TO renf%
         LOCATE I%, coli%: PRINT lv$
         LOCATE I%, colf%: PRINT lv$
     NEXT I%
     LOCATE renf%, coli%: PRINT eii$
     LOCATE renf%, colf%: PRINT eid$
     LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%
 
   'Letrero
     LOCATE 3, 8: PRINT "APROXIMACION DE ECUACIONES DIFERENCIALES USANDO LA SUBRUTINA RKF45 "
    
END SUB

SUB RKF45 (NEQN%, Y(), T, TOUT, RELERR, ABSERR, IFLAG%, WORK(), IWORK%())
           
           'METODO DE RUNGE-KUTTA FEHLBERG DE CUARTO-QUINTO ORDEN
 
 'Escrito por H.A.WATTS y L.F.SHAMPINE,  Laboratorios  SANDIA,  Albuquerque,
 'New Mexico. RKF45 fue diseada inicialmente para resolver ecuaciones dife-
 'renciales (E.D.), semi-inflexivas y no-inflexivas, cuando sus derivadas no
 'son de difcil evaluacin. RKF45 no debe usarse, por lo general, cuando el
 'usuario demande excesiva precisin.

 'RESUMEN:

 'La subrutina RKF45 resuelve un sistema de NEQN% E.D.  ordinarias  de  1er.
 'orden, de la forma: DY(I)/DT = F(T, Y(1), Y(2), ..., Y(NEQN%)), donde cada
 'Y(I) est dada para T. Comnmente, esta subrutina se emplea para  integrar
 'de T a TOUT, pero, puede  usarse  como  un  integrador  de  un-paso,  para
 'avanzar, en la direccin de TOUT, una etapa en la solucin. En el regreso,
 'los parmetros incluidos en la llamada, son ajustados para  proseguir  con
 'la solucin. El usuario slo tiene que llamar a RKF45 de  nuevo  (y  quiz
 'definir un nuevo valor para TOUT). RKF45 es una rutina de enlace que llama
 'a la subrutina RKFS para hallar la solucin. RKFS, a su vez, invoca  a  la
 'subrutina FEHL, la cual calcula, para cada paso, una  aproximacin  de  la
 'solucin.

 'RKF45 se basa en el mtodo de Runge-Kutta-Fehlberg (4,5)  descrito  en  la
 'referencia: E. FEHLBERG, "LOW-ORDER CLASSICAL  RUNGE-KUTTA  FORMULAS  WITH
 'STEPSIZE CONTROL", NASA TR R - 315.
 'El desarrollo de RKF45 se ilustra en la referencia: L. F. SHAMPINE,  H. A.
 'WATTS y S. DAVENPORT, "SOLVING NON-STIFF ORDINARY DIFFERENTIAL  EQUATIONS-
 'THE STATE  OF  THE  ART",  SANDIA  LABORATORIES  REPORT  SAND75-0182,  que
 'apareci en SIAM REVIEW.

 'SIGNIFICADO DE LOS PARAMETROS:

 '     F -- Subprograma F(T,Y(),YP()), que evala las derivadas
 '          YP(I) = DY(I)/DT.
 ' NEQN% -- Nmero de ecuaciones por resolver.
 '  Y(*) -- Vector solucin en T.
 '     T -- Variable independiente.
 '  TOUT -- Punto final en el que se desea la solucin.
 'RELERR,
 'ABSERR -- Tolerancias para pruebas locales de error relativo  y  absoluto.
 '          En cada paso, los  componentes  de  error  local  y  del  vector
 '          solucin, deben satisfacer:
 '                    ABS(LOCAL ERROR) <= RELERR*ABS(Y) + ABSERR.
 'IFLAG% -- Indicador de la situacin de la solucin.
 'WORK(*) - Arreglo para manejo de informacin interna para RKF45,  la  cual
 '          se necesita en las llamadas subsecuentes.  Su  dimensin  cuando
 '          menos debe ser de 3+6*NEQN%.
 'IWORK%(*) -- Arreglo, de tipo entero, para manejo interno  de  informacin
 '          til para RKF45 en llamadas  posteriores.  Su  dimensin  cuando
 '          menos debe ser de 5.

 'PRIMERA LLAMADA A RKF45:
 
 'El usuario debe prever el dimensionamiento, desde su  programa  principal,
 'para los arreglos involucrados en la  llamada  Y(NEQN%),  WORK(3+6*NEQN%),
 'IWORK%(5), debe crear  el  subprograma  F(T,Y(),YP())  e  inicializar  los
 'siguientes parmetros:
 ' NEQN% -- Nmero de ecuaciones por resolver (NEQN% >= 1).
 '  Y(*) -- Vector de condiciones iniciales.
 '     T -- Punto de inicio de la solucin, debe ser una variable.
 '  TOUT -- Punto final en el que se desea la solucin, T=TOUT es  permitido
 '          slo en  la  primera  llamada,  en  cuyo  caso,  si  es  posible
 '          continuar, RKF45 regresar con IFLAG%=2.
 'RELERR,
 'ABSERR -- Tolerancias locales de error relativo y absoluto; deben ser  po-
 '          sitivas. RELERR debe ser variable y ABSERR constante. La subruti
 '          na normalmente no debe ser usada con un control de error relati-
 '          vo mayor que 1E-8. Para evitar dificultades con la precisin, es
 '          necesario que RELERR sea a lo ms,  tan  grande  como  el  error
 '          relativo  computado  internamente,  el  cual  depende  de   cada
 '          computadora.  En  particular,  el  error  absoluto  puro  no  es
 '          permitido.
 '          Si se elige un valor de RELERR mayor  que  el  disponible, RKF45
 '          modifica apropiadamente el valor de RELERR y devuelve su control
 '          al usuario, antes de continuar con la solucin.
 'IFLAG% -- +1,-1, este indicador debe inicializase para cada nuevo problema.
 '          Para un proceso normal es +1. El usuario debe asignarle el valor
 '          de -1, si desea slo la solucin a un-paso. En este caso,  RKF45
 '          avanza a la solucin en la direccin de TOUT, en un paso  senci-
 '          llo, cada vez que es llamada. Como este modo de operacin genera
 '          un gasto de cmputo extra, debe evitarse a menos que sea  forzo-
 '          samente requerido.

 'SALIDA DE RKF45:
 
 '      Y(*) -- Solucin en T.
 '         T -- Ultimo punto alcanzado en la solucin.
 'IFLAG% = 2 -- Si la solucin lleg a TOUT. Indica un regreso completo y es
 '              el valor normal para una solucin continua.
 '       =-2 -- Un paso completo en la direccin de TOUT ha sido  realizado,
 '              y es el valor normal para una solucin paso a paso.
 '       = 3 -- La solucin no se finaliz porque  la  tolerancia  de  error
 '              relativo es excesiva. RELERR debe modificarse  adecuadamente
 '              para continuar.
 '       = 4 -- La solucin no se finaliz porque las derivadas se evaluaron
 '              ms de 3000 veces (esto significa 500 pasos aproximadamente).
 '       = 5 -- La solucin no se finaliz porque la solucin se  desprecia,
 '              haciendo imposible una prueba de error relativo puro. ABSERR
 '              debe ser diferente de cero para proseguir. Usar el  modo  de
 '              solucin paso a paso es una buena manera de proceder.
 '       = 6 -- La solucin no se finaliz porque la precisin demandada  no
 '              pudo lograrse al ser considerado el mnimo  tamao  de  paso
 '              disponible. El usuario debe  modificar  las  tolerancias  de
 '              error antes de proseguir.
 '       = 7 -- Parece que RKF45 es ineficiente para resolver este problema.
 '              Tantos pasos (con sus respectivos datos  de  salida),  estn
 '              restringiendo la eleccin natural del tamao del  paso.  Use
 '              el modo de solucin de un paso.
 '       = 8 -- Parmetros de entrada invlidos. Esto ocurre cuando si:
 '              NEQN% <= 0, T=TOUT e IFLAG% <> +1  -1, RELERR o ABSERR < 0,
 '              IFLAG% = 0  < -2  > 8.
 'WORK(*),
 'IWORK%(*)  -- Informacin no interesante para el usuario, pero, til  para
 '              llamadas subsecuentes. WORK(1), ...,  WORK(NEQN%)  contienen
 '              las primeras derivadas del vector solucin Y en T.
 '              WORK(NEQN%+1) contiene el tamao del paso H, que ser reque-
 '              rido en el siguiente clculo. IWORK%(1) es  el  contador  de
 '              evaluaciones de las derivadas.
 
 'LLAMADAS SUBSECUENTES A RKF45:
 
 'RKF45 regresa con toda la informacin  necesaria  para  continuar  con  la
 'solucin. Si TOUT es alcanzado, el usuario debe definir un nuevo valor  de
 'TOUT e invocar a RKF45 una vez ms. En el modo  de  solucin  de  un  paso
 '(IFLAG%=-2), el usuario debe tener en mente que cada paso es tomado en  la
 'direccin del TOUT actual. Hasta alcanzarse el valor de TOUT (indicado por
 'el cambio de IFLAG% a 2), el usuario proporcionar un nuevo TOUT y redefi-
 'nir IFLAG%=-2 para continuar en el modo de solucin de un paso.
 
 'Si la solucin no se finaliz, pero el usuario desea continuar (IFLAG%=3 
 '4), debe invocarse RKF45 una vez ms. Si IFLAG%=3,  RELERR  ser  ajustado
 'apropiadamente para proseguir la solucin. En el  caso  de  que  IFLAG%=4,
 'el contador de funciones ser reinicilizado a 0 y podrn  realizarse  3000
 'evaluaciones extras. Sin embargo, en el caso de que IFLAG%=5,  el  usuario
 'modificar el criterio de error en ABSERR, antes de continuar con la solu-
 'cin. Si no lo hace, el proceso terminar. Tambin,  en  el  caso  de  que
 'IFLAG%=6, es necesario reinicilizar IFLAG% a 2 (-2 en el modo de  solucin
 'de un paso), a la vez que se modifica ABSERR, REELERR o  ambos,  antes  de
 'continuar con la solucin. Si esto no se hace, el  proceso  terminar.  El
 'que IFLAG%=6, indica que la solucin cambia rpidamente, y,  por lo tanto,
 'la singularidad puede presentarse. A menudo, es imprudente proseguir.

 'Cuando IFLAG%=7, debe emplearse el modo de solucin de un paso, con un ta-
 'mao del paso igual al determinado en el proceso o al seleccionado de  los
 'algoritmos de Adams (DE/STEP o INTRP). Si se insiste en continuar  con  el
 'uso de RKF45, debe asignarse el valor de 2 a IFLAG% antes de volver a lla-
 'mar a RKF45. Si no, el proceso terminar.
 'Si IFLAG%=8, la ejecucin no podr proseguir hasta que no se corrijan  los
 'parmetros de entrada.

 'Debe observarse, que los arreglos WORK e IWORK%, contienen la  informacin
 'requerida para las soluciones sucesivas. Por lo tanto, WORK  e  IWORK%  no
 'deben alterarse.

 'Variables enteras: NEQN%, IFLAG%, IWORK%(), K1, K2, K3, K4, K5, K6, K1M
 'Variables reales: REAL Y(NEQN%), T, TOUT, RELERR, ABSERR, WORK()

 'Clculo de los ndices para la divisin de los arreglos de trabajo
    K1M% = NEQN% + 1
    K1% = K1M% + 1
    K2% = K1% + NEQN%
    K3% = K2% + NEQN%
    K4% = K3% + NEQN%
    K5% = K4% + NEQN%
    K6% = K5% + NEQN%

 'Esta rutina de enlace solamente releva al usuario de una  larga  lista  de
 'parmetros de transferencia en la llamada, por medio de  la  particin  de
 'los dos arreglos de trabajo. Si esta sintaxis no  es  compatible  con  los
 'compiladores empleados, debe invocarse a RKFS directamente desde el progra
 'ma fuente y anularse la siguiente instruccin:
    ''CALL RKFS(NEQN%, Y, T, TOUT, RELERR, ABSERR, IFLAG%, WORK(1), WORK(K1M%), WORK(K1%), WORK(K2%), WORK(K3%), WORK(K4%), WORK(K5%), WORK(K6%), WORK(K6% + 1), IWORK%(1), IWORK%(2), IWORK%(3), IWORK%(4), IWORK%(5))

END SUB

SUB RKFS (NEQN%, Y(), T, TOUT, RELERR, ABSERR, IFLAG%, YP(), H, F1(), F2(), F3(), F4(), F5(), SAVRE, SAVAE, NFE%, KOP%, INIT%, JFLAG%, KSFLAG%)
        
         'METODO DE RUNGE-KUTTA FEHLBERG DE CUARTO-QUINTO ORDEN
 
 'RKFS soluciona un sitema de E.D.O. de primer orden, como los descritos en
 'los comentarios de RKF45. Los arreglos YP(), F1(), F2(),  F3(),  F4(),  y
 'F5() (de dimensin al menos de NEQN%) y las variables  H,  SAVRE,  SAVAE,
 'NFE%, KOP%, INIT%, JFLAG% y KFLAG%, son usadas internamente por el algo--
 'ritmo y aparecen en la llamada, para eliminar la retencin local  de  va-
 'riables entre llamadas. Por lo cual, no deben alterarse.
 
 'Tpicos de inters son:   YP -- Vector de derivadas con solucin en T.
 '                           H -- Tamao apropiado de paso para el siguien
 '                                te clculo.
 '                        NFE% -- Contador del nmero de evaluaciones de las
 '                                derivadas.

 'Variables lgicas: HFAILD, OUTPUT1
 'Variables enteras: NEQN%,IFLAG%,NFE%,KOP%,INIT%,JFLAG%,KFLAG%,K%, MAXNFE%,
 '                   MFLAG%
 'Variables reales:  Y(NEQN%),T,TOUT,RELERR,ABSERR,H, YP(NEQN%),  F1(NEQN%),
  '                   F2(NEQN%),F3(NEQN%),F4(NEQN%),F5(NEQN%),SAVRE,SAVAE,A,
  '                   AE,DT,EE,EEOET,ESTTOL,ET,HMIN,REMIN,RER,S, SCALE, TOL,
  '                   TOLN,U26,EPSP1,EPS,YPK,AMAX1,AMIN1

 'REMIN es el valor mnimo aceptable de RELERR. Intentar obtener mayor preci
 'sin con est subrutina es difcil y a menudo no se tiene xito.
    REMIN = 7E-09
 
 'El mximo nmero de evaluaciones de las ecuaciones est controlado aproxi-
 'madamente por MAXNFE%. Esto corresponde a cerca de 500 pasos.
    MAXNFE% = 3000

  'Se checan los parmetros de entrada
    IF NEQN% < 1 GOTO R10
    IF (RELERR < 0!) OR (ABSERR < 0!) GOTO R10
    MFLAG% = INT(ABS(IFLAG%))
    IF (MFLAG% = 0) OR (MFLAG% > 8) GOTO R10
    IF MFLAG% <> 1 GOTO R20

  'Primera llamada, se clcula el machine epsilon
    EPS = 1!
R5: EPS = EPS / 2!
    EPSP1 = EPS + 1!
    IF (EPSP1 > 1!) GOTO R5
    U26 = 26! * EPS
    GOTO R50

  'Valores de entrada no vlidos
R10: IFLAG% = 8
    EXIT SUB

  'Se verifican las posibilidades restantes
R20: IF (T = TOUT) AND (KFLAG% <> 3) GOTO R10
    IF MFLAG% <> 2 GOTO R25

    'IFLAG% = 2  -2
      IF (KFLAG% = 3) OR (INIT% = 0) GOTO R45
      IF KFLAG% = 4 GOTO R40
      IF (KFLAG% = 5) AND (ABSERR = 0!) GOTO R30
      IF (KFLAG% = 6) AND (RELERR <= SAVRE) AND (ABSERR <= SAVAE) GOTO R30
      GOTO R50

    'IFLAG% = 3, 4, 5, 6, 7  8
R25:  IF IFLAG% = 3 GOTO R45
      IF IFLAG% = 4 GOTO R40
      IF (IFLAG% = 5) AND (ABSERR > 0!) GOTO R45

  'La solucin no puede continuar mientras el usuario no halla actuado con-
  'forma a las instrucciones pertinentes para IFLAG%=5,6,7  8.
R30: STOP

  'Se reinicializa el contador de evaluaciones
R40: NFE% = 0
    IF MFLAG% = 2 GOTO R50

  'Se asigna al identificador el valor de la llamada previa
R45: IFLAG% = JFLAG%
    IF KFLAG% = 3 THEN MFLAG% = INT(ABS(IFLAG%))

  'Se salva el valor de entrada IFLAG% y se asigna un nuevo valor al identi-
  'ficador para el subsecuente chequeo de entrada.
R50: JFLAG% = IFLAG%
    KFLAG% = 0

  'Se salvan RELERR y ABSERR para el chequeo en subsecuentes llamadas
    SAVRE = RELERR
    SAVAE = ABSERR

  'La tolerancia de error relativo debe ser al menos 2*EPS+REMIN para evitar
  'las dificultades de precisin originadas por requerimientos de  exactitud
  'inalcanzables
    RER = 2! * EPS + REMIN
    IF RELERR >= RER GOTO R55

  'Tolerancia de error demasiado pequea
    RELERR = RER
    IFLAG% = 3
    KFLAG% = 3
    EXIT SUB

R55: DT = TOUT - T
    IF MFLAG% = 1 GOTO R60
    IF INIT% = 0 GOTO R65
    GOTO R80

  'Inicializacin del indicador de finalizacin, INIT%, del indicador de ex-
  'ceso puntos de salida, KOP%, de la evaluacin de derivadas iniciales, del
  'contador de evaluaciones de las ecuaciones, NFE%,  y  del  estimador  del
  'tamao del paso inicial.
R60: INIT% = 0
    KOP% = 0
    A = T
    CALL F(A, Y(), YP())
    NFE% = 1
    IF T <> TOUT GOTO R65
    IFLAG% = 2
    EXIT SUB

R65: INIT% = 1
    H = ABS(DT)
    TOLN = 0!
    FOR k% = 1 TO NEQN%
        TOL = RELERR * ABS(Y(k%)) + ABSERR
        IF TOL <= 0! GOTO R70
        TOLN = TOL
        YPK = ABS(YP(k%))
        IF YPK * H ^ 5 > TOL THEN H = (TOL / YPK) ^ .2
R70: NEXT
    IF TOLN <= 0! THEN H = 0!
    IF ABS(T) > ABS(DT) THEN H1 = ABS(T) ELSE H1 = ABS(DT)
    IF H < (U26 * H1) THEN H = U26 * H1
    IF IFLAG% >= 0! THEN JFLAG% = -2 ELSE JFLAG% = 2

  'Se asigna el tamao del paso para la solucin en la direccin de T a TOUT
R80: IF DT >= 0! THEN H = -H

  'Se verifica si RKF45 est siendo afectada severamente por el exceso de
  'puntos de salida
    IF ABS(H) >= (2! * ABS(DT)) THEN KOP% = KOP% + 1
    IF KOP% <> 100 GOTO R85

  'Frecuencia de salida innecesaria
    KOP% = 0
    IFLAG% = 7
    EXIT SUB

R85: IF ABS(DT) > (U26 * ABS(T)) GOTO R95
  'Si est muy cercano el punto de salida, se extrapola y se aborta la sub-
  'rutina
    FOR k% = 1 TO NEQN%
        Y(k%) = Y(k%) + DT * YP(k%)
    NEXT
    A = TOUT
    CALL F(A, Y(), YP())
    NFE% = NFE% + 1
    GOTO R300

  'Se inicializa el indicador de puntos de salida
R95: OUTPUT1 = 0

  'Para evitar un prematuro UNDERFLOW en la funcin de tolerancia de error,
  'se escalan las tolerancias de error
    SCALE = 2! / RELERR
    AE = SCALE * ABSERR

  'Solucin paso a paso
R100: HFAILD = 0

  'Se asigna el mnimo tamao de paso disponible
    HMIN = U26 * ABS(T)

  'Ajuste del tamao de paso si es necesario para alcanzar el punto de sali-
  'da. Se revisan 2 pasos hacia adelante para prevenir cambios drsticos  en
  'el tamao del paso y por lo tanto aminorar el impacto de  los  puntos  de
  'salida sobre el algoritmo.
    DT = TOUT - T
    IF ABS(DT) >= (2! * ABS(H)) GOTO R200
    IF ABS(DT) > ABS(H) GOTO R150

  'El siguiente paso completa la solucin para el punto de salida
    OUTPUT1 = 1
    H = DT
    GOTO R200
R150: H = .5 * DT

 'SOLUCION CENTRAL PARA PASOS SIMPLES
 
 'Las tolerancias han sido escaladas para prevenir un prematuro UNDERFLOW en
 'el clculo de la tolerancia de error por la funcin ET. Para  evitar  pro-
 'blemas por cruzamiento de ceros, el error relativo  es  medido  usando  un
 'promedio de las magnitudes de la solucin al inicio y final del  paso.  La
 'frmula para estimar el error se ha agrupado para controlar la prdida  de
 'significatividad. Para distinguir los variados argumentos, no se permitir
 'que H valga menos de 26 unidades de redondeo en T. Los  lmites  prcticos
 'en el cambio del tamao de paso, son forzados a suavizar el proceso de se-
 'leccin de tamao y se preve una excesiva dificultad por discontinuidades.
 'Para evitar fallas innecesarias, el algoritmo usa una estimacin de tamao
 'de paso de 9/10. Despus, de un paso fallido, el tamao no se emplear pa-
 'ra incrementar el siguiente paso tentativo. Esto torna  al  procedimiento,
 'en general, ms efectivo y como una extrapolacin  local  ser  usada,  un
 'precaucin extra es factible.
 
  'Se verifica el nmero de evaluaciones de las derivadas. Si es  permisible,
  'se avanza en la solucin de T a T+H.
R200: IF NFE% <= MAXNFE% GOTO R220

  'Clculos excesivos
    IFLAG% = 4
    KFLAG% = 4
    EXIT SUB

  'Se prosigue en la aproximacin de la solucin sobre un paso de longitud H
R220: CALL FEHL(NEQN%, Y(), T, H, YP(), F1(), F2(), F3(), F4(), F5(), F1())
    NFE% = NFE% + 5

 'Clculo y prueba de las tolerancias disponibles versus la estimacin  del
 'error local y remocin del escalamiento de las tolerancias. Ntese que el
 'error relativo es medido con respecto a la magnitud promedio de la  solu-
 'cin al inicio y final de cada paso.
    EEOET = 0!
    FOR k% = 1 TO NEQN%
        ET = ABS(Y(k%)) + ABS(F1(k%)) + AE
        IF ET > 0! GOTO R240
        'Error de tolerancia inapropiado
          IFLAG% = 5
          EXIT SUB
R240:   EE = ABS((-2090! * YP(k%) + (21970! * F3(k%) - 15048! * F4(k%))) + (22528! * F2(k%) - 27360! * F5(k%)))
R250:   IF EEOET < (EE / ET) THEN EEOET = EE / ET
    NEXT
      ESTTOL = ABS(H) * EEOET * SCALE / 752400!
      IF ESTTOL <= 1! GOTO R260

  'Paso incontinuable. Se reduce el tamao, en un factor de 1/10, y se
  'reintenta
    HFAILD = 1
    OUTPUT1 = 0
    S = .1
    IF ESTTOL < 59049! THEN S = .9 / ESTTOL ^ .2
    H = S * H
    IF ABS(H) > HMIN GOTO R200

  'Demanda de error inalcanzable para el mnimo tamao de paso disponible
    IFLAG% = 6
    KFLAG% = 6
    EXIT SUB

  'Paso completamente cubierto. Se alamacena la solucin para T+H y se
  'evalan las derivadas.
R260: T = T + H
    FOR k% = 1 TO NEQN%
        Y(k%) = F1(k%)
    NEXT
    A = T
    CALL F(A, Y(), YP())
    NFE% = NFE% + 1

 'Se selecciona el siguiente tamao de paso. El incremento est restringido
 'por un factor de 5. Si en el paso existi una  falla,  no  incremntar el
 'siguiente tamao.
    S = 5!
    IF ESTTOL > 1.889568E-04 THEN S = .9 / ESTTOL ^ .2
    IF HFAILD = 1 THEN
       IF S < 1! THEN S = 1!
    END IF
    IF (S * ABS(H)) > HMIN THEN H1 = S * ABS(H) ELSE H1 = HMIN
    IF H >= 0! THEN H = -H1 ELSE H = H1

  'FIN DE LA SOLUCION CENTRAL PARA PASOS SIMPLES
   
    'Se contina con otro paso
    IF OUTPUT1 = 1 THEN GOTO R300
    IF IFLAG% > 0 GOTO R100
    'Solucin totalmente realizada
 
    'Modo de un-paso
    IFLAG% = -2
    EXIT SUB

    'Modo de intervalos
R300: T = TOUT
    IFLAG% = 2

END SUB

