 
  'Programa para Simular Pruebas de Decremento de Presin
  '(Creado por el Ing. Nstor Martnez y modificado por J. Antonio Ruiz)
  'Versin 1.0 (1993)
  
   DECLARE SUB apuntador (FIRST%, LAST%, DX%, Y%, FLAG1%)
   DECLARE SUB enrolla ()
   DECLARE SUB letreros (X%)
   DECLARE SUB marco (reni%, renf%, coli%, colf%, tipo%, ci%, cf%)
   DECLARE SUB opciones (archivo$)
   DECLARE SUB PWD (P#, PDS#, cde2s#)
   DECLARE SUB STFEST (T#, FA#, cde2s#)
  
   DEFDBL A-H, O-Z
   DIM TD#(300), PD#(300)
 
   'Proteccin contra errores durante la ejecucin del programa
   ON ERROR GOTO PROCERROR

   CLS
   VIEW PRINT
   LOCATE , , 0
  
   'Subrutina de pantalla inicial
   CALL enrolla
  
   'Subrutina para control de opciones
   CALL opciones(archivo$)
   
20 'Lectura de datos del archivo previamente abierto
   INPUT #1, Q, BO, FI, PERM, VISCO, CT, RW, H, S, PI, CD, NDTD
   cde2s# = CD * EXP(2! * S)
   CTDCD = .000264 * PERM / (VISCO * RW ^ 2 * FI * CT) / CD
   FOR I = 1 TO NDTD
	  INPUT #1, TD#(I): TD#(I) = TD#(I) * CTDCD
   NEXT
  
   'Se cierran los archivos abiertos
   CLOSE #1
  
   'Resultados
   LOCATE 1, 1: COLOR 15, 2: PRINT STRING$(80, 32);
   LOCATE 1, 31: PRINT "TIEMPO    PRESION"
   COLOR 15, 0
   FOR I = 1 TO NDTD
	  'Subrutina de la tcnica de Sthefest
	  CALL STFEST(TD#(I), PD#(I), cde2s#)
	  TR = TD#(I) / CTDCD
	  PR = PD#(I) * 141.2 * Q * VISCO * BO / (PERM * H): PR = PI - PR
	  PRINT TAB(25); : PRINT USING "   #####.##    #####.##"; TR; PR
   NEXT
  
   LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);
   COLOR 31
	 LOCATE 24, 20: PRINT " < Para continuar presione cualquier tecla > "
   COLOR 15, 0
   DO: LOOP WHILE INKEY$ = ""
	
   CLS
   VIEW PRINT
   'Subrutina para control de opciones
   CALL opciones(archivo$)
   GOTO 20
  
   'Subrutina para deteccin de errores
PROCERROR: SELECT CASE ERR
		    CASE 53: LOCATE 23, 30:  COLOR 31, 0: PRINT "NO EXISTE EL ARCHIVO"; : BEEP: LOCATE 23, 11, 0: COLOR 15, 4: PRINT STRING$(80, 32):
UU:                    LOCATE 24, 8
				   INPUT "TECLEE NOMBRE DE ARCHIVO-DATOS (SIN PUNTO NI EXTENSION)"; archivo$:
				   IF archivo$ = "" THEN BEEP: CONTAD = CONTAD + 1: IF CONTAD = 3 THEN GOTO UU
				   'Archivos de 8 caracteres
				   IF LEN(archivo$) > 8 THEN BEEP: GOTO UU
				   archivo$ = archivo$ + ".DTO"
				   COLOR 15, 0
				   RESUME
		 END SELECT
		 'Se cierran los archivos abiertos
		 CLOSE
		 'Regreso a modo texto
		 CLS : VIEW PRINT
		 CALL opciones(archivo$)
		 GOTO 20

DEFSNG A-H, O-Z
SUB apuntador (FIRST%, LAST%, DX%, Y%, FLAG1%)

 'Subprograma para control de seleccin de opciones en pantalla

   'ENTRADA:
	 'FIRST% = Valor mnimo o inicial de la coord. X del cursor (rengln),
			'el valor asciende de la parte sup. a la inferior del  moni-
			'tor.
	 ' LAST% = Valor mximo o final de la coord. X del  cursor  (rengln),
			'el valor se incrementa de la parte izq. a  la  derecha  del
			'monitor.
		 'NOTA: [LAST% - FIRST%] + 1 = nm. de alternativas de trabajo.
	 '   DX% = Valor que modifica la posicin inicial del cursor.
	 '    X% = Coord. X donde aparecera el cursor { FIRST% + DX% }
	 '    Y% = Coord. Y (ordenada o columna) donde aparecera el cursor.

   'SALIDA:
	 'FLAG1% = Valor nulo en la entrada y de la alternativa en la salida.

  '
 
	'Coordenada X del cursor
	  X% = FIRST% + DX%

	'Despliegue de barra de ayuda
	  LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);
	  LOCATE 24, 24: PRINT "USE LAS TECLAS < ,  > PARA MOVERSE": COLOR 15, 0
    
	'Se define visibilidad, tamao y posicin del cursor
	  LOCATE X%, Y%, 1, 0, 7
    
	'Se asigna el valor de una tecla a una variable alfanumrica
a10:   ANS$ = INKEY$
	  IF ANS$ = "" THEN GOTO a10
	 
	  'Se teclea la flecha de desplazamiento hacia bajo
	  IF ANS$ = CHR$(0) + CHR$(80) THEN
		'Nueva coordenada X (rengln)
		IF X% < LAST% THEN
		   'Incremento
		   X% = X% + 1
		ELSE
		   'Posicin inicial
		   X% = FIRST%
		END IF
	  END IF
  
	  'Se teclea la flecha de desplazamiento hacia arriba
	  IF ANS$ = CHR$(0) + CHR$(72) THEN
		'Nueva coordenada X (rengln)
		IF X% > FIRST% THEN
		   'Decremento
		   X% = X% - 1
		ELSE
		   'Posicin final
		   X% = LAST%
		END IF
	  END IF
    
	'Se invoca la subrutina de lectura de letreros para la barra de ayuda
	  CALL letreros(X%)
    
	'Se despliega el cursor en las coordenadas actuales
	  LOCATE X%, Y%
    
	'Si no se oprime < ENTER > se contina el proceso
	  IF ANS$ <> CHR$(13) THEN GOTO a10

	'Se asigna a la variable FLAG% el valor de la alternativa elegida en
	'funcin de su posicin
	  FLAG1% = CSRLIN
	  FLAG1% = FLAG1% - (FIRST% - 1)

	'Se redefine la visibilidad y el tamao del cursor
	  LOCATE , , 0, 5, 6

END SUB

SUB enrolla

  'Subrutina que despliega una cortina para presentacin de ttulos

   'Creacin de la cortina
	CLS
	VIEW PRINT
	COLOR 3, 1
	  FOR AR = 8 TO 70
		 FOR RA = 4 TO 21
			COLOR 7
			  LOCATE RA + 1, AR + 1: PRINT ""
			COLOR 3
			  LOCATE RA, AR: PRINT ""
	  NEXT RA, AR

   'Letreros
	COLOR 0, 3
	  LOCATE 7, 22: PRINT "T E C N I C A S    A V A N Z A D A S "
	  LOCATE 9, 25: PRINT "D E    P R O G R A M A C I O N"
	  LOCATE 13, 30: PRINT "C A P I T U L O   V I"
	  LOCATE 17, 26: PRINT "PROGRAMA PARA SIMULAR PRUEBAS"
	  LOCATE 18, 28: PRINT "DE DECREMENTO DE  PRESION"
	COLOR 31, 0
	  LOCATE 24, 60: PRINT "ESPERE POR FAVOR ..."
 
   'Pausa de 2.5 segundos
	SLEEP 2.5

END SUB

SUB letreros (X%)
  
 'Se invoca la subrutina de lectura de letreros para la barra de ayuda

 'Barra
 LOCATE 24, 1: COLOR 15, 2: PRINT STRING$(80, 32);
 
 SELECT CASE X%
	 CASE 11: LOCATE 24, 8: PRINT "LEE UN ARCHIVO (PREVIAMENTE CREADO) EN EL PATRON DE BUSQUEDA ACTUAL"
	 CASE 12: LOCATE 24, 15: PRINT "EJECUCION DEL METODO CON LOS DATOS DEL ARCHIVO ELEGIDO"
	 CASE 13: LOCATE 24, 29: PRINT "F I N    D E    S E S I O N"
 END SELECT

 COLOR 15, 0

END SUB

SUB marco (reni%, renf%, coli%, colf%, tipo%, ci%, cf%)

 'Subprograma que genera un marco

   'reni%, renf%-- Rengln inicial y final del recuadro
   'coli%, colf%-- Columna inicial y final del recuadro
   'tipo%       -- 1 para lnea sencilla, 2 para doble y 3 para semi-gruesa
   'ci%, cf%    -- Color inicial (recuadro) y final

   'Caractersticas del marco (tipo de lnea)
   SELECT CASE tipo%
		CASE 1
			'lnea sencilla
			esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
			lhi$ = "": eid$ = ""
		CASE 2
			'lnea doble
			esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
			lhi$ = "": eid$ = ""
		CASE 3
			'lnea semi-gruesa
			esi$ = "": lhs$ = "": lv$ = "": esd$ = "": eii$ = ""
			lhi$ = "": eid$ = ""
   END SELECT

   'Se despliega el recuadro
   COLOR ci%
	LOCATE reni%, coli%: PRINT esi$
	LOCATE reni%, colf%: PRINT esd$
	LOCATE reni%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhs$)
	FOR I% = reni% + 1 TO renf%
	    LOCATE I%, coli%: PRINT lv$
	    LOCATE I%, colf%: PRINT lv$
	NEXT I%
	LOCATE renf%, coli%: PRINT eii$
	LOCATE renf%, colf%: PRINT eid$
	LOCATE renf%, coli% + 1: PRINT STRING$(colf% - coli% - 1, lhi$)
   COLOR cf%

END SUB

SUB opciones (archivo$)

 'Subrutina que facilita una seleccin de alternativas con el cursor como
 'apuntador

  '-------------- Despliegue grfico de opciones maestras -------------------

p10: CLS
    LOCATE , , 0
    'Se invoca a la subrutina que genera un marco
	 CALL marco(9, 15, 21, 60, 3, 6, 15)
  
    COLOR 15, 6
	 LOCATE 9, 32:  PRINT " MENU PRINCIPAL "
    COLOR 15, 0
    LOCATE 11, 26: PRINT "_ Leer archivo de datos."
    LOCATE 12, 26: PRINT "_ Simular prueba de decremento."
    LOCATE 13, 26: PRINT "_ Trmino de la sesin."
  
    'Control de seleccin de opciones en pantalla
	 CALL apuntador(11, 13, 0, 26, FLAG1%)
	 SOUND 450, 4
  
    'Designacin de alternativa
	 ON FLAG1% GOSUB p20, p30, p40

p20: 'Opcin 1 (lectura de archivos)
	 CLS
	 CONTAD = 0
	 SHELL ("A:\")
	 SHELL ("CD \CAP6")
	 SHELL ("DIR/W *.DTO")
	 VIEW PRINT
U:    'Despliegue de barra de texto
	  LOCATE 23, 24: COLOR 15, 2: PRINT STRING$(80, 32);
	  LOCATE 24, 2: INPUT "Elija archivo de datos (sin punto ni extensin) "; archivo$
	  COLOR 15, 0
	  IF archivo$ = "" THEN BEEP: CONTAD = CONTAD + 1: IF CONTAD = 3 THEN GOTO p10 ELSE GOTO U
	  'Archivos de 8 caracteres
	  IF LEN(archivo$) > 8 THEN BEEP: GOTO U
	  archivo$ = UCASE$(archivo$) + ".DTO"
	  'Se abre archivo para lectura
	  OPEN archivo$ FOR INPUT AS #1
	 
	  GOTO p10

p30: 'Opcin 2 (efectuar anlisis de prueba de presin)
	 CLS
	  'Previamente debe elegirse un archivo
	  IF archivo$ = "" THEN BEEP:  GOTO p10
	  EXIT SUB
	  GOTO p10

p40: 'Opcin 3
	 CLS
	 'Se invoca a la subrutina que genera un marco
	  CALL marco(22, 24, 52, 70, 3, 22, 0)
	 
	  COLOR 31, 0
	    LOCATE 23, 54
	    PRINT " FIN DE SESION "
	  COLOR 15, 0
    
	  'Se redefinen las caractersticas del cursor
	   LOCATE , , 0
    
	  END

END SUB

SUB PWD (P#, PDS#, cde2s#)
 
  'Subrutina que vala la ecuacin diferencial de flujo radial
  PDS# = 1! / (P# * (P# + 1! / (LOG(2! / (1.78 * SQR(P# / (cde2s#)))))))

END SUB

SUB STFEST (T#, FA#, cde2s#) STATIC
 
  'Tcnica de Sthefest
  
   DIM FACT(50), V#(50), H#(25)
  
   IF ISWT = 1 THEN GOTO 14
  
   ISWT = 1: DLOGTW# = .693147180559945#
   N% = 8: NE2% = N% / 2
  
   FACT(1) = 1
  
   FOR I% = 2 TO N%
	  FACT(I%) = FACT(I% - 1) * I%
   NEXT I%
  
   H#(1) = 2! / FACT(NE2% - 1)
  
   FOR I% = 2 TO NE2%
	  FI = I%
	  IF I% < NE2% THEN H#(I%) = FI ^ NE2% * FACT(2 * I%) / (FACT(NE2% - I%) * FACT(I%) * FACT(I% - 1))
	  IF I% = NE2% THEN H#(I%) = FI ^ NE2% * FACT(2 * I%) / (FACT(I%) * FACT(I% - 1))
   NEXT I%
  
   SIGNO% = 2 * (NE2% - NE2% / 2 * 2) - 1

   FOR I% = 1 TO N%
	  V#(I%) = 0!
	  K1% = INT((I% + 1) / 2 + .45): K2% = I%
	  IF (K2% - NE2%) > 0 THEN K2% = NE2%
	  FOR K% = K1% TO K2%
		 IF (2 * K% - I%) <> 0 THEN
		    IF (I% - K%) <> 0 THEN V#(I%) = V#(I%) + H#(K%) / (FACT(I% - K%) * FACT(2 * K% - I%))
		    IF (I% - K%) = 0 THEN V#(I%) = V#(I%) + H#(K%) / FACT(2 * K% - I%)
		 ELSE
		    V#(I%) = V#(I%) + H#(K%) / FACT(I% - K%)
		 END IF
	  NEXT K%
	  V#(I%) = SIGNO% * V#(I%)
	  SIGNO% = -SIGNO%
   NEXT I%

14    FA# = 0!
	 A# = DLOGTW# / T#
	 FOR I% = 1 TO N%
		ARG# = I% * A#
		'Subrutina que vala la ecuacin diferencial de flujo radial
		CALL PWD(ARG#, RESP#, cde2s#)
		FA# = FA# + V#(I%) * RESP#
	 NEXT I%
	 FA# = A# * FA#

END SUB

